﻿Imports System.Data.OracleClient
Imports System.Data
Imports System.Data.OleDb
Imports CTI.Utilities.Log
Partial Class CrearOferta
    Inherits claseBase

    Private NOFE As String
    Private TIPOOFE As String
    Private EMPRESA As String
    Private GRUPO As String
    Private TIPVC As String
    Private _lineas As List(Of BCb2b.COferta_linOff)
    Private num_lineas_error_costo As Integer = 0

    Public ReadOnly Property PROP_N_OFE_SEL() As String
        Get
            Return Me.NOFE
        End Get
    End Property
    Public ReadOnly Property PROP_TIPO_OFE_SEL() As String
        Get
            Return Me.TIPOOFE
        End Get
    End Property
    Public ReadOnly Property PROP_EMPRESA() As String
        Get
            Return Me.EMPRESA
        End Get
    End Property
    Public ReadOnly Property PROP_GRUPO() As String
        Get
            Return Me.GRUPO
        End Get
    End Property
    Public ReadOnly Property PROP_TIPVC() As String
        Get
            Return Me.TIPVC
        End Get
    End Property

    Private Property lineas As List(Of BCb2b.COferta_linOff)
        Get
            Return _lineas
        End Get
        Set(value As List(Of BCb2b.COferta_linOff))
            _lineas = value
        End Set
    End Property


    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Function obtenerPlazo(ByVal ModificandoSN As String) As String
        Dim ag As New BCb2b.gvagente()
        Try
            If Session("agente") Is Nothing And Session("cliente") Is Nothing Then
                'TODO: Mandamos a expirado. habrá que hacer una función que compruebe si se ha ido la sesión.
                Server.Transfer("~/Expirado.aspx")
            Else
                If Not Session("agente") Is Nothing Then
                    ag = Session("agente")
                Else
                    Dim cli As New BCb2b.ggclipr()
                    cli = Session("cliente")
                    ag = New BCb2b.gvagente(cli.prop_GVAGENTE_COD, ConfigurationManager.AppSettings("grupo"), 0)
                End If

                Dim observacionPlazoAgente As New BCb2b.GGCLIPROBS(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("compra"), ag.prop_GGCLIPR_PROV, ConfigurationManager.AppSettings("OBPZ"))
                Return observacionPlazoAgente.PROP_COMENTARIO
            End If
        Catch ex As Exception
            Log.Error(ex, "[CrearOferta.obtenerPlazo]: agente = {agente}", ag.prop_COD)
            Return ex.Message.ToString()
        End Try
    End Function

    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Function obtenerSuRef(ByVal grupo As String, ByVal tip_vc As String, ByVal codigo_Art As String, ByVal COD_CLI As String, ByVal ModificandoSN As String) As String

        Try

            If (ModificandoSN = "S") Then
                Return "modificando!!!"
            Else

                Dim ggpreres As New BCb2b.GGPRERES(grupo, COD_CLI, codigo_Art)

                Return ggpreres.prop_SREFER

            End If
        Catch ex As Exception
            Log.Error(ex, "[CrearOferta.obtenerSuRef]: grup = {grup} ggclipr = {CLI} gaart = {Art}", grupo, COD_CLI, codigo_Art)
            Return ex.Message.ToString()
        End Try
    End Function
    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Function InsertarPrecioEspecial(ByVal grupo As String, ByVal empresa As String, ByVal tip_vc As String, ByVal ggofetip_cod As String, ByVal ggclipr_cod As String, ByVal gaart_cod As String, ByVal cantidad As String, ByVal precio As String, ByVal descuento As String, ByVal obser_prec_esp As String) As String
        Dim precio_esp_final As Double = 0
        Try
            cantidad = GestionaNumero(cantidad)
            precio = GestionaNumero(cantidad)
            descuento = GestionaNumero(descuento)

            If cantidad <> "" And precio <> "" And descuento <> "" Then
                'AMC_NE119.PRECIOS ESPECIALES
                '----------------------------------------------
                'INSERTAMOS PRECIO ESPECIAL
                Dim precioEspecial = New BCb2b.crearPrecioEspecial()
                precio_esp_final = FormatNumber((CDbl(precio) * CDbl(1)) - ((CDbl(precio) * CDbl(1)) * (CDbl(descuento) / 100)), 2)

                obser_prec_esp = ggofetip_cod.ToUpper & " " & obser_prec_esp & " " & precio_esp_final
                precioEspecial.crear_con_params(grupo, tip_vc, ggclipr_cod, gaart_cod, precio_esp_final, obser_prec_esp, ConfigurationManager.AppSettings("usuario"), ConfigurationManager.AppSettings("pass"), ConfigurationManager.AppSettings("bbdd"), ConfigurationManager.AppSettings("Oferta"))

                'FIN AMC_NE119. PRECIOS ESPECIALES
                '----------------------------------------------
            End If

            Return "0"
        Catch ex As Exception
            Log.Error(ex, "[CrearOferta.InsertarPrecioEspecial]: grup = {grupo} tip = {tip} cli = {cli} gaart = {gaart} precio = {precio} obser = {obser}", grupo, tip_vc, ggclipr_cod, gaart_cod, precio_esp_final, obser_prec_esp)
            Return "1"
        End Try
    End Function

    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Function Crear_su_ref(ByVal codigo_Art As String, ByVal COD_CLI As String, ByVal larefmodif As String) As String

        Try
            'cambiar su ref para ese cli y art
            Dim ggpreres As New BCb2b.GGPRERES()
            Dim codclinumber As New OracleNumber
            codclinumber = CType(COD_CLI, OracleNumber)
            ggpreres.actualizar_su_ref(ConfigurationManager.AppSettings("grupo"), codclinumber, codigo_Art, larefmodif)
            ggpreres.GGPRERES_INSERTAR(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), codclinumber, codigo_Art, larefmodif)
            Return ""
        Catch ex As Exception
            Log.Error(ex, "[CrearOferta.Crear_su_ref]: art = {art} cli = {cli} ref = {ref}", codigo_Art, COD_CLI, larefmodif)
            Return ex.Message.ToString()
        End Try
    End Function

    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Function Cambiar_su_ref(ByVal codigo_Art As String, ByVal COD_CLI As String, ByVal larefmodif As String) As String

        Try
            'cambiar su ref para ese cli y art
            Dim ggpreres As New BCb2b.GGPRERES()
            Dim codclinumber As New OracleNumber
            codclinumber = CType(COD_CLI, OracleNumber)
            ggpreres.actualizar_su_ref(ConfigurationManager.AppSettings("grupo"), codclinumber, codigo_Art, larefmodif)
            ggpreres.GGPRERES_INSERTAR(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), codclinumber, codigo_Art, larefmodif)
            Return ""
        Catch ex As Exception
            Log.Error(ex, "[CrearOferta.Cambiar_su_ref]: art = {art} cli = {cli} ref = {ref}", codigo_Art, COD_CLI, larefmodif)
            Return ex.Message.ToString()
        End Try
    End Function

    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Function Comprobar_su_ref(ByVal codigo_Art As String, ByVal COD_CLI As String, ByVal larefmodif As String) As String

        Try
            'cambiar su ref para ese cli y art
            Dim ggpreres As New BCb2b.GGPRERES()
            Dim codclinumber As New OracleNumber
            codclinumber = CType(COD_CLI, OracleNumber)

            Dim parametro_ref As String = "GGPRERES_" + ConfigurationManager.AppSettings("venta") + "_SREFER_UNICA"
            Dim PARAMETRO As New BCb2b.empparam(parametro_ref, GRUPO, EMPRESA, Session("USUARIOB2B").PROP_COD)
            Dim PARAM_REFER As String = PARAMETRO.prop_VALOR
            If (PARAM_REFER = "S") Then
                Dim mensaje As String = ""
                mensaje = ggpreres.GGPRERES_CONTROL_SREFER_UNICA(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), codclinumber, codigo_Art, larefmodif)
                If (mensaje = "") Then
                    Return "SI"
                Else
                    Return "NO"
                End If
            Else
                Return "NO"
            End If

        Catch ex As Exception
            Log.Error(ex, "[CrearOferta.Comprobar_su_ref]: art = {art} cli = {cli} ref = {ref}", codigo_Art, COD_CLI, larefmodif)
            Return ex.Message.ToString()
        End Try
    End Function
    <Ajax.AjaxMethod()> _
    Public Function ES_KIT(ByVal empgrupo_cod As String, ByVal gaart_cod As String) As Boolean
        Dim es As Boolean = False
        Try
            Dim estruc As New BCb2b.gaestru()
            es = estruc.ES_KIT(empgrupo_cod, gaart_cod)
        Catch ex As Exception
            Log.Error(ex, "[Ajax:CrearPedido.ES_KIT] grupo = {grupo} art = {art} ", empgrupo_cod, gaart_cod)
        End Try

        Return es
    End Function
    <Ajax.AjaxMethod()> _
    Public Function ES_KIT_SUSTITUCION(ByVal empgrupo_cod As String, ByVal gaart_cod As String) As Boolean
        Dim es As Boolean = False
        Try
            Dim estruc As New BCb2b.gaestru()
            es = estruc.ES_KIT_SUSTITUCION(empgrupo_cod, gaart_cod)
        Catch ex As Exception
            Log.Error(ex, "[Ajax:CrearPedido.ES_KIT_SUSTITUCION] grupo = {grupo} art = {art} ", empgrupo_cod, gaart_cod)
        End Try
        Return es
    End Function
    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Function guardar_observacion(ByVal vOBSER As String) As String
        'AQUI LLAMO AL A FUCNION QUE INSERTA O NO SEGÚN LO QUE TENGA QUE HACER.

        Dim PARAM_OBS As String = ""
        Try
            'modificar obser
            Dim PARAMETRO As New BCb2b.empparam(ConfigurationManager.AppSettings("CRM_GGOFETIP_OPO_OBS"), GRUPO, EMPRESA, Session("USUARIOB2B").PROP_COD)
            PARAM_OBS = PARAMETRO.prop_VALOR

            Dim ggOFEobs As New BCb2b.CObs_oferta(session("cabecera").prop_empgrupo_cod().ToString, session("cabecera").prop_emp_cod().ToString, session("cabecera").prop_tip_vc().ToString, session("cabecera").prop_GGOFETIP_COD().ToString, session("cabecera").prop_N_OFE().ToString, PARAM_OBS)
            ggOFEobs.MODIFICAR_OBS("", vOBSER)
            Return vOBSER
        Catch ex As Exception
            Log.Error(ex, "[CrearOferta.guardar_observacion]: grup = {grup} emp = {emp} tip = {tip} ggofetip = {ggofetip} ofe = {ofe} obs = {obs}", Session("cabecera").prop_empgrupo_cod().ToString, Session("cabecera").prop_emp_cod().ToString, Session("cabecera").prop_tip_vc().ToString, Session("cabecera").prop_GGOFETIP_COD().ToString, Session("cabecera").prop_N_OFE().ToString, PARAM_OBS)
            Return ex.Message.ToString()
        End Try
    End Function
    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Function obtenerCuc(ByVal grupo As String, ByVal empresa As String, ByVal tip_vc As String, ByVal codigo_Art As String) As String
        If grupo = "" Then
            grupo = ConfigurationManager.AppSettings("grupo")
        End If
        If empresa = "" Then
            empresa = ConfigurationManager.AppSettings("empresa")
        End If
        If tip_vc = "" Then
            tip_vc = ConfigurationManager.AppSettings("venta")
        End If

        Dim PRECIO_TARIFA_AUX As Double = 0
        Dim PARAM_TARIFA As New BCb2b.empparam()
        Try
            Dim PARAM_MARGEN_COSTE As New BCb2b.empparam("B2B_MARGEN_COSTE", grupo, empresa, Nothing)
            PARAM_TARIFA = New BCb2b.empparam("B2B_TARIFA_COSTE", grupo, empresa, Nothing)

            Dim ARTICULOAUX As New BCb2b.CArticulo(grupo, codigo_Art.ToUpper)
            Dim PRECIO_TARIFA As Double = ARTICULOAUX.calcula_precio_tarifa(PARAM_TARIFA.prop_VALOR, tip_vc)


            PRECIO_TARIFA_AUX = (PRECIO_TARIFA + (PRECIO_TARIFA * PARAM_MARGEN_COSTE.prop_VALOR) / 100)

            Return FormatNumber(PRECIO_TARIFA_AUX, 2).ToString
        Catch ex As Exception
            Log.Error(ex, "[CrearOferta.obtenerCuc]: grup = {grup} empr = {empr} tip = {tip} tarif = {tarif} prec = {prec}", grupo, empresa, tip_vc, PARAM_TARIFA.prop_VALOR, PRECIO_TARIFA_AUX)
            Return ex.Message.ToString()
        End Try
    End Function
    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Function GestionaNumero(ByVal numero As String, Optional ByVal v_cultura As String = "") As String
        Try
            If numero <> "" And IsNumeric(numero) Then
                If v_cultura <> "" Then
                    Dim cnum As New BCb2b.Utilities()
                    numero = cnum.ConvierteNumSegunCulture(numero, v_cultura)
                End If
            Else
                numero = ""
            End If
        Catch ex As Exception
            Log.Error(ex, "[CrearOferta.GestionaNumero]: nume = {nume} cultu = {cultu}", numero, v_cultura)
        End Try

        Return numero
    End Function
    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Function GestionaFecha(ByVal fecha As String) As String
        Try
            If fecha = "" Or IsDate(fecha) = False Then
                fecha = ""
            End If
        Catch ex As Exception
            Log.Error(ex, "[Ajax:CrearPedido.GestionaFecha] fec = {fec}", fecha)
        End Try

        Return fecha
    End Function
    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Function GESTION_DESCRIP_ART_TIRAS_ROLLOS(ByVal empgrupo_cod As String, ByVal vGAART_COD As String, ByVal vDESCRIP As String, ByVal vCANTIDAD As String) As String
        Dim anadir_a_descrip As String = ""
        Dim clasi1 As String = ""
        Dim clasi2 As String = ""
        Try
            'COMPROBAMOS PARAMETROS
            Dim param1 As String = "AMC_GV082_CLASIFICACION_ART"
            Dim param2 As String = "GGXXXLIN_GACLATIP_CLASIF_AUT"

            Dim dameparam As New BCb2b.CParametros()
            clasi1 = dameparam.dame_param(param1)
            clasi2 = dameparam.dame_param(param2)

            Dim valor1 As New BCb2b.gaartclasi(empgrupo_cod, vGAART_COD, clasi1)
            Dim valor2 As New BCb2b.gaartclasi(empgrupo_cod, vGAART_COD, clasi2)

            If valor1.prop_GACLASIF_COD = "S" Then
                Dim gacodbar As New BCb2b.gacodbar()
                Dim existe_gaart_en_gacodbar As Boolean = gacodbar.ExisteGaartEnGacodbarPorGacodtip(empgrupo_cod, vGAART_COD, ConfigurationManager.AppSettings("UNID"))
                Dim art As New BCb2b.gaart(empgrupo_cod, vGAART_COD)

                Dim ancho As New BCb2b.gaartclasi(empgrupo_cod, vGAART_COD, "ANCHO")
                Dim largo As New BCb2b.gaartclasi(empgrupo_cod, vGAART_COD, "LARGO")

                If valor2.prop_GACLASIF_COD = "S" And existe_gaart_en_gacodbar = False And art.prop_GAUNITIP_UNI1 = "UN" Then
                    anadir_a_descrip = "Metros Cuadrados = (" & ancho.prop_VALOR & " x " & largo.prop_VALOR & ") " & vCANTIDAD
                Else
                    anadir_a_descrip = "Metros Cuadrados"
                End If

            End If
        Catch ex As Exception
            Log.Error(ex, "[CrearOferta.GestionaNumero]: clas1 = {clas1} clas2 = {clas2} art = {art}", clasi1, clasi2, vGAART_COD)
        End Try


        If anadir_a_descrip = "" Then
            Return Trim(vDESCRIP)
        Else
            Return Trim(vDESCRIP & vbCrLf & anadir_a_descrip)
        End If

    End Function
    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Function Dame_Unidad_Gaart(ByVal grupo As String, ByVal gaart_cod As String) As String
        Dim valor As String = ""
        Try
            Dim ARTICULOAUX As New BCb2b.CArticulo(grupo, gaart_cod.ToUpper)
            valor = ARTICULOAUX.prop_gaunitip_uni1
        Catch ex As Exception
            Log.Error(ex, "[CrearOferta.Dame_Unidad_Gaart]: grup = {grup} gaart = {gaart}", grupo, gaart_cod)
        End Try

        Return valor
    End Function
    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Function ValidarPrecioLinea(ByVal gaart_cod As String, ByVal cod_cli As String, ByVal precio As String, ByVal cantidad As String, ByVal descuento As String, ByVal v_cultura As String) As String
        Dim conexionole As IDbConnection = conectar(ConfigurationManager.AppSettings("usuario"), ConfigurationManager.AppSettings("pass"), ConfigurationManager.AppSettings("bbdd"))
        Dim transaccion_valida_prec As IDbTransaction
        transaccion_valida_prec = conexionole.BeginTransaction

        Dim mensajeinfo As String = ""
        Dim mensajeerror As String = ""
        Dim ES_VALIDO As String = "N"

        Dim prec_aux As Double = 0

        precio = GestionaNumero(precio, v_cultura)
        descuento = GestionaNumero(descuento, v_cultura)

        If gaart_es_tira_o_rollo(ConfigurationManager.AppSettings("grupo"), gaart_cod) = "N" Then
            If descuento <> "" And precio <> "" Then

                prec_aux = precio - (precio * descuento / 100)

                Try
                    'TODO: JCE. no encuentra el metodo validar precio.
                    'ES_VALIDO = AMC_B2B_PKG.AMC_B2B_PKG.VALIDAR_PRECIO(transaccion_valida_prec, ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), cod_cli, gaart_cod, prec_aux, CDate(Now.ToShortDateString), mensajeinfo, mensajeerror)
                    transaccion_valida_prec.Commit()
                Catch ex As Exception
                    Log.Error(ex, "[CrearOferta.ValidarPrecioLinea]: cli = {cli} art = {art} prec = {prec} mensaje = {mensaje} ", cod_cli, gaart_cod, prec_aux, mensajeerror)
                    transaccion_valida_prec.Rollback()
                Finally
                    transaccion_valida_prec.Dispose()
                End Try

                Dim PARAM_TARIFA As New BCb2b.empparam(ConfigurationManager.AppSettings("PARAM_TARIFA_CUC"), ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("empresa"), Nothing)
                Dim ARTICULOAUX As New BCb2b.CArticulo(ConfigurationManager.AppSettings("grupo"), gaart_cod.ToUpper)
                Dim PRECIO_TARIFA As Double = ARTICULOAUX.calcula_precio_tarifa(PARAM_TARIFA.prop_VALOR, ConfigurationManager.AppSettings("venta"))

                If PRECIO_TARIFA = 0 Then
                    Return "#OK" 'permitimos pedidos precio 0
                End If

                If mensajeerror <> "" Then
                    Return mensajeerror
                Else
                    Return "#OK"
                End If
            Else
                Return "#OK"
            End If
        Else
            Return "#OK"
        End If
    End Function
    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Function Dame_TipoError_de_Error(ByVal cod_error As String) As String
        If cod_error.IndexOf("ERROR") <> -1 Then
            Return "#ERROR"
        ElseIf cod_error.IndexOf("WARNING") <> -1 Then
            Return "#WARNING"
        Else
            Return "#OK"
        End If
    End Function
    <Ajax.AjaxMethod()> _
    Public Function Obtener_Descrip_Error(ByVal cod_error As String, ByVal culture As String) As String
        Dim resultado As String = ""
        Try
            'ES NECESARIO HACER ESTO PORQUE SINO NO TRADUCE
            If (String.IsNullOrEmpty(culture)) Then
                culture = "Auto"
            End If
            Dim ci As New System.Globalization.CultureInfo(culture)
            ci.NumberFormat.CurrencyDecimalDigits = 3
            ci.NumberFormat.NumberGroupSeparator = ""
            ci.NumberFormat.NumberDecimalSeparator = ","
            System.Threading.Thread.CurrentThread.CurrentCulture = ci
            System.Threading.Thread.CurrentThread.CurrentUICulture = ci
            resultado = GetGlobalResourceObject("general", cod_error.Replace("#", "")) 'en los resources no deja poner #
            If resultado Is Nothing Then 'SI NO EXISTE EL CODIGO DE ERROR QUE LO MUESTRE PARA SABER QUE HAY QUE TRADUCIR
                resultado = cod_error
            End If
        Catch ex As Exception
            Log.Error(ex, "[CrearOferta.Obtener_Descrip_Error]: error = {error} cultu = {cultu}", cod_error, culture)
        End Try

        Return resultado
    End Function
    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Function CompruebaSiDatosValidos(ByVal CANTIDAD As String, ByVal PR_PRECIO As String, ByVal DESCUENTO As String, ByVal v_cultura As String) As Boolean
        CANTIDAD = GestionaNumero(CANTIDAD, v_cultura)
        PR_PRECIO = GestionaNumero(PR_PRECIO, v_cultura)
        DESCUENTO = GestionaNumero(DESCUENTO, v_cultura)

        Dim es_valido As Boolean = False
        If CANTIDAD <> "" And PR_PRECIO <> "" And DESCUENTO <> "" Then
            es_valido = True
        End If
        Return es_valido
    End Function
    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Function guardar_linea(ByVal empgrupoCod As String, ByVal EMCOD As String, ByVal vTIP_VC As String, ByVal vGGOFETIP_COD As String, ByVal vN_OFE As String, ByVal vN_LIN As String, ByVal vGAART_COD As String, ByVal vDESCRIP As String, ByVal COD_CLI As String, ByVal CANTIDAD As String, ByVal PR_PRECIO As String, ByVal DESCUENTO As String, ByVal vF_ENTRPREV As String, ByVal total As String, ByVal plazo As String, ByVal vgaunitip_uni1 As String, ByVal v_ancho As String, ByVal v_alto As String, ByVal v_tiras As String, ByVal v_rollos As String, ByVal v_m2 As String, ByVal v_equi_unpr As String, ByVal v_despercidio As String, ByVal tipo_error As String, ByVal mensajeInfo As String, ByVal v_cultura As String) As String
        Dim resultado As String = ""
        Dim ERRORCOSTE As Boolean = False
        Dim ATENCIONCOSTE As Boolean = False
        Dim vienedeofertaSN As Boolean = False
        Dim OBSERVACIONCOSTE As String = ""
        Try
            If CompruebaSiDatosValidos(CANTIDAD, PR_PRECIO, DESCUENTO, v_cultura) Then

                Dim es_tira_o_rollo As String = gaart_es_tira_o_rollo(empgrupoCod, vGAART_COD.ToUpper)

                'MIRAMOS EL MARGEN.
                Dim PARAM_MARGEN_COSTE As New BCb2b.empparam("B2B_MARGEN_COSTE", empgrupoCod, EMCOD, Nothing)
                Dim PARAM_TARIFA As New BCb2b.empparam("B2B_TARIFA_COSTE", empgrupoCod, EMCOD, Nothing)

                Dim ARTICULOAUX As New BCb2b.CArticulo(empgrupoCod, vGAART_COD.ToUpper)
                Dim PRECIO_TARIFA As Double = ARTICULOAUX.calcula_precio_tarifa(PARAM_TARIFA.prop_VALOR, vTIP_VC)

                Dim PRECIO_TARIFA_AUX As Double = 0
                PRECIO_TARIFA_AUX = (PRECIO_TARIFA + (PRECIO_TARIFA * PARAM_MARGEN_COSTE.prop_VALOR) / 100) * CANTIDAD

                Dim art_ESP As String = ConfigurationManager.AppSettings("COD_GAART_ESP")

                If (CDbl(total) < CDbl(PRECIO_TARIFA_AUX)) And es_tira_o_rollo = "N" And vGAART_COD.ToUpper <> art_ESP.ToUpper Then
                    'AMC_NE174
                    Select Case tipo_error
                        Case "#ERROR"
                            ERRORCOSTE = True 'MENOR QUE CUC Y QUE TARIF_ESTR
                        Case "#WARNING"
                            ATENCIONCOSTE = True 'MENOR QUE EL CUC PERO NO MENOR QUE TARIF_ESTR
                            OBSERVACIONCOSTE = mensajeInfo
                        Case "#OK"
                            OBSERVACIONCOSTE = ""
                    End Select
                End If

                resultado = tipo_error

                'SRA CLIENTE
                'Dim LINEAOFE As New BCb2b.COferta_linOff(empgrupoCod, EMCOD, vTIP_VC, vGGOFETIP_COD, vN_OFE, vN_LIN, vGAART_COD.ToUpper, vDESCRIP, CANTIDAD, PR_PRECIO, vF_ENTRPREV, Nothing, COD_CLI, DESCUENTO, plazo, vienedeofertaSN, ERRORCOSTE)
                Dim LINEAOFE As New BCb2b.COferta_linOff(empgrupoCod, EMCOD, vTIP_VC, vGGOFETIP_COD, vN_OFE, vN_LIN, vGAART_COD.ToUpper, vDESCRIP, CANTIDAD, PR_PRECIO, vF_ENTRPREV, vgaunitip_uni1, COD_CLI, DESCUENTO, plazo, vienedeofertaSN, ERRORCOSTE, ATENCIONCOSTE, v_ancho, v_alto, v_tiras, v_rollos, v_m2, v_equi_unpr, v_despercidio, OBSERVACIONCOSTE, v_cultura)

                Dim GAUNITP_UNI1 As String = ""
                Dim vGGOFECAB_GGCLIPR_COD As String = COD_CLI
                'jvc. aqui pongo la propiedad lineas para pasarselo al otro lado.

                Dim VCANTIDAD As String = CANTIDAD
                Dim list_LINEAS As New List(Of BCb2b.COferta_linOff)
                Try
                    list_LINEAS = Session("lineasOferta")
                Catch ex As Exception
                    Log.Error(ex, "[CrearOferta.obtenerlineas] lineas = {@lineas}", Session("lineasOferta"))
                End Try

                lineas = LINEAOFE.addLinea(list_LINEAS, LINEAOFE, ConfigurationManager.AppSettings("obstip_articulo_idiomas"), Session("idioma_spyro"))

                Session("lineasOferta") = lineas

                If resultado = "" Then
                    resultado = LINEAOFE.prop_N_LIN
                End If
            End If
        Catch ex As Exception
            Log.Error(ex, "[CrearOferta.guardar_linea]: grupo = {grupo} emp = {emp} tip = {tip} ofetip = {ofetip} ofe = {ofe} lin = {lin} art = {art} descr = {descr} cant = {cant} prec = {prec} f_entr = {f_entr} uni = {uni} cli = {cli} desc = {desc} plaz = {plaz} vienedeofeSN = {vienedeofeSN} costeerror = {costeerror} costeatenci = {costeatenci} ancho = {ancho} alto = {alto} tiras = {tiras} rollos = {rollos} m2 = {m2} equi_unpr = {equi_unpr} desper = {desper} costeobser = {costeobser}", empgrupoCod, EMCOD, vTIP_VC, vGGOFETIP_COD, vN_OFE, vN_LIN, vGAART_COD.ToUpper, vDESCRIP, CANTIDAD, PR_PRECIO, vF_ENTRPREV, vgaunitip_uni1, COD_CLI, DESCUENTO, plazo, vienedeofertaSN, ERRORCOSTE, ATENCIONCOSTE, v_ancho, v_alto, v_tiras, v_rollos, v_m2, v_equi_unpr, v_despercidio, OBSERVACIONCOSTE)
        End Try
        'fuerzo el return
        Return resultado

    End Function
    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Function obtener_precio_especial(ByVal empgrupoCod As String, ByVal EMCOD As String, ByVal vTIP_VC As String, ByVal cod_cli As String, ByVal vGAART_COD As String, ByVal CANTIDAD As String, ByVal v_cultura As String) As String
        Dim prec_especial As String = ""
        Try
            CANTIDAD = GestionaNumero(CANTIDAD, v_cultura)

            If vGAART_COD <> ConfigurationManager.AppSettings("COD_GAART_ESP") And CANTIDAD <> "" Then
                Dim precioEspecial As New BCb2b.crearPrecioEspecial()

                Dim valor As String = precioEspecial.damePrecEspecial(empgrupoCod, vTIP_VC, cod_cli, vGAART_COD, CANTIDAD)
                If valor <> "" Then
                    prec_especial = FormatNumber(valor, 2)
                Else
                    prec_especial = ""
                End If
            Else
                prec_especial = ""
            End If
        Catch ex As Exception
            Log.Error(ex, "[CrearOferta.obtener_precio_especial]:  grupo = {grupo} tip = {tip} cli = {cli} art = {art} cant = {cant} ", empgrupoCod, vTIP_VC, cod_cli, vGAART_COD, CANTIDAD)
            prec_especial = ""
        End Try

        Return prec_especial
    End Function
    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Function gaart_es_tira_o_rollo(ByVal empgrupoCod As String, ByVal vGAART_COD As String) As String
        Dim es_tira_o_rollo As String = "N"
        Dim clasi_tira As String = ConfigurationManager.AppSettings("CLASI_TIRAS_ROLLOS")
        Try
            Dim clasi As New BCb2b.gaartclasi(empgrupoCod, vGAART_COD, clasi_tira)
            es_tira_o_rollo = clasi.prop_GACLASIF_COD

            If es_tira_o_rollo = "" Then
                es_tira_o_rollo = "N"
            End If

            '---ESTO COMENTAR CUANDO SUBAMOS A REAL, ES PARA QUE NO SALTE LA PANTALLA DE TIRAS
            'es_tira_o_rollo = "N"
            '---FIN ESTO COMENTAR CUANDO SUBAMOS A REAL
        Catch ex As Exception
            Log.Error(ex, "[CrearOferta.gaart_es_tira_o_rollo]: grupo = {grupo} art = {art} tira = {tira} ", empgrupoCod, vGAART_COD, clasi_tira)
        End Try


        Return es_tira_o_rollo

    End Function
    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Sub borrar_linea(ByVal empgrupoCod As String, ByVal EMCOD As String, ByVal vTIP_VC As String, ByVal vGGOFETIP_COD As String, ByVal vN_OFE As String, ByVal vN_LIN As String, ByVal vGAART_COD As String, ByVal vDESCRIP As String, ByVal COD_CLI As String, ByVal CANTIDAD As String, ByVal PR_PRECIO As String, ByVal DESCUENTO As String, ByVal vF_ENTRPREV As String, ByVal total As String)
        Dim list_LINEAS As New List(Of BCb2b.COferta_linOff)
        Dim LINEAOFE As New BCb2b.COferta_linOff()
        Try
            If Not Session("lineasOferta") Is Nothing Then
                list_LINEAS = Session("lineasOferta")
            End If

            Dim vienedeofertaSN As Boolean = False 'revisar esto!!!!JVC!!!
            Dim ERRORCOSTE As Boolean

            Dim plazo As String = "en borrar línea"

            'ESTO ES PARA QUE NO DE ERROR AL BORRAR LA LINEA, PORQUE HAN METIDO EL CODIGO DEL ARTICULO PERO NO LA CANTIDAD.
            If CANTIDAD = "" Then
                CANTIDAD = "0"
            End If
            If PR_PRECIO = "" Then
                PR_PRECIO = "0"
            End If
            If DESCUENTO = "" Then
                DESCUENTO = "0"
            End If

            LINEAOFE = New BCb2b.COferta_linOff(ConfigurationManager.AppSettings("Grupo"), ConfigurationManager.AppSettings("Empresa"), ConfigurationManager.AppSettings("Venta"), vGGOFETIP_COD, vN_OFE, vN_LIN, vGAART_COD.ToUpper, vDESCRIP, CANTIDAD, "", PR_PRECIO, vF_ENTRPREV, Nothing, COD_CLI, DESCUENTO, plazo, vienedeofertaSN, ERRORCOSTE)
            lineas = LINEAOFE.delLinea(list_LINEAS, LINEAOFE)

            Session("lineasOferta") = lineas
        Catch ex As Exception
            Log.Error(ex, "[CrearOferta.borrar_linea]:  list_lineas = {@list_lineas} lineaofe = {@lineaofe} ", list_LINEAS, LINEAOFE)
        End Try
    End Sub
    <Ajax.AjaxMethod()> _
    Public Function Obtener_Precio_UnPr(ByVal precio As String, ByVal cantidad As String, ByVal equi_unpr As String, ByVal v_culture As String) As String
        Dim resultado As String = ""
        Try
            cantidad = GestionaNumero(cantidad, v_culture)
            precio = GestionaNumero(precio, v_culture)
            equi_unpr = GestionaNumero(equi_unpr, v_culture)

            If cantidad <> "" And precio <> "" And equi_unpr <> "" Then
                resultado = FormatNumber(CDbl(precio) * CDbl(cantidad) * CDbl(equi_unpr), 2)
            End If

        Catch ex As Exception
            Log.Error(ex, "[CrearOferta.Obtener_Precio_UnPr]: cant = {cant} idioma = {idioma} prec = {prec} ", cantidad, v_culture, precio)
        End Try

        Return resultado
    End Function
    <Ajax.AjaxMethod()> _
    Public Function Obtener_precios(ByVal cod_Art As String, ByVal COD_CLI As String, ByVal CANTIDAD As String, ByVal v_cultura As String) As String
       ' Teniendo un código artículo, al cambiar la cantidad cargo 
        ' precios y descuentos del artículo para esa cantidad.
        If (String.IsNullOrEmpty(cod_Art)) Then
            Return ""
        End If

        Dim cliente As New BCb2b.CUsuarios()
        Try
            cod_Art = cod_Art.ToUpper
            cliente.CrearUsuario(COD_CLI)

            Dim articulo_prueba As New BCb2b.CArticulo(ConfigurationManager.AppSettings("grupo"), cod_Art)

            CANTIDAD = GestionaNumero(CANTIDAD, v_cultura)

            If CANTIDAD <> "" Then
                Return articulo_prueba.calcula_precio_b2b(cliente, CDbl(CANTIDAD))
            End If

            Return ""
        Catch ex As Exception
            Log.Error(ex, "[Ajax:CrearOferta.Obtener_precios] cli = {@cli} cant = {cant} ", cliente, CANTIDAD)
            Return ""
        End Try
    End Function
    <Ajax.AjaxMethod()> _
    Public Function Obtener_descuento(ByVal cod_Art As String, ByVal cod_cli As String, ByVal cantidad As String, ByVal v_cultura As String) As String
        ' Teniendo un código artículo, al cambiar la cantidad cargo 
        ' precios y descuentos del artículo para esa cantidad.
        If (String.IsNullOrEmpty(cod_Art)) Then
            Return ""
        End If

        If (String.IsNullOrEmpty(cantidad)) Then
            Return FormatNumber("0", 2)
        End If

        Dim DTO As String = ""
        Dim cliente As New BCb2b.CUsuarios()
        Try
            cantidad = GestionaNumero(cantidad, v_cultura)

            If cantidad <> "" Then
                cod_Art = cod_Art.ToUpper
                cliente.CrearUsuario(cod_cli)
                Dim articulo_prueba As New BCb2b.CArticulo(ConfigurationManager.AppSettings("grupo"), cod_Art)

                Return articulo_prueba.dame_porcentaje_dto_b2b(cliente, CDbl(cantidad), Nothing, Nothing)
            End If

            Return ""
        Catch ex As Exception
            Log.Error(ex, "[Ajax:CrearOferta.Obtener_descuento] cli = {@cli} cant = {cant} ", cliente, cantidad)
            Return ""
        End Try
    End Function
    <Ajax.AjaxMethod()> _
    Public Function calcular_total_NP(ByVal cantidad As String, ByVal precio As String, ByVal descuento As String, ByVal v_cultura As String) As String
        ' Teniendo un código artículo y una cantidad. Al cambiar el precio
        ' recalculo el total (No hace falta query contra la bd)

        If (descuento = "") Then
            descuento = FormatNumber("0", 2)
        End If

        cantidad = GestionaNumero(cantidad, v_cultura)
        precio = GestionaNumero(precio, v_cultura)
        descuento = GestionaNumero(descuento, v_cultura)

        If (cantidad <> "" And precio <> "" And descuento <> "") Then
            Dim total As String = ""
            Try
                total = FormatNumber((precio * cantidad) - ((precio * cantidad) * (descuento / 100)), 2)
            Catch ex As Exception
                Log.Error(ex, "[Ajax:CrearOferta.calcular_total_NP] prec = {prec} cant = {cant} desc = {desc} idioma = {idioma} ", precio, cantidad, descuento, v_cultura)
            End Try

            Return total
        Else
            Return FormatNumber("0", 2)
        End If
    End Function
    <Ajax.AjaxMethod()> _
    Public Function calcular_total_ND(ByVal cantidad As String, ByVal precio As String, ByVal descuento As String, ByVal v_cultura As String) As String
        ' Teniendo un código artículo, una cantidad y un precio.
        ' Al cargar el descuento recalculo el total. (No hace falta query contra bd)
        If (descuento = "") Then
            descuento = FormatNumber("0", 2)
        End If

        cantidad = GestionaNumero(cantidad, v_cultura)
        precio = GestionaNumero(precio, v_cultura)
        descuento = GestionaNumero(descuento, v_cultura)

        If (cantidad <> "" And precio <> "" And descuento <> "") Then
            Dim precio_aux As String = ""
            Try
                precio_aux = (precio * cantidad) - ((precio * cantidad) * (descuento / 100))
            Catch ex As Exception
                Log.Error(ex, "[CrearOferta.calcular_total_ND] cant = {cant} prec = {prec} desc = {desc} idioma = {idioma} ", cantidad, precio, descuento, v_cultura)
            End Try

            'precio_aux = Replace(precio_aux, ",", ".")
            Return FormatNumber(precio_aux, 2)

        Else
            Return FormatNumber("0", 2)
        End If
    End Function


    <Ajax.AjaxMethod()> _
    Public Function Obtener_DescripArt(ByVal cod_Art As String) As String
        cod_Art = cod_Art.ToUpper
        If (cod_Art <> "") Then
            Try
                Dim articulo_prueba As New BCb2b.CArticulo(ConfigurationManager.AppSettings("grupo"), cod_Art)
                If articulo_prueba.prop_cod <> "" Then
                    If (articulo_prueba.prop_descrip <> "Null") Then
                        Return articulo_prueba.prop_descrip
                    Else
                        Return " "
                    End If
                Else
                    Return "Invalid article"
                End If

            Catch ex As Exception
                Log.Error(ex, "[CrearOferta.Obtener_DescripArt] art = {art} ", cod_Art)
                Return "Invalid article"
            End Try
        Else
            Return " "
        End If

    End Function

    <Ajax.AjaxMethod()> _
    Public Function Obtener_CodigoArtRef(ByVal cod_cli As String, ByVal cod_Ref As String) As String
        'cod_Ref = cod_Ref.ToUpper

        'en v_codigo_idioma nos llega la cultura. tenemos que obtener el idiomas.
        Dim idioma As New BCb2b.idiomas()
        If (cod_Ref <> "") Then
            Try
                Dim articulo_ref As New BCb2b.CArticulo()
                Dim cod_art As String = articulo_ref.articulo_con_ref(cod_cli, cod_Ref)
                'If (cod_art <> "") Then
                '    Dim articulo_de_ref As New BCb2b.CArticulo(cod_art)
                'Else : Return "NO"
                'End If
                Return cod_art

            Catch ex As Exception
                Log.Error(ex, "[CrearOferta.Obtener_CodigoArtRef]: cli = {cli} ref = {ref} ", cod_cli, cod_Ref)

                Return "Invalid article"
            End Try
        Else
            Return ""
        End If

    End Function

    <Ajax.AjaxMethod()> _
    Public Function Obtener_DescripArtIdioma(ByVal cod_Art As String, ByVal vggobstip_cod As String, ByVal vcodigo_idioma As String) As String
        cod_Art = cod_Art.ToUpper

        'NO PERMITIMOS INTRODUCIR EL ARTICULO PARA COMISIONES.
        Dim param As New BCb2b.CParametros()
        If cod_Art = param.dame_param("B2B_ART_COMI_AGENTES") Then
            Return "Invalid article"
        Else

            'en v_codigo_idioma nos llega la cultura. tenemos que obtener el idiomas.
            Dim idioma As New BCb2b.idiomas()
            idioma.dameIdioma(vcodigo_idioma)
            If (cod_Art <> "") Then
                Try
                    Dim articulo_prueba As New BCb2b.CArticulo(ConfigurationManager.AppSettings("grupo"), cod_Art.ToUpper)
                    Dim dd As String = articulo_prueba.descripcion_idiomas(vggobstip_cod, idioma.prop_idioma, ConfigurationManager.AppSettings("ING_SPYRO"))
                    If dd <> "" Then
                        If (dd <> "Null") Then
                            Return dd
                        Else
                            Return articulo_prueba.prop_descrip
                        End If
                    Else
                        Return "Invalid article"
                    End If

                Catch ex As Exception
                    Log.Error(ex, "[CrearOferta.Obtener_DescripArtIdioma]: art = {art} cod_obs = {cod_obs} idi = {idi} ", cod_Art, vggobstip_cod, idioma.prop_idioma)
                    Return "Invalid article"
                End Try
            Else
                Return ""
            End If
        End If

    End Function

    <Ajax.AjaxMethod()> _
    Public Function usuarioValido(ByVal usrnom As String, ByVal usrpass As String, ByVal Sesion_usuario As String) As String
        Dim Usuario As New BCb2b.CUsuarios(usrnom, _
                                           usrpass, _
                                           ConfigurationManager.AppSettings("grupo"), _
                                           ConfigurationManager.AppSettings("Venta"), _
                                           ConfigurationManager.AppSettings("usrnom"), _
                                           ConfigurationManager.AppSettings("usrpass"))
        If Not Usuario.es_vacio() Then
            If (Usuario.prop_LOGIN.CompareTo(Sesion_usuario) = 0) Then
                'If (Usuario.prop_LOGIN.CompareTo("CELMA") = 0) Then

                Return "S"
            Else
                Return "N"
            End If
        Else
            Return "N"
        End If
        Return "S"

    End Function

    ''NUEVA MANERA DE MOSTRAR LAS LOV DE LOS ARTICULOS(JQUERY)
    'Public Shared Sub OpenPopUpModal(ByVal opener As System.Web.UI.WebControls.WebControl, ByVal Url As String, ByVal claseboton As String, ByVal idcontainer As String, ByVal textbox As String, ByVal textbox2 As String, ByVal c1 As String, ByVal textbox3 As String, ByVal tituloModal As String, ByVal width As Integer, ByVal height As Integer)
    '    Dim clientScript As String
    '    clientScript = "javascript:CrearLovAUrl('" & Url & "','" & claseboton & "','" & idcontainer & "','" & textbox & "','" & textbox2 & "','" & c1 & "','" & textbox3 & "','" & tituloModal & "','" & width & "','" & height & "');return false;"
    '    opener.Attributes.Add("onClick", clientScript)
    'End Sub
    'Public Shared Sub ShowLupaArticuloModal(ByVal opener As System.Web.UI.WebControls.WebControl, ByVal artControl As System.Web.UI.WebControls.TextBox, ByVal textbusqueda As String, ByVal lblDescripART As System.Web.UI.WebControls.TextBox, ByVal art_cantControl As System.Web.UI.WebControls.TextBox, ByVal tituloModal As String)
    '    'OpenPopUp(opener, "lov_articulos.aspx?textbox=" & artControl.ClientID & "&textbox2=" & art_desControl.ClientID & "&textbox3=" & art_cantControl.ClientID, "LOV", 400, 450)
    '    OpenPopUpModal(opener, "lov_articulos_jquery.aspx", ".inputLovImage", "#container2", lblDescripART.ClientID, artControl.ClientID, textbusqueda, art_cantControl.ClientID, tituloModal, 560, 600)
    'End Sub
    'ANTERIOR MANERA DE MOSTRAR LAS LOV DE LOS ARTICULOS
    Public Shared Sub OpenPopUp(ByVal opener As System.Web.UI.WebControls.WebControl, ByVal PagePath As String, ByVal windowName As String, ByVal width As Integer, ByVal height As Integer)
        Dim clientScript As String
        Dim windowAttribs As String
        windowAttribs = "width=" & width & "px," & _
                    "height=" & height & "px," & _
                    "left='+((screen.width -" & width & ") / 2)+'," & _
                    "top='+ (screen.height - " & height & ") / 2+'"
        clientScript = "window.open('" & PagePath & "','" & windowName & "','" & windowAttribs & "');return false;"
        opener.Attributes.Add("onClick", clientScript)
    End Sub
    Public Shared Sub ShowLupaArticulo(ByVal opener As System.Web.UI.WebControls.WebControl, ByVal artControl As System.Web.UI.WebControls.TextBox, ByVal lblDescripART As System.Web.UI.WebControls.Label, ByVal art_cantControl As System.Web.UI.WebControls.TextBox)
        'OpenPopUp(opener, "lov_articulos.aspx?textbox=" & artControl.ClientID & "&textbox2=" & art_desControl.ClientID & "&textbox3=" & art_cantControl.ClientID, "LOV", 400, 450)
        OpenPopUp(opener, "lov_articulos.aspx?textbox=" & artControl.ClientID & "&textbox2=" & lblDescripART.ClientID & "&textbox3=" & art_cantControl.ClientID, "LOV", 410, 630)
    End Sub
    Public Shared Sub ShowLupaArticulo(ByVal opener As System.Web.UI.WebControls.WebControl, ByVal artControl As System.Web.UI.WebControls.TextBox, ByVal lblDescripART As System.Web.UI.WebControls.TextBox, ByVal art_cantControl As System.Web.UI.WebControls.TextBox)
        'OpenPopUp(opener, "lov_articulos.aspx?textbox=" & artControl.ClientID & "&textbox2=" & art_desControl.ClientID & "&textbox3=" & art_cantControl.ClientID, "LOV", 400, 450)
        OpenPopUp(opener, "lov_articulos.aspx?textbox=" & artControl.ClientID & "&textbox2=" & lblDescripART.ClientID & "&textbox3=" & art_cantControl.ClientID, "LOV", 410, 630)
    End Sub

    Public Shared Sub ShowLupaSuRef(ByVal opener As System.Web.UI.WebControls.WebControl, ByVal artControl As System.Web.UI.WebControls.TextBox, ByVal lblDescripART As System.Web.UI.WebControls.TextBox, ByVal surefControl As System.Web.UI.WebControls.TextBox, ByVal art_cantControl As System.Web.UI.WebControls.TextBox)
        'OpenPopUp(opener, "lov_articulos.aspx?textbox=" & artControl.ClientID & "&textbox2=" & art_desControl.ClientID & "&textbox3=" & art_cantControl.ClientID, "LOV", 400, 450)
        OpenPopUp(opener, "lov_su_ref.aspx?textbox=" & artControl.ClientID & "&textbox2=" & lblDescripART.ClientID & "&textbox3=" & surefControl.ClientID & "&textbox4=" & art_cantControl.ClientID, "LOV", 410, 630)
    End Sub

    Protected Sub BulkEditGridView1_RowDataBound(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewRowEventArgs) Handles BulkEditGridView1.RowDataBound

        If (e.Row.RowType = DataControlRowType.DataRow) Then

            Dim cabecera As New BCb2b.COferta_Cab()
            cabecera = Session("cabecera")

            Dim cargas As Boolean = False


            Dim tboxCodigoArt As TextBox
            Dim tboxSuRef As TextBox
            Dim tboxDescripART As TextBox
            Dim tboxGaartCod As TextBox
            Dim lblborrar As IButtonControl
            Dim lblf_disponible As Label
            Dim lblDisponibilidad As Label
            Dim lblGaartCod As Label
            Dim lblSuRef As Label
            Dim lblprecio_teorico As Label

            Dim lblDescripART As System.Web.UI.WebControls.Label

            Dim ibLupaArt As ImageButton
            Dim ibLupaSuRef As ImageButton
            Dim imgBorrar As Image
            'Dim imgBorrar2 As ImageButton

            tboxCodigoArt = e.Row.FindControl("tboxGaartCod")
            tboxSuRef = e.Row.FindControl("tboxSuRef")
            tboxDescripART = e.Row.FindControl("descrip_art")
            lblDescripART = e.Row.FindControl("lbldescrip_art")
            lblf_disponible = e.Row.FindControl("lblf_disponible")
            lblDisponibilidad = e.Row.FindControl("lblDisponibilidad")
            tboxGaartCod = e.Row.FindControl("tboxGaartCod")
            lblGaartCod = e.Row.FindControl("lblGaartCod")
            lblSuRef = e.Row.FindControl("lblSuRef")
            lblprecio_teorico = e.Row.FindControl("lblprecio_teorico")

            Dim lblPrecio As Label
            Dim lblDescuento As Label
            Dim lbltotal As Label
            Dim Unidad As Label
            ' Dim lblModif As Label

            Dim lblModif As HiddenField
            Dim HfModificado As New HiddenField
            Dim lblNLin As New Label
            Dim HFLINEA As HiddenField


            Dim tbox_precio As TextBox
            Dim tbox_dto As TextBox

            'plazo.
            Dim tboxPlazo As TextBox

            tboxPlazo = e.Row.FindControl("plazo")
            lblPrecio = e.Row.FindControl("lblPrecio")
            tbox_precio = e.Row.FindControl("tbox_precio")

            lblDescuento = e.Row.FindControl("lbldto")
            tbox_dto = e.Row.FindControl("tbox_dto")


            lbltotal = e.Row.FindControl("lblPrecio_final")

            ibLupaArt = e.Row.FindControl("IBarticulo")
            ibLupaSuRef = e.Row.FindControl("IBsuref")
            imgBorrar = e.Row.FindControl("imgBorrar")
            'imgBorrar2 = e.Row.FindControl("imgBorrar2")

            lblborrar = e.Row.FindControl("lbBorrar")

            'lblModif = e.Row.FindControl("lblModificado")

            lblModif = e.Row.FindControl("HfModificado")

            HFLINEA = e.Row.FindControl("HFLINEA")
            Unidad = e.Row.FindControl("lblUnidad")
            Dim lblAncho As Label
            Dim lblLargo As Label
            Dim lblTiras As Label
            Dim lblRollos As Label
            Dim lblM2 As Label
            Dim lblEquiUnPr As Label
            Dim lblDesperdicio As Label

            lblAncho = e.Row.FindControl("lblAncho")
            lblLargo = e.Row.FindControl("lblLargo")
            lblTiras = e.Row.FindControl("lblTiras")
            lblRollos = e.Row.FindControl("lblRollos")
            lblM2 = e.Row.FindControl("lblM2")
            lblEquiUnPr = e.Row.FindControl("lblEquiUnPr")
            lblDesperdicio = e.Row.FindControl("lblDesperdicio")

            Dim imgEditTirasRollos As Image
            imgEditTirasRollos = e.Row.FindControl("imgEditTirasRollos")

            'Datos del artículo:
            Dim EMPRESAGRUPO As String = ConfigurationManager.AppSettings("Grupo")
            Dim clasifCargas As String = ConfigurationManager.AppSettings("KZ")
            Dim obstip_articulo_idiomas As String = ConfigurationManager.AppSettings("obstip_articulo_idiomas")
            Dim IDIOMA As String = Session("idioma")
            '  Dim cargamax As String = ConfigurationManager.AppSettings("ggclatip_carga_max")


            Dim p_com As String = ConfigurationManager.AppSettings("obstip_articulo_idiomas")



            'OBTENER DESCRIP DE LA LINEA POR SI HA SIDO MODIFICADA
            If (Not tboxCodigoArt.Text = "") Then
                'JVC. AMC.
                'Dim ggofelin As New BCb2b.COferta_linOff(session("cabecera").prop_empgrupo_cod(), session("cabecera").prop_emp_cod(), session("cabecera").prop_tip_vc(), session("cabecera").prop_GGOFETIP_COD(), session("cabecera").prop_N_OFE(), HFLINEA.Value)
                'tboxDescripART.Text = ggofelin.prop_DESCRIP
                'lblDescripART.Text = ggofelin.prop_DESCRIP
            End If


            Dim TIPO_USUARIO As String = Session("tipo_usuario")

            'fin datos del artículo
            'PONEMOS AJAX 
            tboxCodigoArt.Attributes.Add("onKeyPress", "javascript: return disableEnterKey(event);")
            Dim tbox_cantidad As TextBox
            tbox_cantidad = e.Row.FindControl("tbox_cantidad")
            tbox_cantidad.Attributes.Add("onKeyPress", "javascript: return disableEnterKey(event);")
            Dim codigoCliente As Int32 = Session("cliente").prop_cod

            Dim EMPRESA As String
            If Session("EMPRESA") Is Nothing Then
                Session("EMPRESA") = New BCb2b.Cempresa(ConfigurationManager.AppSettings("EMPRESA"))
            End If
            EMPRESA = Session("EMPRESA").PROP_COD



            'tboxCodigoArt.Attributes.Add("onBlur", "javascript:cambia_codigo_art('" + codigoCliente.ToString() + "','" + tboxCodigoArt.ClientID + "', '" + tboxDescripART.ClientID + "','" + ConfigurationManager.AppSettings("obstip_articulo_idiomas") + "','" + Session("idioma") + "','" + tbox_cantidad.ClientID + "','" + lblPrecio.ClientID + "','" + tbox_precio.ClientID + "','" + lblDescuento.ClientID + "','" + tbox_dto.ClientID + "','" + lbltotal.ClientID + "','" + TIPO_USUARIO + "')")
            'tboxCodigoArt.Attributes.Add("onchange", "javascript:cambia_codigo_art('" + codigoCliente.ToString() + "','" + tboxCodigoArt.ClientID + "', '" + lblDescripART.ClientID + "','" + ConfigurationManager.AppSettings("obstip_articulo_idiomas") + "','" + Session("idioma") + "','" + tbox_cantidad.ClientID + "','" + lblPrecio.ClientID + "','" + tbox_precio.ClientID + "','" + lblDescuento.ClientID + "','" + tbox_dto.ClientID + "','" + lbltotal.ClientID + "','" + TIPO_USUARIO + "')")

            tboxCodigoArt.Attributes.Add("onchange", "javascript:cambia_codigo_art('" & HFLINEA.ClientID & "','" + codigoCliente.ToString() + "','" + tboxCodigoArt.ClientID + "', '" + tboxDescripART.ClientID + "','" + ConfigurationManager.AppSettings("obstip_articulo_idiomas") + "','" + Session("idioma") + "','" + tbox_cantidad.ClientID + "','" + lblPrecio.ClientID + "','" + tbox_precio.ClientID + "','" + lblDescuento.ClientID + "','" + tbox_dto.ClientID + "','" + tboxSuRef.ClientID + "','" + lbltotal.ClientID + "','" + TIPO_USUARIO + "','" + lblModif.ClientID + "','" & GetLocalResourceObject("ArticuloNoExiste") & "','" + lblprecio_teorico.ClientID + "','" & EMPRESAGRUPO & "','" & EMPRESA & "','" & ConfigurationManager.AppSettings("venta") & "','" & Unidad.ClientID & "','" & lblAncho.ClientID & "','" & lblLargo.ClientID & "','" & lblTiras.ClientID & "','" & lblRollos.ClientID & "','" & lblM2.ClientID & "','" & lblEquiUnPr.ClientID & "','" & lblDesperdicio.ClientID & "','" & imgEditTirasRollos.ClientID & "','" & imgEditTirasRollos.ClientID & "')")

            ShowLupaArticulo(ibLupaArt, tboxCodigoArt, tboxDescripART, tbox_cantidad)
            'ShowLupaArticuloModal(ibLupaArt, tboxCodigoArt, tboxCodigoArt.Text, tboxDescripART, tbox_cantidad, GetLocalResourceObject("ListaValoresText"))

            'su ref
            ShowLupaSuRef(ibLupaSuRef, tboxCodigoArt, tboxDescripART, tboxSuRef, tbox_cantidad)

            imgEditTirasRollos.Attributes.Add("onclick", "javascript:abrir_lov_tiras('" & tboxCodigoArt.ClientID & "', '" & tbox_cantidad.ClientID & "', '" & tboxDescripART.ClientID & "','" & lblAncho.ClientID & "','" & lblLargo.ClientID & "','" & lblTiras.ClientID & "','" & lblRollos.ClientID & "','" & lblM2.ClientID & "','" & lblEquiUnPr.ClientID & "','" & lblDesperdicio.ClientID & "');")
            imgEditTirasRollos.Attributes.Add("style", "cursor:pointer;")

            'texto confirm
            Dim textoconfirm As String = GetLocalResourceObject("MsgModalModificarSuRef")
            Dim textorepetidos As String = GetLocalResourceObject("MsgModaltextorepetidos")
            Dim mensajenoexiste As String = GetLocalResourceObject("MsgModalmensajenoexiste")
            tboxSuRef.Attributes.Add("onblur", "javascript:lov_cambiar_su_ref('" + codigoCliente.ToString() + "','" + tboxCodigoArt.ClientID + "', '" + tboxDescripART.ClientID + "','" + ConfigurationManager.AppSettings("obstip_articulo_idiomas") + "','" + Session("idioma") + "','" + tbox_cantidad.ClientID + "','" + lblPrecio.ClientID + "','" + tbox_precio.ClientID + "','" + lblDescuento.ClientID + "','" + tbox_dto.ClientID + "','" + lbltotal.ClientID + "','" + TIPO_USUARIO + "','" + lblModif.ClientID + "','" & GetLocalResourceObject("ArticuloNoExiste") + "','" + lblprecio_teorico.ClientID + "','" + tboxSuRef.ClientID + "','" + textoconfirm + "','" + textorepetidos + "','" + mensajenoexiste & "','" & EMPRESAGRUPO & "','" & EMPRESA & "','" & ConfigurationManager.AppSettings("venta") & "','" & Unidad.ClientID & "','" & lblAncho.ClientID & "','" & lblLargo.ClientID & "','" & lblTiras.ClientID & "','" & lblRollos.ClientID & "','" & lblM2.ClientID & "','" & lblEquiUnPr.ClientID & "','" & lblDesperdicio.ClientID & "','" & imgEditTirasRollos.ClientID & "')")


            'jvc dudo de esto. No se si es el almacen defecto de la oportunidad o no.
            Dim almacen As String = ConfigurationManager.AppSettings("Almacen_defecto")

            'cambiar texto articulo
            'si tentemos la oferta de origen, se lo pasamos.


            Dim numOferta As String = Session("cabecera").prop_N_OFE

            Dim age As New BCb2b.gvagente()
            If Not Session("agente") Is Nothing Then
                age = Session("agente")
            Else
                Dim cli As New BCb2b.ggclipr(codigoCliente, ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"))
                age = New BCb2b.gvagente(cli.prop_GVAGENTE_COD, ConfigurationManager.AppSettings("grupo"), 0)
            End If

            tboxDescripART.Attributes.Add("onchange", "javascript:cambia_cantidad('" + codigoCliente.ToString() + "','" + tboxCodigoArt.ClientID + "', '" + tboxDescripART.ClientID + "','" + tbox_cantidad.ClientID + "','" + lblPrecio.ClientID + "','" + tbox_precio.ClientID + "','" + lblDescuento.ClientID + "','" + tbox_dto.ClientID + "','" + lbltotal.ClientID + "','" + TIPO_USUARIO + "','" + lblModif.ClientID + "','" + HFLINEA.ClientID + "','" + numOferta + "','" + tboxPlazo.ClientID + "','" + tboxSuRef.ClientID + "','" + lblprecio_teorico.ClientID + "','" & ConfigurationManager.AppSettings("grupo") & "','" & ConfigurationManager.AppSettings("empresa") & "','" & ConfigurationManager.AppSettings("venta") & "','" & ConfigurationManager.AppSettings("serieOferta") & "','" & GetLocalResourceObject("MsgArticuloCambiarPrecEsp") & "','" & age.prop_NOMBRE & " " & Date.Now & "','" & Unidad.ClientID & "','" & lblAncho.ClientID & "','" & lblLargo.ClientID & "','" & lblTiras.ClientID & "','" & lblRollos.ClientID & "','" & lblM2.ClientID & "','" & lblEquiUnPr.ClientID & "','" & lblDesperdicio.ClientID & "','" & Session("cultura") & "','" & ConfigurationManager.AppSettings("COD_GAART_ESP") & "','" & GetLocalResourceObject("MsgModalEsKit") & "')")
            tbox_cantidad.Attributes.Add("onchange", "javascript:cambia_cantidad('" + codigoCliente.ToString() + "','" + tboxCodigoArt.ClientID + "', '" + tboxDescripART.ClientID + "','" + tbox_cantidad.ClientID + "','" + lblPrecio.ClientID + "','" + tbox_precio.ClientID + "','" + lblDescuento.ClientID + "','" + tbox_dto.ClientID + "','" + lbltotal.ClientID + "','" + TIPO_USUARIO + "','" + lblModif.ClientID + "','" + HFLINEA.ClientID + "','" + numOferta + "','" + tboxPlazo.ClientID + "','" + tboxSuRef.ClientID + "','" + lblprecio_teorico.ClientID + "','" & ConfigurationManager.AppSettings("grupo") & "','" & ConfigurationManager.AppSettings("empresa") & "','" & ConfigurationManager.AppSettings("venta") & "','" & ConfigurationManager.AppSettings("serieOferta") & "','" & GetLocalResourceObject("MsgArticuloCambiarPrecEsp") & "','" & age.prop_NOMBRE & " " & Date.Now & "','" & Unidad.ClientID & "','" & lblAncho.ClientID & "','" & lblLargo.ClientID & "','" & lblTiras.ClientID & "','" & lblRollos.ClientID & "','" & lblM2.ClientID & "','" & lblEquiUnPr.ClientID & "','" & lblDesperdicio.ClientID & "','" & Session("cultura") & "','" & ConfigurationManager.AppSettings("COD_GAART_ESP") & "','" & GetLocalResourceObject("MsgModalEsKit") & "')")
            tboxPlazo.Attributes.Add("onchange", "javascript:cambia_cantidad('" + codigoCliente.ToString() + "','" + tboxCodigoArt.ClientID + "', '" + tboxDescripART.ClientID + "','" + tbox_cantidad.ClientID + "','" + lblPrecio.ClientID + "','" + tbox_precio.ClientID + "','" + lblDescuento.ClientID + "','" + tbox_dto.ClientID + "','" + lbltotal.ClientID + "','" + TIPO_USUARIO + "','" + lblModif.ClientID + "','" + HFLINEA.ClientID + "','" + numOferta + "','" + tboxPlazo.ClientID + "','" + tboxSuRef.ClientID + "','" + lblprecio_teorico.ClientID + "','" & ConfigurationManager.AppSettings("grupo") & "','" & ConfigurationManager.AppSettings("empresa") & "','" & ConfigurationManager.AppSettings("venta") & "','" & ConfigurationManager.AppSettings("serieOferta") & "','" & GetLocalResourceObject("MsgArticuloCambiarPrecEsp") & "','" & age.prop_NOMBRE & " " & Date.Now & "','" & Unidad.ClientID & "','" & lblAncho.ClientID & "','" & lblLargo.ClientID & "','" & lblTiras.ClientID & "','" & lblRollos.ClientID & "','" & lblM2.ClientID & "','" & lblEquiUnPr.ClientID & "','" & lblDesperdicio.ClientID & "','" & Session("cultura") & "','" & ConfigurationManager.AppSettings("COD_GAART_ESP") & "','" & GetLocalResourceObject("MsgModalEsKit") & "')")

            tbox_precio.Attributes.Add("onchange", "javascript:calcula_precio_final('" + codigoCliente.ToString() + "','" + tboxCodigoArt.ClientID + "', '" + tboxDescripART.ClientID + "','" + tbox_cantidad.ClientID + "','" + lblPrecio.ClientID + "','" + tbox_precio.ClientID + "','" + lblDescuento.ClientID + "','" + tbox_dto.ClientID + "','" + lbltotal.ClientID + "','" + TIPO_USUARIO + "','" + lblModif.ClientID + "','" + HFLINEA.ClientID + "','" + numOferta + "','" + tboxPlazo.ClientID + "','" + tboxSuRef.ClientID + "','" + lblprecio_teorico.ClientID + "','" & ConfigurationManager.AppSettings("grupo") & "','" & ConfigurationManager.AppSettings("empresa") & "','" & ConfigurationManager.AppSettings("venta") & "','" & ConfigurationManager.AppSettings("serieOferta") & "','" & GetLocalResourceObject("MsgArticuloCambiarPrecEsp") & "','" & age.prop_NOMBRE & " " & Date.Now & "','" & Unidad.ClientID & "','" & lblAncho.ClientID & "','" & lblLargo.ClientID & "','" & lblTiras.ClientID & "','" & lblRollos.ClientID & "','" & lblM2.ClientID & "','" & lblEquiUnPr.ClientID & "','" & lblDesperdicio.ClientID & "','" & Session("cultura") & "','" & ConfigurationManager.AppSettings("COD_GAART_ESP") & "','N')")
            tbox_dto.Attributes.Add("onchange", "javascript:calcula_precio_final('" + codigoCliente.ToString() + "','" + tboxCodigoArt.ClientID + "', '" + tboxDescripART.ClientID + "','" + tbox_cantidad.ClientID + "','" + lblPrecio.ClientID + "','" + tbox_precio.ClientID + "','" + lblDescuento.ClientID + "','" + tbox_dto.ClientID + "','" + lbltotal.ClientID + "','" + TIPO_USUARIO + "','" + lblModif.ClientID + "','" + HFLINEA.ClientID + "','" + numOferta + "','" + tboxPlazo.ClientID + "','" + tboxSuRef.ClientID + "','" + lblprecio_teorico.ClientID + "','" & ConfigurationManager.AppSettings("grupo") & "','" & ConfigurationManager.AppSettings("empresa") & "','" & ConfigurationManager.AppSettings("venta") & "','" & ConfigurationManager.AppSettings("serieOferta") & "','" & GetLocalResourceObject("MsgArticuloCambiarPrecEsp") & "','" & age.prop_NOMBRE & " " & Date.Now & "','" & Unidad.ClientID & "','" & lblAncho.ClientID & "','" & lblLargo.ClientID & "','" & lblTiras.ClientID & "','" & lblRollos.ClientID & "','" & lblM2.ClientID & "','" & lblEquiUnPr.ClientID & "','" & lblDesperdicio.ClientID & "','" & Session("cultura") & "','" & ConfigurationManager.AppSettings("COD_GAART_ESP") & "','S')")


            imgBorrar.Attributes.Add("onclick", "javascript:borraLinea('" + codigoCliente.ToString() + "','" + tboxCodigoArt.ClientID + "', '" + tboxDescripART.ClientID + "','" + tbox_cantidad.ClientID + "','" + lblPrecio.ClientID + "','" + tbox_precio.ClientID + "','" + lblDescuento.ClientID + "','" + tbox_dto.ClientID + "','" + lbltotal.ClientID + "','" + TIPO_USUARIO + "','" + lblModif.ClientID + "','" + HFLINEA.ClientID + "','" + numOferta + "','" + GetLocalResourceObject("lblResourceBorrarLineaConfirm.Text") + "','" & ConfigurationManager.AppSettings("grupo") & "','" & ConfigurationManager.AppSettings("empresa") & "','" & ConfigurationManager.AppSettings("venta") & "','" & ConfigurationManager.AppSettings("serieOferta") & "')")

            'HACER QUE SI ES CLIENTE NO VEA LOS TEXTBOX DE PRECIOS Y SI ES OTRO PERFIL NO SE VEAN LOS LABEL.
            If (TIPO_USUARIO = "CL") Then

                ' lblPrecio.Attributes.Add("style", "visibility:hidden")
                lblPrecio.Attributes.Add("style", "display:inline")
                tbox_precio.Attributes.Add("style", "display:none")

                ' lblDescuento.Attributes.Add("style", "visibility:hidden")
                lblDescuento.Attributes.Add("style", "display:inline")
                tbox_dto.Attributes.Add("style", "display:none")
            Else
                ' lblPrecio.Attributes.Add("style", "visibility:hidden")
                lblPrecio.Attributes.Add("style", "display:none")
                tbox_precio.Attributes.Add("style", "display:inline")

                ' lblDescuento.Attributes.Add("style", "visibility:hidden")
                lblDescuento.Attributes.Add("style", "display:none")
                tbox_dto.Attributes.Add("style", "display:inline")
            End If

            If tboxGaartCod.Text <> "" And tbox_cantidad.Text <> "" Then
                'SI ENTRA POR AQUI ES QUE TIENE LINEA
                'COMPROBAMOS EL CUC PARA PONER EL MENSAJE.

                'MIRAMOS EL MARGEN.
                Dim PARAM_MARGEN_COSTE As New BCb2b.empparam("B2B_MARGEN_COSTE", ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("empresa"), Nothing)
                Dim PARAM_TARIFA As New BCb2b.empparam("B2B_TARIFA_COSTE", ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("empresa"), Nothing)

                Dim ARTICULOAUX As New BCb2b.CArticulo(ConfigurationManager.AppSettings("grupo"), tboxGaartCod.Text.ToUpper)
                Dim PRECIO_TARIFA As Double = ARTICULOAUX.calcula_precio_tarifa(PARAM_TARIFA.prop_VALOR, ConfigurationManager.AppSettings("venta"))

                Unidad.Text = ARTICULOAUX.prop_gaunitip_uni1

                Dim PRECIO_TARIFA_AUX As Double = 0
                PRECIO_TARIFA_AUX = (PRECIO_TARIFA + (PRECIO_TARIFA * PARAM_MARGEN_COSTE.prop_VALOR) / 100) * CDbl(tbox_cantidad.Text)

                Dim PRECIO_MIN_TEORICO As Double = 0
                PRECIO_MIN_TEORICO = (PRECIO_TARIFA + (PRECIO_TARIFA * PARAM_MARGEN_COSTE.prop_VALOR) / 100)

                lblprecio_teorico.Text = FormatNumber(PRECIO_MIN_TEORICO, 2).ToString

                lblPrecio.Text = tbox_precio.Text 'almacenamos aqui el valor
                tbox_precio.Text = Obtener_precios(tboxGaartCod.Text.ToUpper, codigoCliente, tbox_cantidad.Text, Session("cultura"))
                If gaart_es_tira_o_rollo(EMPRESAGRUPO, tboxGaartCod.Text.ToUpper) = "S" Then
                    tbox_cantidad.Enabled = False
                    'tbox_cantidad.BackColor = Drawing.Color.LightGray
                    tbox_precio.Enabled = False
                    'tbox_precio.BackColor = Drawing.Color.LightGray

                    If lblEquiUnPr.Text <> "" Then
                        tbox_cantidad.Text = lblM2.Text
                        tbox_precio.Text = Obtener_Precio_UnPr(tbox_precio.Text, tbox_cantidad.Text, lblEquiUnPr.Text, Session("cultura"))
                    End If
                    lblPrecio.Text = tbox_precio.Text
                End If

                ' lblPrecio.Text = tbox_precio.Text
                If lblPrecio.Text = "" Then
                    lblPrecio.Text = tbox_precio.Text
                Else
                    tbox_precio.Text = lblPrecio.Text
                End If

                tbox_dto.Text = Obtener_descuento(tboxGaartCod.Text.ToUpper, codigoCliente, tbox_cantidad.Text, Session("cultura"))
                'lblDescuento.Text = tbox_dto.Text
                If lblDescuento.Text = "" Then
                    lblDescuento.Text = tbox_dto.Text
                Else
                    tbox_dto.Text = lblDescuento.Text
                End If

                Dim cantidad_aux As String = ""
                If (lblTiras.Text <> "" Or lblRollos.Text <> "") And Unidad.Text <> "UN" Then
                    If lblTiras.Text <> "" Then
                        cantidad_aux = lblTiras.Text
                    End If
                    If lblRollos.Text <> "" Then
                        cantidad_aux = lblRollos.Text
                    End If
                Else
                    cantidad_aux = tbox_cantidad.Text
                End If
                lbltotal.Text = calcular_total_NP(cantidad_aux, tbox_precio.Text, tbox_dto.Text, Session("cultura"))

                Unidad.Text = ARTICULOAUX.prop_gaunitip_uni1

                Dim es_tira_o_rollo As String = gaart_es_tira_o_rollo(EMPRESAGRUPO, tboxGaartCod.Text.ToUpper)

                Dim ERRORCOSTE As Boolean = False
                Dim ATENCIONCOSTE As Boolean = False
                Dim OBSERVACIONCOSTE As String = ""
                Dim art_ESP As String = ConfigurationManager.AppSettings("COD_GAART_ESP")

                Dim cli As New BCb2b.ggclipr()
                cli = Session("cliente")

                If (CDbl(lbltotal.Text) < CDbl(PRECIO_TARIFA_AUX)) And es_tira_o_rollo = "N" And tboxGaartCod.Text.ToUpper <> art_ESP.ToUpper Then
                    Dim cod_error As String = ValidarPrecioLinea(tboxGaartCod.Text, cli.prop_COD, tbox_precio.Text, tbox_cantidad.Text, tbox_dto.Text, Session("cultura"))
                    Dim tipo_error As String = Dame_TipoError_de_Error(cod_error)
                    OBSERVACIONCOSTE = Obtener_Descrip_Error(cod_error, Session("cultura"))

                    Dim clase As String = ""
                    Dim clase_inf As String = ""
                    Select Case tipo_error  'PARA COLOR DE FONDO DE LA FILA.
                        Case "#ERROR"
                            ERRORCOSTE = True 'MENOR QUE CUC Y QUE TARIF_ESTR
                            clase = "error"
                            clase_inf = "error_suave"
                        Case "#WARNING"
                            ATENCIONCOSTE = True 'MENOR QUE EL CUC PERO NO MENOR QUE TARIF_ESTR
                            clase = "atencion"
                            clase_inf = "atencion_suave"
                        Case "#OK"
                    End Select

                    e.Row.CssClass = clase
                    'PINTAMOS LA FILA ACTUAL DE ROJO
                    Dim i As Integer = 0
                    For i = 0 To e.Row.Cells.Count - 1
                        e.Row.Cells(i).CssClass = clase
                    Next

                    If tipo_error <> "#OK" Then 'si es OK no creamos otra fila.
                        num_lineas_error_costo = num_lineas_error_costo + 1
                        'AÑADIMOS LA NUEVA
                        AddNewRow(BulkEditGridView1, e, num_lineas_error_costo, OBSERVACIONCOSTE, clase_inf)
                    End If

                End If

                Dim LINEAOFE As New BCb2b.COferta_linOff(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("empresa"), ConfigurationManager.AppSettings("venta"), cabecera.prop_ggofetip_cod, cabecera.prop_N_OFE, HFLINEA.Value, tboxGaartCod.Text.ToUpper, tboxDescripART.Text, tbox_cantidad.Text, tbox_precio.Text, "", Unidad.Text, cabecera.prop_ggclipr_cod, tbox_dto.Text, tboxPlazo.Text, True, ERRORCOSTE, ATENCIONCOSTE, lblAncho.Text, lblLargo.Text, lblTiras.Text, lblRollos.Text, lblM2.Text, lblEquiUnPr.Text, lblDesperdicio.Text, OBSERVACIONCOSTE)

                Dim list_LINEAS As New List(Of BCb2b.COferta_linOff)
                Try
                    'OBTENEMOS LINEAS Y ASIGNAMOS LA LINEA ACTUAL CON EL ERROR
                    list_LINEAS = Session("lineasOferta")
                    list_LINEAS(HFLINEA.Value - 1) = LINEAOFE
                    Session("lineasOferta") = list_LINEAS
                Catch ex As Exception
                    Log.Error(ex, "[CrearOferta.AsignandoLin]")
                End Try

            End If
        End If
    End Sub
    Public Sub AddNewRow(ByVal sender As Object, ByVal e As GridViewRowEventArgs, ByVal n_lin As Integer, ByVal textoMensaje As String, ByVal clasecss As String)
        Try
            Dim GridView1 As GridView = DirectCast(sender, GridView)
            Dim NewTotalRow As New GridViewRow(0, 0, DataControlRowType.DataRow, DataControlRowState.Insert)
            NewTotalRow.Font.Bold = True
            NewTotalRow.BackColor = System.Drawing.Color.Aqua
            Dim HeaderCell As New TableCell()
            HeaderCell.Height = 10
            HeaderCell.HorizontalAlign = HorizontalAlign.Center

            Dim IDIOMA As String = Session("idioma")
            'Dim texto As String = CType(HttpContext.GetGlobalResourceObject("general", "bajoCoste", Session("cultura")), String).ToString()

            'Dim texto As String = ConfigurationManager.AppSettings("bajoCoste_" & IDIOMA)

            'Dim texto As String = GetGlobalResourceObject("general", "AtencionBajoCoste")

            HeaderCell.Text = textoMensaje
            HeaderCell.ColumnSpan = 10
            HeaderCell.CssClass = clasecss
            NewTotalRow.Cells.Add(HeaderCell)
            GridView1.Controls(0).Controls.AddAt(e.Row.RowIndex + n_lin + 1, NewTotalRow)
        Catch ex As Exception
            Log.Error(ex, "[CrearOferta.AddNewRow] lin = {lin} ", n_lin + 1)
        End Try

    End Sub
    Protected Sub BulkEditGridView1_RowCommand(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewCommandEventArgs) Handles BulkEditGridView1.RowCommand

        BulkEditGridView1.Save()
        If e.CommandName = "Borrar" Then


        End If
    End Sub

    Protected Sub Page_Load(sender As Object, e As EventArgs) Handles Me.Load
        Ajax.Utility.RegisterTypeForAjax(GetType(CrearOferta))

        'HABILITAMOS LOS MENSAJES MODALES
        Dim mensaje As New BCb2b.Utilities
        mensaje.HabilitarModalMessages(Me, GetLocalResourceObject("MsgModalBtnAceptar"))
        mensaje.CrearModalConfirm(Me, "BorrarLineaOferta", GetLocalResourceObject("MsgModalBtnConfirm"), GetLocalResourceObject("lblResourceBorrarLineaConfirm.Text"), GetLocalResourceObject("MsgModalBtnYes"), GetLocalResourceObject("MsgModalBtnNo"), False)

        'VER SI PUEDO QUITAR ESTO.
        '  Dim kk As Object = Session("lineasOferta")

        If (Session("cliente") Is Nothing) Then
            'Server.Transfer("SelCliente.aspx")
            Server.Transfer("BusquedaClientes.aspx")
        End If

        'HABILITAMOS LOS MENSAJES MODALES
        'Dim mensaje As New BCb2b.Utilities
        'mensaje.HabilitarModalMessages(Me, GetLocalResourceObject("MsgModalBtnAceptar"))
        'mensaje.CrearModalConfirm(Me, "BorrarLineaOferta", GetLocalResourceObject("MsgModalBtnConfirm"), GetLocalResourceObject("lblResourceBorrarLineaConfirm.Text"), GetLocalResourceObject("MsgModalBtnYes"), GetLocalResourceObject("MsgModalBtnNo"), False)

        'cargamos hiddens.
        tboxGrupo.Value = ConfigurationManager.AppSettings("grupo")
        tboxempresa.Value = ConfigurationManager.AppSettings("empresa")
        tboxggofetip_cod.Value = DDLSeries.SelectedValue

        'Meto esto para ajax.

        Dim DTO_DEFECTO As New BCb2b.CParametros()
        'DESCUENTO_DEFECTO = DTO_DEFECTO.dame_param_EMP(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("empresa"), ConfigurationManager.AppSettings("B2B_DESCUENTO_DEFECTO"))


        '   If Not Page.IsPostBack Then
        Session("N_OFE") = ""
        Session("GRUPO_OFE") = ""
        Session("EMPRESA_OFE") = ""
        Session("TIPO_OFE") = ""


        btnContinuar.Visible = True

        num_lineas_error_costo = 0

        Dim list_series_std As ArrayList = OBTENER_SERIES_OFERTA() 'Estándar
        DDLSeries.DataSource = list_series_std
        DDLSeries.DataBind()

        Dim cliente As New BCb2b.ggclipr()
        cliente = Session("cliente")

        'RECALCULAMOS PARA VER SI HA CAMBIADO LA DIRECCION DE ENVIO POR DEFECTO.
        Dim cliente_aux As New BCb2b.ggclipr(cliente.prop_COD, cliente.prop_EMPGRUPO_COD, cliente.prop_TIP_VC)
        cliente = cliente_aux

        If Not Page.IsPostBack Then

            'DDLDir_Envio
            Dim dir_env As New BCb2b.CDirecciones()
            Dim ldir_env As New ArrayList
            ldir_env = dir_env.LISTA_DIRECCIONES(cliente.prop_RSOCIAL_COD)
            DDLDir_Envio.DataSource = ldir_env
            DDLDir_Envio.DataTextField = "PROP_NOMBRE_DIR"
            DDLDir_Envio.DataValueField = "PROP_COD"
            DDLDir_Envio.DataBind()

            'LE PASO EL cli.prop_GGMENVIO_COD PORQUE SI NO TIENE MODOS DE ENVIO DEFINIDOS EN LA OBSER DEL PROVEEDOR PARA QUE PONGA LA DEL CLI.
            cargarListadoModosEnvio(cliente.prop_GGMENVIO_COD, Session("idioma_spyro"))

            'JCE. SI NO TIENE DIR_ENV POR DEFECTO PONDREMOS LA SOC.
            Dim dir_defecto As New BCb2b.CDirecciones()
            If cliente.prop_RSOCDIR_ENV <> "" Then
                dir_defecto = cliente.PROP_DIR_ENVIO
            Else
                dir_defecto = cliente.PROP_DIR_social
            End If
            DDLDir_Envio.SelectedValue = dir_defecto.PROP_COD

            Try

                lbldir.Text = dir_defecto.PROP_DIR
                lblCP.Text = dir_defecto.PROP_COD_POSTAL
                lblProvi.Text = dir_defecto.PROP_PROVI_NOM
                lblTfono.Text = dir_defecto.PROP_TELEFONOS
                Dim uti As New BCb2b.Utilities()
                If uti.IsMobileBrowser() = True Then
                    lblTfono.NavigateUrl = uti.DameMailtoTelefono(dir_defecto.PROP_TELEFONOS())
                    lblTfono.CssClass = ""
                Else
                    lblTfono.NavigateUrl = ""
                    lblTfono.CssClass = "HyperlinkSinStyles"
                End If

                lblPoblacion.Text = dir_defecto.PROP_POBLAC_NOM
                lblpais.Text = dir_defecto.PROP_PAISES_nom
                lblFax.Text = dir_defecto.PROP_TELEFAX

            Catch ex As Exception
                Log.Error(ex, "[CrearOferta.Cargando Telefonos] dir = {@dir} ", dir_defecto)
            End Try
        End If

        'generamos la cabecera de la oferta.

        Dim AGENTE As String = ""
        If Not Session("agente") Is Nothing Then
            AGENTE = Session("agente").prop_cod()
        End If

        lblSerie.Text = DDLSeries.SelectedItem.Value()
        lblSerie.Visible = False
        DDLSeries.Visible = True

        Dim direccion_envio As String
        direccion_envio = ""
        Try
            direccion_envio = DDLDir_Envio.SelectedItem.Value
        Catch ex As Exception

        End Try

        'Dim cabecera As New BCb2b.COferta_Cab(cliente, ConfigurationManager.AppSettings("empresa"), DDLSeries.SelectedItem.Value, _
        ' ConfigurationManager.AppSettings("ESTADO_INTERMEDIO"), ConfigurationManager.AppSettings("imprimir_sn"), ConfigurationManager.AppSettings("historico_sn"), AGENTE, tboxRefCli.Text, tboxAtte.Text, direccion_envio, Session("cliente").prop_rsoccondi_DEF)



        'aqui habría que añadir estos datos:AGENTE, tboxRefCli.Text, tboxAtte.Text, direccion_envio, Session("cliente").prop_rsoccondi_DEF
        'esto solo si estoy creando.

        '-----CAMBIO AMC_NE213. LA FORMA DE PAGO PDTE PARA LAS OFERTAS SOLO PARA CLIENTES EN ESTADO PC O POT
        '-----AMC_NE183----- FORMA DE PAGO DE PARAMETRO 
        Dim param As New BCb2b.CParametros()
        Dim fpago As String = ""
        If cliente.prop_GGESTADO_COD = ConfigurationManager.AppSettings("EstadoNewCli") Or cliente.prop_GGESTADO_COD = ConfigurationManager.AppSettings("EstadoPC") Then
            fpago = param.dame_param(ConfigurationManager.AppSettings("AMC_B2B_OBFP_OFERTAS"))
        Else
            fpago = cliente.prop_forma_pago.PROP_COD
        End If

        '-----FIN AMC_NE183----- FORMA DE PAGO DE PARAMETRO 
        '-----FIN CAMBIO AMC_NE213. LA FORMA DE PAGO PDTE PARA LAS OFERTAS SOLO PARA CLIENTES EN ESTADO PC O POT

        If (Session("cabecera") Is Nothing) Then
            Dim cabecera As New BCb2b.COferta_Cab()
            cabecera = New BCb2b.COferta_Cab(cliente, ConfigurationManager.AppSettings("empresa"), DDLSeries.SelectedItem.Value, _
                 ConfigurationManager.AppSettings("ESTADO_ACTIVO"), ConfigurationManager.AppSettings("imprimir_sn"), ConfigurationManager.AppSettings("historico_sn"), AGENTE, tboxRefCli.Text, tboxAtte.Text, direccion_envio, "", fpago, Nothing)

            'Dim cabecera As New BCb2b.COferta_Cab(Session("cliente"),EMPRESA,tipo_oferta:=,TIPVC,pAtte:=,estado,pGgmenvio:=,pPortpagSN:=,pSurefOfe:=,direnv,rsoccondicod,nothing)
            Session("cabecera") = cabecera
        End If

        If Not (Page.IsPostBack) Then
            If Not (Session("cabecera") Is Nothing) Then
                Dim cabecera As New BCb2b.COferta_Cab()
                cabecera = Session("cabecera")
                'cargar refe y atte de la oferta creada que estamos revisando
                tboxRefCli.Text = cabecera.prop_su_ref_OFE
                tboxAtte.Text = cabecera.prop_ATTE
                'cargar observacion de la oferta creada que estamos revisando
                txtarea_observacion.Text = cabecera.prop_OBSERVACION_dEFECTO
                'cargar observacion de pie de la oferta creada que estamos revisando
                txtarea_observacion_pie.Text = cabecera.prop_OBSERVACION_pie

                Dim dir_sel As New BCb2b.CDirecciones()
                dir_sel = cabecera.prop_dir_envio
                DDLDir_Envio.SelectedValue = dir_sel.PROP_COD
                comboModosEnvio.SelectedValue = cabecera.prop_GGMENVIO_COD

                lbldir.Text = dir_sel.PROP_DIR
                lblCP.Text = dir_sel.PROP_COD_POSTAL
                lblProvi.Text = dir_sel.PROP_PROVI_NOM
                lblTfono.Text = dir_sel.PROP_TELEFONOS
                lblPoblacion.Text = dir_sel.PROP_POBLAC_NOM
                lblpais.Text = dir_sel.PROP_PAISES_nom
                lblFax.Text = dir_sel.PROP_TELEFAX

                'calculos asociados
                Dim listado_calculos As New ArrayList
                listado_calculos = cabecera.prop_LISTADO_IDDISTRIBUCION

                If listado_calculos.Count > 0 Then
                    'Dim calculo As New AMC_Proyectos_pkg.CCalculos()
                    'calculo = Session("calculos")
                    'Dim iddistribucion As String = calculo.prop_iddistribucion
                    Dim ggestcampa_cod As String = ""
                    lblCalculoAsoc.Text = ""
                    For Each calculo As AMC_Proyectos_pkg.CCalculos In listado_calculos
                        ggestcampa_cod = calculo.prop_idestudio.PadLeft(10, "0")
                        Dim revision As String = calculo.prop_revision
                        Dim observacion As String = calculo.prop_observaciones

                        lblCalculoAsoc.Text = lblCalculoAsoc.Text & observacion & ","
                    Next
                    lblCalculoAsoc.Text = lblCalculoAsoc.Text.Remove(lblCalculoAsoc.Text.LastIndexOf(","))
                    lblCalculoAsoc.Text = ggestcampa_cod & " (" & lblCalculoAsoc.Text & ")"

                    If ggestcampa_cod <> "" Then
                        cabecera.prop_LISTADO_IDDISTRIBUCION = listado_calculos
                    Else
                        lblcalcasoctitu.Visible = False
                        lblCalculoAsoc.Visible = False
                    End If

                    lblatencion_confim_calc.Visible = True
                    div_lblatencion_confim_calc.Visible = True
                    lblatencion_confim_calc.Text = GetLocalResourceObject("lblAtenConfirCalc")
                    If lblCalculoAsoc.Text <> "" Then
                        lblatencion_confim_calc.Text = lblatencion_confim_calc.Text & " " & lblCalculoAsoc.Text
                    End If
                Else
                    lblcalcasoctitu.Visible = False
                    lblCalculoAsoc.Visible = False
                    lblatencion_confim_calc.Visible = False
                    div_lblatencion_confim_calc.Visible = False
                    lblatencion_confim_calc.Text = ""
                End If
            End If
        End If

        Dim cli As New BCb2b.ggclipr()
        Try

            If (Not Session("cliente") Is Nothing) Then
                cli = Session("cliente")

                'AMC_NE127. SI NO TIENE TODAS LAS CLASIS METIDAS O ESTA EN ESTADO POT POR LO QUE SEA, VA A CREARCLIENTE
                Dim clasisOblis As String = param.dame_param(ConfigurationManager.AppSettings("B2B_CLASIS_OBLI_USU_CREACLI"))
                Dim comp_clasis As New BCb2b.CGGCLICLASI()
                Dim todas_llenas As Boolean = comp_clasis.CompruebaSiClasisObliRellenas(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), clasisOblis, cli.prop_COD, Session("idioma_spyro"), ConfigurationManager.AppSettings("NOMTABLA_TRADUC_GGCLATIP"), ConfigurationManager.AppSettings("NOMCOLUMNA_TRADUC_GGCLATIP_DESC"))

                Dim perfiles As New BCb2b.USUARIOS_B2B()
                perfiles.Administrar_Permisos_Perfiles(Session("tipo_usuario"))

                If perfiles.prop_TIPO_PERFIL <> 0 Then 'SI ES ING O SVT QUE NO LE MANDE A RELLENAR CLASIS O CONTACTO. PORQUE SINO AL PASAR DE CALCULO A OFERTA LE FASTIDIA.
                    If todas_llenas = False Or cli.prop_GGESTADO_COD = ConfigurationManager.AppSettings("EstadoNewCli") Then
                        Session("new_cliente") = cli
                        Response.Redirect("CrearCliente.aspx")
                    End If
                End If
                'cargar forma de pago

                If Not Page.IsPostBack Then
                    GESTIONAR_FORMAS_DE_PAGO(cli, fpago)
                End If

                'Dim forma_pago As New BCb2b.CFPago()
                'forma_pago.DameDatosFPago(fpago, Session("idioma_spyro"), ConfigurationManager.AppSettings("TRADUC_FPAGO_IDIOMASTAB"))
                'lblFormadepago.Text = forma_pago.PROP_DESCRIP


                'Datos de la cabecera fijos
                lblNombreCli.Text = cli.prop_NOMBRE

                'EN EL CASO DE TENER QUE PONER LOS PORTES DE NUEVO DESCOMENTAR LAS SIGUIENTES LINEAS.
                'If cli.prop_PORTES_PD = "P" Then
                'lblPortes.Text = GetLocalResourceObject("lblPortesPagadosDescrip.Text").ToString()
                'ElseIf cli.prop_PORTES_PD = "D" Then
                'lblPortes.Text = GetLocalResourceObject("lblPortesDebidosDescrip.Text").ToString()
                'End If

                lblRSocial.Text = cli.prop_RSOCIAL_COD

                'ANTERIORMENTE ERA UN LABEL FIJO Y SE HACIA ESTO
                'Dim traduc As New BCb2b.CSPTRADDATOS()
                'lblAgencia.Text = traduc.DameTraduccion(ConfigurationManager.AppSettings("NOMTABLA_TRADUC_GGMENVIO"), ConfigurationManager.AppSettings("NOMCOLUMNA_TRADUC_GGMENVIO"), ConfigurationManager.AppSettings("ING_SPYRO"), cli.prop_GGMENVIO_COD)
                'If lblAgencia.Text = "" Then
                '    lblAgencia.Text = cli.prop_GGMENVIO_desc
                'End If

                'Cabecera datos variables
                lblFOFE.Text = Now().Date



                ' lblFOFE.Text = session("cabecera").prop_n_ofe
                'lblSerie.Text = Session("cabecera").prop_GGOFETIP_COD
                lblSerie.Text = Session("cabecera").prop_ggofetip_Desc()
                DDLSeries.SelectedValue = Session("cabecera").prop_ggofetip_cod
                'lblSerieCod.Text = Session("cabecera").prop_ggofetip_cod()
                lblNOferta.Text = Session("cabecera").prop_n_ofe

                Session("N_OFE") = Session("cabecera").prop_N_OFE
                Session("GRUPO_OFE") = Session("cabecera").prop_EMPGRUPO_COD
                Session("EMPRESA_OFE") = Session("cabecera").prop_emp_cod
                Session("TIPO_OFE") = Session("cabecera").prop_ggofetip_cod


                'cargar observacion de pie del agente en el idioma, a no ser que sea revisión
                If (txtarea_observacion_pie.Text = "") Then

                    If Not (Page.IsPostBack) Then
                        Dim idioma As String = Session("idioma")
                        Dim cultura As String = Session("cultura")
                        Dim idioma_spyro As String = Session("idioma_spyro")
                        Dim la_obs_idioma As String = "O" + idioma_spyro
                        Dim emprgrupocod As String = Session("cabecera").prop_EMPGRUPO_COD

                        Dim cod_proveedor As String = ""
                        Dim proveedor As New BCb2b.gvagente()
                        If Not Session("agente") Is Nothing Then
                            proveedor = Session("agente")
                            cod_proveedor = proveedor.prop_GGCLIPR_PROV
                        Else
                            'SINO HAY AGENTE LO COGE DEL CLIENTE PARA OBTENER SUS OBSERVACIONES.
                            AGENTE = cliente.prop_GVAGENTE_COD
                            If AGENTE <> "" Then
                                'Dim ag As New BCb2b.CAgente(AGENTE)
                                Dim ag As New BCb2b.gvagente(AGENTE, ConfigurationManager.AppSettings("grupo"), 0)
                                cod_proveedor = ag.prop_GGCLIPR_PROV
                            End If
                            'Dim user As String = Session("Usuario").prop_cod
                            'If Not user Is Nothing Then
                            '    proveedor = New BCb2b.gvagente(user, emprgrupocod)
                            'End If

                        End If

                        Dim ggcliprobs As New BCb2b.GGCLIPROBS(emprgrupocod, ConfigurationManager.AppSettings("Compra"), cod_proveedor, la_obs_idioma)
                        txtarea_observacion_pie.Text = ggcliprobs.PROP_COMENTARIO
                    End If
                    'FIN
                End If
                'HAY QUE LLAMAR PARA CALCULAR PARAMETROS DE CABECERA 
                guardar_info_cabecera()
            Else
                If (Not Session("agente") Is Nothing) Then
                    'Response.Redirect("cliente_consulta.aspx")
                Else
                    'Response.Redirect("index.aspx")
                End If
            End If
        Catch ex As Exception
            Log.Error(ex, "[CrearOferta.CargandoDatosCli] cliente = {@cliente} ", cli)
            LBLERROR.Text = ex.ToString
        End Try

    End Sub


    Protected Sub btnContinuar_Click(sender As Object, e As EventArgs) Handles btnContinuar.Click
        BulkEditGridView1.DataBind()
    End Sub



    Protected Sub btnRealizar_Click(sender As Object, e As EventArgs) Handles btnRealizar.Click
        guardar_info_cabecera()

        Dim cabecera As New BCb2b.COferta_Cab()
        cabecera = Session("cabecera")

        Dim listado_calculos As New ArrayList
        listado_calculos = cabecera.prop_LISTADO_IDDISTRIBUCION
        If listado_calculos.Count = 0 Then
            'SINO LLEGA ES QUE NO VIENE DE CALCULOS Y HAY QUE OBTENERLO.
            Dim calc As New AMC_Proyectos_pkg.CCalculos()
            listado_calculos = calc.DameCalculosDeOferta(cabecera.prop_EMPGRUPO_COD, cabecera.prop_emp_cod, cabecera.prop_tip_Vc, cabecera.prop_ggofetip_cod, cabecera.prop_N_OFE, cabecera.prop_N_REVISION)
            cabecera.prop_LISTADO_IDDISTRIBUCION = listado_calculos
        End If

        Session("cabecera") = cabecera

        Dim mislineas As New List(Of BCb2b.COferta_linOff)
        If Not Session("lineasOferta") Is Nothing Then
            mislineas = Session("lineasOferta")
        End If
        If mislineas.Count > 0 Then
            Server.Transfer("ofertaValidar.aspx")
        Else
            'MOSTRAR ERROR SIN LINEAS.
            ScriptManager.RegisterStartupScript(Me, Me.GetType(), "NoLines", "ShowDialog('" & GetGlobalResourceObject("general", "MsgModalbtnAtencion") & "','" & GetGlobalResourceObject("general", "NoLineasIntroduc") & "','err_red','',300);", True)
        End If
    End Sub

    Protected Sub DDLDir_Envio_SelectedIndexChanged(sender As Object, e As EventArgs) Handles DDLDir_Envio.SelectedIndexChanged
        Dim dir_sel As New BCb2b.CDirecciones(lblRSocial.Text, DDLDir_Envio.SelectedValue)
        Try
            lbldir.Text = dir_sel.PROP_DIR
            lblCP.Text = dir_sel.PROP_COD_POSTAL
            lblProvi.Text = dir_sel.PROP_PROVI_NOM
            lblTfono.Text = dir_sel.PROP_TELEFONOS
            lblPoblacion.Text = dir_sel.PROP_POBLAC_NOM
            lblpais.Text = dir_sel.PROP_PAISES_nom
            lblFax.Text = dir_sel.PROP_TELEFAX

            guardar_info_cabecera()
        Catch ex As Exception
            Log.Error(ex, "[CrearOferta.DDLDir_Envio_SelectedIndexChanged] dir = {@dir} ", dir_sel)
        End Try
    End Sub
    Private Sub cargarListadoModosEnvio(Optional ByVal menvio_def As String = "", Optional ByVal idioma As String = "")
        Dim cli As New BCb2b.ggclipr()
        Dim age As New BCb2b.gvagente()
        Try
            comboModosEnvio.Items.Clear()
            Dim listaModosEnvio As New ArrayList
            Dim arrayModosEnvio As Array

            'LOS MODOS DE ENVIO SE OBTIENEN UNA OBSERVACION ASOCIADA A LA FICHA DEL PROVEEDOR (OBME)

            cli = Session("cliente")
            If Not Session("agente") Is Nothing Then
                age = Session("agente")
            Else
                age = New BCb2b.gvagente(cli.prop_GVAGENTE_COD, ConfigurationManager.AppSettings("grupo"), 0)
            End If

            Dim valor As String = ""
            Dim obs As New BCb2b.GGCLIPROBS()
            valor = obs.DameObserAGEdeGGCLIPR(ConfigurationManager.AppSettings("grupo"), age, cli.prop_COD, ConfigurationManager.AppSettings("OBME"))

            Dim tiene_el_ggmenvio_def As Boolean = False
            If valor <> "" Then
                arrayModosEnvio = Split(valor, ",")

                Dim i As Integer = 0
                For i = 0 To arrayModosEnvio.Length - 1

                    Dim mEnvio As New BCb2b.CGGMenvio()
                    If idioma <> "" Then
                        mEnvio.DameDatosModoEnvio(arrayModosEnvio(i), idioma, ConfigurationManager.AppSettings("NOMTABLA_TRADUC_GGMENVIO"), ConfigurationManager.AppSettings("NOMCOLUMNA_TRADUC_GGMENVIO"))
                    Else
                        mEnvio = New BCb2b.CGGMenvio(arrayModosEnvio(i))
                    End If

                    If mEnvio.PROP_cod = menvio_def Then
                        tiene_el_ggmenvio_def = True
                    End If

                    listaModosEnvio.Add(mEnvio)
                Next i
            Else
                '--------AMC_NE183. Si no hay observacion de proveedor OBME poner A Convenir POR DELANTE
                Dim mEnvio As New BCb2b.CGGMenvio()
                If idioma <> "" Then
                    mEnvio.DameDatosModoEnvio(ConfigurationManager.AppSettings("MODO_ENVIO_A_CONVENIR"), idioma, ConfigurationManager.AppSettings("NOMTABLA_TRADUC_GGMENVIO"), ConfigurationManager.AppSettings("NOMCOLUMNA_TRADUC_GGMENVIO"))
                Else
                    mEnvio = New BCb2b.CGGMenvio(ConfigurationManager.AppSettings("MODO_ENVIO_A_CONVENIR"))
                End If
                listaModosEnvio.Add(mEnvio)
                '------FIN AMC_NE183-------
                If menvio_def <> "" Then
                    Dim MEnvioDefecto As New BCb2b.CGGMenvio()
                    MEnvioDefecto.DameDatosModoEnvio(menvio_def, idioma, ConfigurationManager.AppSettings("NOMTABLA_TRADUC_GGMENVIO"), ConfigurationManager.AppSettings("NOMCOLUMNA_TRADUC_GGMENVIO"))
                    listaModosEnvio.Add(MEnvioDefecto)
                    tiene_el_ggmenvio_def = True
                End If
            End If

            If tiene_el_ggmenvio_def = False Then
                Dim modo_env_def As New BCb2b.CGGMenvio(menvio_def)
                listaModosEnvio.Add(modo_env_def)
            End If

            comboModosEnvio.DataSource = listaModosEnvio
            comboModosEnvio.DataTextField = "prop_descrip"
            comboModosEnvio.DataValueField = "prop_cod"
            comboModosEnvio.DataBind()
        Catch ex As Exception
            Log.Error(ex, "[CrearOferta.cargarListadoModosEnvio] age = {@age} cli = {@cli} ", age, cli)
        End Try

    End Sub

    Protected Sub TimerSesion_Tick(sender As Object, e As EventArgs) Handles TimerSesion.Tick
        BulkEditGridView1.DataBind()
    End Sub
    Private Sub guardar_info_cabecera()
        Dim cabecera As New BCb2b.COferta_Cab()
        Dim cliente As New BCb2b.ggclipr()
        Try
            'RECARGAMOS DATOS DE REF,ATT,OBSERS Y DIR PARA GUARDARLO Y QUE NO SE PIERDA
            cabecera = Session("cabecera")
            cabecera.prop_dir_envio = New BCb2b.CDirecciones(lblRSocial.Text, DDLDir_Envio.SelectedValue)
            cabecera.prop_GGMENVIO_COD = comboModosEnvio.SelectedValue
            cabecera.prop_ATTE = tboxAtte.Text
            cabecera.prop_su_ref_OFE = tboxRefCli.Text
            cabecera.prop_OBSERVACION_dEFECTO = txtarea_observacion.Text
            cabecera.prop_OBSERVACION_pie = txtarea_observacion_pie.Text
            cabecera.prop_ggofetip_cod = DDLSeries.SelectedValue

            cliente = Session("cliente")

            'AMC_NE243. JCE. 07/06/16. FPAGO OFERTAS INGENIERO.
            Dim perfiles As New BCb2b.USUARIOS_B2B()
            perfiles.Administrar_Permisos_Perfiles(Session("perfil_usuario"))
            Dim fpago As String = ""
            If perfiles.prop_TIPO_PERFIL = 0 Then 'ING o SVT
                fpago = ddlFPago.SelectedValue
                cabecera.prop_RSOCCONDI_COD = ""
            Else
                'LO HABITUAL
                '-----CAMBIO AMC_NE213. LA FORMA DE PAGO PDTE PARA LAS OFERTAS SOLO PARA CLIENTES EN ESTADO PC O POT
                '-----AMC_NE183----- FORMA DE PAGO DE PARAMETRO 
                Dim param As New BCb2b.CParametros()
                If cliente.prop_GGESTADO_COD = ConfigurationManager.AppSettings("EstadoNewCli") Or cliente.prop_GGESTADO_COD = ConfigurationManager.AppSettings("EstadoPC") Then
                    fpago = param.dame_param(ConfigurationManager.AppSettings("AMC_B2B_OBFP_OFERTAS"))
                    cabecera.prop_RSOCCONDI_COD = ""
                Else
                    fpago = cliente.prop_forma_pago.PROP_COD
                    cabecera.prop_RSOCCONDI_COD = cliente.prop_RSOCCONDI_DEF
                End If
            End If
            cabecera.prop_FORMA_DE_PAGO = fpago
            '-----FIN AMC_NE183----- FORMA DE PAGO DE PARAMETRO 
            '-----FIN CAMBIO AMC_NE213. LA FORMA DE PAGO PDTE PARA LAS OFERTAS SOLO PARA CLIENTES EN ESTADO PC O POT

            'calculo asociado, si por lo que sea a perdido los calculos miramos si tiene.
            Dim listado_calculos As New ArrayList
            listado_calculos = cabecera.prop_LISTADO_IDDISTRIBUCION
            If listado_calculos.Count = 0 Then
                Dim calc As New AMC_Proyectos_pkg.CCalculos()
                listado_calculos = calc.DameCalculosDeOferta(cabecera.prop_EMPGRUPO_COD, cabecera.prop_emp_cod, cabecera.prop_tip_Vc, cabecera.prop_ggofetip_cod, cabecera.prop_N_OFE, cabecera.prop_N_REVISION)
                cabecera.prop_LISTADO_IDDISTRIBUCION = listado_calculos
            End If

            Session("cabecera") = cabecera
        Catch ex As Exception
            Log.Error(ex, "[CrearOferta.guardar_info_cabecera] cab_ofe = {@cab_ofe} ", cabecera)
        End Try

    End Sub

    Protected Sub tboxAtte_TextChanged(sender As Object, e As EventArgs) Handles tboxAtte.TextChanged
        guardar_info_cabecera()
    End Sub

    Protected Sub tboxRefCli_TextChanged(sender As Object, e As EventArgs) Handles tboxRefCli.TextChanged
        guardar_info_cabecera()
    End Sub

    Protected Sub txtarea_observacion_TextChanged(sender As Object, e As EventArgs) Handles txtarea_observacion.TextChanged
        guardar_info_cabecera()
    End Sub

    Protected Sub txtarea_observacion_pie_TextChanged(sender As Object, e As EventArgs) Handles txtarea_observacion_pie.TextChanged
        guardar_info_cabecera()
    End Sub

    Protected Sub comboModosEnvio_SelectedIndexChanged(sender As Object, e As EventArgs) Handles comboModosEnvio.SelectedIndexChanged
        guardar_info_cabecera()
    End Sub
    Private Function conectar(ByVal usuario As String, ByVal password As String, ByVal bd As String) As IDbConnection
        If String.IsNullOrEmpty(bd) Then
            Return Nothing
        End If

        Dim b As New OleDbConnectionStringBuilder
        b.Provider = "MSDAORA.1"
        b("user id") = usuario
        b("password") = password
        b.DataSource = bd

        Dim conexion As IDbConnection = New OleDbConnection(b.ConnectionString)

        Try
            conexion.Open()
        Catch ex As Exception
            Log.Error(ex, "[CrearOferta.conectar] usu = {usu} pass = {pass} bdatos = {bdatos} ", usuario, password, bd)
            conexion.Dispose()
            Return Nothing
        End Try
        Return conexion
    End Function
    Private Sub GESTIONAR_FORMAS_DE_PAGO(ByVal cli As BCb2b.ggclipr, ByVal f_pago_cli As String)
        'AMC_NE243. JCE. 06/06/2016. FORMA DE PAGO INGENIEROS.
        Dim perfiles As New BCb2b.USUARIOS_B2B()
        perfiles.Administrar_Permisos_Perfiles(Session("perfil_usuario"))

        If perfiles.prop_TIPO_PERFIL = 0 Then 'SVT o ING
            'CARGAMOS EL COMBO DE FORMAS DE PAGO DE LA FICHA DEL AGENTE E INTRODUCIMOS LA DE A CONVENIR.
            Dim age As New BCb2b.gvagente(cli.prop_GVAGENTE_COD, ConfigurationManager.AppSettings("grupo"), 0)
            Dim obsProveedor As New BCb2b.GGCLIPROBS(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("compra"), age.prop_GGCLIPR_PROV, ConfigurationManager.AppSettings("OBFP"))
            Dim valor As String = obsProveedor.PROP_COMENTARIO

            Dim listaFPago As New ArrayList
            Dim arrayFPago As Array
            ddlFPago.Items.Clear()

            If valor <> "" Then
                arrayFPago = Split(valor, ",")
                Dim i As Integer = 0
                For i = 0 To arrayFPago.Length - 1
                    Dim fp As New BCb2b.CFPago()
                    If Session("idioma_spyro") <> "" Then
                        fp.DameDatosFPago(arrayFPago(i), Session("idioma_spyro"), ConfigurationManager.AppSettings("TRADUC_FPAGO_IDIOMASTAB"))
                    Else
                        fp = New BCb2b.CFPago(arrayFPago(i))
                    End If
                    listaFPago.Add(fp)
                Next i
            End If

            'SI NO HAY NINGUNA FORMA DE PAGO, PONEMOS LA DE A CONVENIR Y LA DEL CLIENTE.
            If listaFPago.Count = 0 Then
                Dim param As New BCb2b.CParametros()
                Dim fpago As String = param.dame_param(ConfigurationManager.AppSettings("AMC_B2B_OBFP_OFERTAS"))

                Dim forma_pago As New BCb2b.CFPago()
                forma_pago.DameDatosFPago(fpago, Session("idioma_spyro"), ConfigurationManager.AppSettings("TRADUC_FPAGO_IDIOMASTAB"))
                listaFPago.Insert(0, forma_pago)

                Dim forma_pago_cli As New BCb2b.CFPago()
                forma_pago_cli.DameDatosFPago(cli.prop_forma_pago.PROP_COD, Session("idioma_spyro"), ConfigurationManager.AppSettings("TRADUC_FPAGO_IDIOMASTAB"))
                listaFPago.Insert(0, forma_pago_cli)
            End If

            ddlFPago.DataSource = listaFPago
            ddlFPago.DataTextField = "prop_descrip"
            ddlFPago.DataValueField = "prop_cod"

            ddlFPago.Visible = True
            lblFormadepago.Visible = False
        Else
            'LO HABITUAL
            Dim forma_pago As New BCb2b.CFPago()
            forma_pago.DameDatosFPago(f_pago_cli, Session("idioma_spyro"), ConfigurationManager.AppSettings("TRADUC_FPAGO_IDIOMASTAB"))
            lblFormadepago.Text = forma_pago.PROP_DESCRIP
            ddlFPago.Visible = False
            lblFormadepago.Visible = True
        End If
        ddlFPago.DataBind()
    End Sub

    Protected Sub ddlFPago_SelectedIndexChanged(sender As Object, e As EventArgs) Handles ddlFPago.SelectedIndexChanged
        guardar_info_cabecera()
    End Sub
    Private Function OBTENER_SERIES_OFERTA() As ArrayList 'ESTÁNDAR
        Dim param As New BCb2b.CParametros()
        Dim series_ofe As String = param.dame_param(ConfigurationManager.AppSettings("SERIES_OFE_CRE"))
        Dim tipo_oferta As New BCb2b.CGGOfetip()
        Dim listado As ArrayList = tipo_oferta.listado_SerieOferta(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), series_ofe, "", "", "", Session("cadena_conexion"), Session("idioma_spyro"))
        Return listado
    End Function

    Protected Sub DDLSeries_SelectedIndexChanged(sender As Object, e As EventArgs) Handles DDLSeries.SelectedIndexChanged
        guardar_info_cabecera()
    End Sub
End Class
