﻿Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.OracleClient
Imports BCb2b.Enterlan
Imports System.Configuration.ConfigurationSettings
Imports System.Collections
Imports System.Collections.Generic
Imports System.Configuration
Imports System.Data.OleDb
Imports CTI.Utilities.Log

Partial Class LOV_precios_esp
    Inherits claseBase
    Private tboxOrigen As String
    Public misql, vsql As String
    Dim conn, conn2 As New OracleConnection()
    Dim conexion As New BCb2b.Enterlan.b2b.Cconexion()
    Dim command As New OracleDataAdapter()
    Dim sql, sql2 As String
    Shared tbox As String

    Private Function esFechaHastaCorrecta(fechaDesde As Nullable(Of Date), fechaHasta As Nullable(Of Date)) As Boolean
        If fechaHasta.HasValue Then
            Return Date.Compare(fechaDesde.Value, fechaHasta.Value) <= 0
        End If

        Return True
    End Function

    Protected Sub Page_Load(sender As Object, e As EventArgs) Handles Me.Load
        Ajax.Utility.RegisterTypeForAjax(GetType(LOV_precios_esp))

        Dim mensaje As New BCb2b.Utilities
        mensaje.HabilitarModalMessages(Me, GetLocalResourceObject("MsgModalBtnAceptar"))
        mensaje.CrearModalConfirm(Me, "DarDeBajaPrecio", GetLocalResourceObject("MsgModalBtnConfirm"), GetLocalResourceObject("MsgDarDeBaja"), GetLocalResourceObject("MsgModalBtnYes"), GetLocalResourceObject("MsgModalBtnNo"))
        mensaje.CrearModalConfirm(Me, "InsertarPrecio", GetLocalResourceObject("MsgModalBtnConfirm"), GetLocalResourceObject("MsgInsertarPrecio"), GetLocalResourceObject("MsgModalBtnYes"), GetLocalResourceObject("MsgModalBtnNo"))
        mensaje.CrearModalConfirm(Me, "ModificarPrecio", GetLocalResourceObject("MsgModalBtnConfirm"), GetLocalResourceObject("MsgModificarPrecio"), GetLocalResourceObject("MsgModalBtnYes"), GetLocalResourceObject("MsgModalBtnNo"))

        txtPrecio.Attributes.Add("onfocus", "javascript:return SetCursorToTextEnd(this.id);")

        If Not Page.IsPostBack Then
            'GGCLIPR_COD
            Try
                hdn_ggclipr_cod.Value = Request.QueryString("cli").ToString()
            Catch ex As Exception
                hdn_ggclipr_cod.Value = ""
            End Try

            'GAART_COD
            Try
                hdn_gaart_cod.Value = Request.QueryString("art").ToString()
            Catch ex As Exception
                hdn_gaart_cod.Value = ""
            End Try

            'CANT
            Try
                hdn_cant.Value = Request.QueryString("cant").ToString()
            Catch ex As Exception
                hdn_cant.Value = ""
            End Try

            'PRECIO
            Try
                hdn_prec.Value = Request.QueryString("prec").ToString()
            Catch ex As Exception
                hdn_prec.Value = ""
            End Try

            'SERIE
            Try
                hdn_tipo.Value = Request.QueryString("tipo").ToString()
            Catch ex As Exception
                hdn_tipo.Value = ""
            End Try

            Dim articulo_prueba As New BCb2b.CArticulo(ConfigurationManager.AppSettings("grupo"), hdn_gaart_cod.Value)
            Dim dd As String = articulo_prueba.descripcion_idiomas(ConfigurationManager.AppSettings("obstip_articulo_idiomas"), Session("idioma_spyro"))
            If dd <> "" Then
                If (dd = "Null") Then
                    dd = articulo_prueba.prop_descrip
                End If
            End If
            lblgaart_cod.Text = hdn_gaart_cod.Value
            lblgaart_desc.Text = dd

            Dim cli As New BCb2b.ggclipr(hdn_ggclipr_cod.Value, ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"))
            lblggclipr_cod.Text = cli.prop_COD
            lblggclipr_desc.Text = cli.prop_NOMBRE

            txtFechaDesde.Text = Now.ToShortDateString
            txtDesde.Text = hdn_cant.Value.ToString
            txtPrecio.Text = hdn_prec.Value.ToString

            CargarPrecios()
        End If
    End Sub
    Private Function conectar(ByVal usuario As String, ByVal password As String, ByVal bd As String) As IDbConnection
        If String.IsNullOrEmpty(bd) Then
            Return Nothing
        End If

        Dim b As New OleDbConnectionStringBuilder
        b.Provider = "MSDAORA.1"
        b("user id") = usuario
        b("password") = password
        b.DataSource = bd

        Dim conexion As IDbConnection = New OleDbConnection(b.ConnectionString)

        Try
            conexion.Open()
        Catch ex As Exception
            conexion.Dispose()
            Return Nothing
        End Try
        Return conexion
    End Function

    Protected Sub btninsertar_Click(sender As Object, e As EventArgs) Handles btninsertar.Click
        Dim conexionole As IDbConnection = conectar(ConfigurationManager.AppSettings("usuario"), ConfigurationManager.AppSettings("pass"), ConfigurationManager.AppSettings("bbdd"))
        Dim transaccion As IDbTransaction
        transaccion = conexionole.BeginTransaction

        RFVDesde.IsValid = (txtDesde.Text <> "")
        RFVDesde.Validate()
        RFVtxtPrecio.IsValid = (txtPrecio.Text <> "")
        RFVtxtPrecio.Validate()

        Dim nom_agen As String = ""
        If Not Session("agente") Is Nothing Then
            Dim age As New BCb2b.gvagente()
            age = Session("agente")
            nom_agen = age.prop_NOMBRE
        Else
            Dim usuario As New BCb2b.CUsrnom()
            If Not Session("usuario") Is Nothing Then
                usuario = Session("usuario")
            End If
            nom_agen = usuario.PROP_COD
        End If

        Dim obser As String = nom_agen & " " & Date.Now & " - " & txtDesde.Text & " " & lblGaunitip_ins.Text & " " & txtPrecio.Text & " " & hdn_tipo.Value

        Dim mensajeinfo As String = ""
        Dim mensajeerror As String = ""

        Dim fecha_desde As Nullable(Of DateTime) = Nothing
        Dim fecha_hasta As Nullable(Of DateTime) = Nothing
        If txtFechaDesde.Text <> "" Then
            fecha_desde = CDate(txtFechaDesde.Text)
        End If

        If txtFechaHasta.Text <> "" Then
            fecha_hasta = CDate(txtFechaHasta.Text)
        End If

        If esFechaHastaCorrecta(fecha_desde, fecha_hasta) Then
            Try
                Dim gp As New BCb2b.GGPRERES()
                Dim vSuRef As String = gp.obtenerSuRef(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), hdn_gaart_cod.Value, hdn_ggclipr_cod.Value)
                Dim vSuDescrip As String = gp.obtenerSuDescrip(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), hdn_gaart_cod.Value, hdn_ggclipr_cod.Value)
                AMC_NE053_PKG.AMC_NE053_PKG.INSERTA_PRECIO(transaccion, ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), CInt(hdn_ggclipr_cod.Value), hdn_gaart_cod.Value, fecha_desde, fecha_hasta, vSuRef, vSuDescrip, CDbl(txtDesde.Text), CDbl(txtPrecio.Text), obser, mensajeinfo, mensajeerror)
                transaccion.Commit()
                transaccion.Dispose()

                If mensajeerror <> "" Then
                    'MOSTRAR DIALOGO ERROR MODIFICANDO PRECIO.
                    ClientScript.RegisterClientScriptBlock(Me.GetType(), "PrecioInsErr", "ShowDialog('" & GetLocalResourceObject("MsgModalbtnAtencion") & "','" & mensajeerror & "','err_red','',300);", True)
                Else
                    'MOSTRAR DIALOGO DE PRECIO INSERTADO
                    ClientScript.RegisterClientScriptBlock(Me.GetType(), "PrecioInsOk", "ShowDialog('" & GetLocalResourceObject("MsgModalBtnCorrecto") & "','" & GetLocalResourceObject("MsgCorrectoPrecInsertado") & "','ok','',300);", True)
                End If

                CargarPrecios()

                'txtFechaDesde.Text = ""
                txtFechaHasta.Text = ""
                txtDesde.Text = ""
                txtPrecio.Text = ""
            Catch ex As Exception
                transaccion.Rollback()
                transaccion.Dispose()

                Log.Error(ex, "[Error insertando prec. especial]: cli={cli} art={art} f_des={f_des} f_has={f_has} desde={desde} prec={prec} ", hdn_ggclipr_cod.Value, hdn_gaart_cod.Value, fecha_desde, fecha_hasta, txtDesde.Text, txtPrecio.Text)

                'MOSTRAR DIALOGO ERROR
                ClientScript.RegisterClientScriptBlock(Me.GetType(), "PrecioInsErr", "ShowDialog('" & GetLocalResourceObject("MsgModalbtnAtencion") & "','[Error Insert Price] " & ex.Message & "','err_rojo','',300);", True)
            End Try
        Else
            ClientScript.RegisterClientScriptBlock(Me.GetType(), "PrecioInsErr", "ShowDialog('" & GetLocalResourceObject("MsgModalbtnAtencion") & "','" & GetLocalResourceObject("cmpDatesResource1.ErrorMessage") & "','err_red','',300);", True)
        End If
    End Sub

    Protected Sub btncancelar_Click(sender As Object, e As EventArgs) Handles btncancelar.Click
        'txtFechaDesde.Text = ""
        txtFechaHasta.Text = ""
        txtDesde.Text = ""
        txtPrecio.Text = ""

        CargarPrecios()
    End Sub
    Private Sub CargarPrecios()
        Dim respuesta As String
        Dim lista As New ArrayList
        Try
            Dim valores As New BCb2b.Precios_especiales()
            lista = valores.lista_precio_ofer(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), hdn_ggclipr_cod.Value, hdn_gaart_cod.Value)
        Catch escep As Exception
            respuesta = escep.Message()
        Finally
            RPTPreciosEsp.DataSource = lista
            RPTPreciosEsp.DataBind()
            UPPrecios.Update()
        End Try
    End Sub
    Protected Sub RPTPreciosEsp_PreRender(sender As Object, e As EventArgs) Handles RPTPreciosEsp.PreRender
        'ESTA GESTION ES PARA CALCULAR EL NUMERO DE LINEAS DE ESCALADOS PARA EL ROWSPAN DEL REPEATER.
        Dim i As Integer = 0
        Dim num_fechas_prec As Integer = 0
        While i < RPTPreciosEsp.Rows.Count
            num_fechas_prec = num_fechas_prec + 1
            Dim currentRepeaterItem As GridViewRow = RPTPreciosEsp.Rows(i)
            Dim currentRepeaterItemIndex As Integer = currentRepeaterItem.DataItemIndex
            Dim lblnum_reg_escal_prim As Label = currentRepeaterItem.FindControl("lblnum_reg_escal")
            lblnum_reg_escal_prim.Text = "1"

            Dim lblf_desde_act As Label = currentRepeaterItem.FindControl("lblf_desde")
            'Dim lblf_hasta_act As Label = currentRepeaterItem.FindControl("lblf_hasta")
            Dim tboxf_hasta_act As TextBox = currentRepeaterItem.FindControl("tboxf_hasta")
            Dim lbldesde As Label = currentRepeaterItem.FindControl("lbldesde")

            Dim nextRepeaterItem As GridViewRow = RPTPreciosEsp.Rows(i)
            Dim lblf_desde_sig As Label = nextRepeaterItem.FindControl("lblf_desde")
            'Dim lblf_hasta_sig As Label = nextRepeaterItem.FindControl("lblf_hasta")
            Dim tboxf_hasta_sig As TextBox = nextRepeaterItem.FindControl("tboxf_hasta")
            Dim lbldesde_sig As Label = nextRepeaterItem.FindControl("lbldesde")


            Dim resul As Boolean = CompruebaSiMarcarDeRojo(lblf_desde_act.Text, tboxf_hasta_act.Text, lbldesde.Text)
            If resul = True Then
                RPTPreciosEsp.Rows(i).Cells(3).CssClass = "error"
                RPTPreciosEsp.Rows(i).Cells(4).CssClass = "error"
                RPTPreciosEsp.Rows(i).Cells(5).CssClass = "error"
            End If

            Dim tboxprecio As TextBox = currentRepeaterItem.FindControl("tboxprecio")
            Dim btnguardar As ImageButton = currentRepeaterItem.FindControl("btnguardar")
            Dim btnbaja As ImageButton = currentRepeaterItem.FindControl("btnbaja")
            'If num_fechas_prec > 2 Then
            '    tboxprecio.Enabled = False
            '    tboxf_hasta_act.Enabled = False
            '    tboxf_hasta_sig.Enabled = False
            '    lblf_desde_act.Enabled = False
            '    btnguardar.Visible = False
            '    btnbaja.Visible = False
            'End If

            If i < RPTPreciosEsp.Rows.Count - 1 Then
                nextRepeaterItem = RPTPreciosEsp.Rows(i + 1)
                lblf_desde_sig = nextRepeaterItem.FindControl("lblf_desde")
                tboxf_hasta_sig = nextRepeaterItem.FindControl("tboxf_hasta")
                lbldesde_sig = nextRepeaterItem.FindControl("lbldesde")
            Else
                Exit While
            End If

            i = i + 1
            Dim cuenta As Integer = 1
            While lblf_desde_act.Text = lblf_desde_sig.Text And tboxf_hasta_act.Text = tboxf_hasta_sig.Text
                Dim lblnum_reg_escal_sig As Label = nextRepeaterItem.FindControl("lblnum_reg_escal")
                cuenta = cuenta + 1

                lblnum_reg_escal_sig.Text = ""
                lblnum_reg_escal_prim.Text = cuenta.ToString

                currentRepeaterItem.Cells(2).Style.Add("border-left", "1px solid #AAAAAA !important")
                nextRepeaterItem.Cells(2).Style.Add("border-left", "1px solid #AAAAAA !important")
                currentRepeaterItem.Cells(5).Style.Add("border-right", "1px solid #AAAAAA !important")
                nextRepeaterItem.Cells(5).Style.Add("border-right", "1px solid #AAAAAA !important")
                currentRepeaterItem.Cells(7).Style.Add("border-left", "1px solid #AAAAAA !important")
                nextRepeaterItem.Cells(7).Style.Add("border-left", "1px solid #AAAAAA !important")

                tboxprecio = nextRepeaterItem.FindControl("tboxprecio")
                btnguardar = nextRepeaterItem.FindControl("btnguardar")
                btnbaja = nextRepeaterItem.FindControl("btnbaja")

                nextRepeaterItem.Cells(0).Visible = False
                nextRepeaterItem.Cells(1).Visible = False
                'nextRepeaterItem.Cells(2).Visible = False

                If num_fechas_prec > 1 Then
                    tboxprecio.Enabled = False
                    lblf_desde_act.Enabled = False
                    tboxf_hasta_act.Enabled = False
                    tboxf_hasta_sig.Enabled = False
                    btnguardar.Visible = False
                    btnbaja.Visible = False
                    nextRepeaterItem.Cells(7).Visible = False
                Else
                    nextRepeaterItem.Cells(7).Visible = False
                End If

                resul = CompruebaSiMarcarDeRojo(lblf_desde_sig.Text, tboxf_hasta_sig.Text, lbldesde_sig.Text)
                If resul = True Then
                    RPTPreciosEsp.Rows(i).Cells(3).CssClass = "error"
                    RPTPreciosEsp.Rows(i).Cells(4).CssClass = "error"
                    RPTPreciosEsp.Rows(i).Cells(5).CssClass = "error"
                End If

                If i < RPTPreciosEsp.Rows.Count - 1 Then
                    nextRepeaterItem = RPTPreciosEsp.Rows(i + 1)

                    lblf_desde_sig = nextRepeaterItem.FindControl("lblf_desde")
                    tboxf_hasta_sig = nextRepeaterItem.FindControl("tboxf_hasta")
                    lbldesde_sig = nextRepeaterItem.FindControl("lbldesde")
                Else
                    Exit While
                End If
                i = i + 1
            End While

            If lblf_desde_act.Text <> lblf_desde_sig.Text Or tboxf_hasta_act.Text <> tboxf_hasta_sig.Text Then
                tboxprecio = nextRepeaterItem.FindControl("tboxprecio")
                btnguardar = nextRepeaterItem.FindControl("btnguardar")
                btnbaja = nextRepeaterItem.FindControl("btnbaja")

                tboxf_hasta_sig.Enabled = False
                lblf_desde_sig.Enabled = False
                lbldesde_sig.Enabled = False
                tboxprecio.Enabled = False
                lblf_desde_sig.Enabled = False
                tboxf_hasta_sig.Enabled = False
                tboxf_hasta_sig.Enabled = False
                btnguardar.Visible = False
                btnbaja.Visible = False
            End If


            currentRepeaterItem.Cells(0).RowSpan = lblnum_reg_escal_prim.Text
            currentRepeaterItem.Cells(1).RowSpan = lblnum_reg_escal_prim.Text
            'currentRepeaterItem.Cells(2).RowSpan = lblnum_reg_escal_prim.Text
            currentRepeaterItem.Cells(7).RowSpan = lblnum_reg_escal_prim.Text

        End While
    End Sub
    Protected Sub RPTPreciosEsp_RowCommand(sender As Object, e As GridViewCommandEventArgs) Handles RPTPreciosEsp.RowCommand
        If e.CommandName <> "Page" Then
            Try
                Dim fila As GridViewRow
                fila = RPTPreciosEsp.SelectedRow
                Dim ind As Integer
                Integer.TryParse(e.CommandArgument, ind)
                fila = RPTPreciosEsp.Rows(ind)

                Dim f_desde As Label = fila.FindControl("lblf_desde")
                'Dim f_hasta As Label = fila.FindControl("lblf_hasta")
                Dim f_hasta As TextBox = fila.FindControl("tboxf_hasta")
                Dim desde As Label = fila.FindControl("lbldesde")
                Dim unidad As Label = fila.FindControl("lblunidad")
                Dim tboxprecio As TextBox = fila.FindControl("tboxprecio")

                Dim conexionole As IDbConnection = conectar(ConfigurationManager.AppSettings("usuario"), ConfigurationManager.AppSettings("pass"), ConfigurationManager.AppSettings("bbdd"))
                Dim transaccion As IDbTransaction
                transaccion = conexionole.BeginTransaction

                Dim nom_agen As String = ""
                If Not Session("agente") Is Nothing Then
                    Dim age As New BCb2b.gvagente()
                    age = Session("agente")
                    nom_agen = age.prop_NOMBRE
                Else
                    Dim usuario As New BCb2b.CUsrnom()
                    If Not Session("usuario") Is Nothing Then
                        usuario = Session("usuario")
                    End If
                    nom_agen = usuario.PROP_COD
                End If

                Dim obser As String = nom_agen & " " & Date.Now & " - " & desde.Text & " " & unidad.Text & " " & tboxprecio.Text & " " & "OFEW"

                Dim mensajeinfo As String = ""
                Dim mensajeerror As String = ""

                Dim fecha_desde As Nullable(Of DateTime) = Nothing
                Dim fecha_hasta As Nullable(Of DateTime) = Nothing
                If f_desde.Text <> "" Then
                    fecha_desde = CDate(f_desde.Text)
                End If

                If f_hasta.Text <> "" Then
                    fecha_hasta = CDate(f_hasta.Text)
                End If

                Try
                    Select Case e.CommandName
                        Case "guardar"
                            Dim gp As New BCb2b.GGPRERES()
                            Dim vSuRef As String = gp.obtenerSuRef(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), hdn_gaart_cod.Value, hdn_ggclipr_cod.Value)
                            Dim vSuDescrip As String = gp.obtenerSuDescrip(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), hdn_gaart_cod.Value, hdn_ggclipr_cod.Value)
                            AMC_NE053_PKG.AMC_NE053_PKG.INSERTA_PRECIO(transaccion, ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), CInt(hdn_ggclipr_cod.Value), hdn_gaart_cod.Value, fecha_desde, fecha_hasta, vSuRef, vSuDescrip, CDbl(desde.Text), CDbl(tboxprecio.Text), obser, mensajeinfo, mensajeerror)
                        Case "baja"
                            fecha_hasta = CDate(Now.ToShortDateString)
                            obser = obser & " BORRADO"
                            'REVISAR JCE: ESTO??
                            '   AMC_NE053.Amc_ne053_pkg.INSERTA_PRECIO(transaccion, ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), CInt(hdn_ggclipr_cod.Value), hdn_gaart_cod.Value, fecha_desde, fecha_hasta, "", "", CDbl(desde.Text), CDbl(tboxprecio.Text), obser, mensajeinfo, mensajeerror)
                            AMC_NE053_PKG.AMC_NE053_PKG.ELIMINAR_PRECIO(transaccion, ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), CInt(hdn_ggclipr_cod.Value), hdn_gaart_cod.Value, fecha_desde, fecha_hasta, CDbl(desde.Text), CDbl(tboxprecio.Text), obser, mensajeinfo, mensajeerror)
                    End Select

                    transaccion.Commit()
                    transaccion.Dispose()

                    If mensajeerror <> "" Then
                        'MOSTRAR DIALOGO ERROR MODIFICANDO PRECIO.
                        ClientScript.RegisterClientScriptBlock(Me.GetType(), "PrecioModErr", "ShowDialog('" & GetLocalResourceObject("MsgModalbtnAtencion") & "','" & mensajeerror & "','err_red','',300);", True)
                    Else
                        Select Case e.CommandName
                            Case "guardar"
                                'MOSTRAR DIALOGO DE PRECIO MODIFICADO
                                ClientScript.RegisterClientScriptBlock(Me.GetType(), "PrecioModOk", "ShowDialog('" & GetLocalResourceObject("MsgModalBtnCorrecto") & "','" & GetLocalResourceObject("MsgCorrectoPrecModificado") & "','ok','',300);", True)
                            Case "baja"
                                'MOSTRAR DIALOGO DE PRECIO DE BAJA
                                ClientScript.RegisterClientScriptBlock(Me.GetType(), "PrecioBajaOk", "ShowDialog('" & GetLocalResourceObject("MsgModalBtnCorrecto") & "','" & GetLocalResourceObject("MsgCorrectoPrecBaja") & "','ok','',300);", True)
                        End Select
                    End If

                    CargarPrecios()
                Catch ex As Exception
                    transaccion.Rollback()
                    transaccion.Dispose()

                    Log.Error(ex, "[Error insertando prec. especial]: cli={cli} art={art} f_des={f_des} f_has={f_has} desde={desde} prec={prec} ", hdn_ggclipr_cod.Value, hdn_gaart_cod.Value, fecha_desde, fecha_hasta, desde.Text, tboxprecio.Text)
                End Try
            Catch ex As Exception
                lblerror.Text = ex.Message.ToString
            End Try
        End If


    End Sub
    Private Function CompruebaSiMarcarDeRojo(ByVal f_desde As String, ByVal f_hasta As String, ByVal desde As String) As Boolean
        Dim resul As Boolean = False

        If txtFechaDesde.Text <> "" Then
            'SI COINCIDEN CANTIDAD Y FECHA DESDE AFECTARA A LA FILA CON DICHA CANTIDAD Y DICHA FECHA DESDE.
            If desde = txtDesde.Text And CDate(f_desde) = CDate(txtFechaDesde.Text) Then
                resul = True
            End If

            'SI COINCIDEN EN FECHA DESDE Y FECHA HASTA ES DISTINTO DE NADA AFECTARÁ A TODAS LAS FILAS CON DICHA FECHA DESDE.
            If CDate(f_desde) = txtFechaDesde.Text And txtFechaHasta.Text <> "" Then
                resul = True
            End If
        End If

        Return resul
    End Function

    Protected Sub txtDesde_TextChanged(sender As Object, e As EventArgs) Handles txtDesde.TextChanged
        CargarPrecios()
        txtPrecio.Focus()
    End Sub

    Protected Sub btnAceptar_Click(sender As Object, e As EventArgs) Handles btnAceptar.Click
        'CERRAMOS ACTUAL
        Dim script(3) As String
        script(0) = "<script>"
        script(1) = "self.close();"
        script(2) = "</" + "script>"
        Dim KK As String = Join(script, "")
        ClientScript.RegisterClientScriptBlock(Me.GetType, "Cerrar", Join(script, ""))
    End Sub

    Protected Sub btninsertar_Click(sender As Object, e As ImageClickEventArgs) Handles btninsertar.Click

    End Sub
End Class
