﻿Imports System.Data
Imports System.Data.OracleClient

Partial Class PedidoConsulta
    Inherits claseBase
    Private NPED As String
    Private TIPOPED As String
    Private EMPRESA As String
    Private GRUPO As String
    Private TIPVC As String

    Public ReadOnly Property PROP_N_PED_SEL() As String
        Get
            Return Me.NPED
        End Get
    End Property
    Public ReadOnly Property PROP_TIPO_PED_SEL() As String
        Get
            Return Me.TIPOPED
        End Get
    End Property
    Public ReadOnly Property PROP_EMPRESA() As String
        Get
            Return Me.EMPRESA
        End Get
    End Property
    Public ReadOnly Property PROP_GRUPO() As String
        Get
            Return Me.GRUPO
        End Get
    End Property
    Public ReadOnly Property PROP_TIPVC() As String
        Get
            Return Me.TIPVC
        End Get
    End Property

    Protected Overrides Sub InitializeCulture()
        Dim culture As String = ""

        If Not Page.IsPostBack Then
            Dim IDIOMA As String = ""
            If Not Session("idioma") Is Nothing Then
                If (Session("idioma").ToString <> "") Then
                    IDIOMA = Session("idioma")
                End If
            Else
                Session("idioma") = ConfigurationManager.AppSettings("IDIOMA_DEFECTO")
                IDIOMA = Session("IDIOMA")
            End If
            Select Case IDIOMA
                Case ConfigurationManager.AppSettings("CAS_SPYRO")
                    culture = "es-ES"
                Case ConfigurationManager.AppSettings("ING_SPYRO")
                    culture = "en-GB"
                Case ConfigurationManager.AppSettings("FRA_SPYRO")
                    culture = "fr-FR"
                Case Else
                    culture = ConfigurationManager.AppSettings("IDIOMA_DEFECTO")
            End Select
        End If



        Session("cultura") = culture
        culture = Session("cultura").ToString


        ' Aqui ponemos tambien lo botones adecuados y la imagen del logo.
        ' y el calendario.

        If (String.IsNullOrEmpty(culture)) Then
            culture = "Auto"
            'Use this
            UICulture = culture
            culture = culture
        End If
        'OR This
        If (culture <> "Auto") Then
            Dim ci As New System.Globalization.CultureInfo(culture)
            System.Threading.Thread.CurrentThread.CurrentCulture = ci
            System.Threading.Thread.CurrentThread.CurrentUICulture = ci
        End If
        MyBase.InitializeCulture()

    End Sub
    Public Sub OpenPopUp(ByVal opener As System.Web.UI.WebControls.WebControl, ByVal PagePath As String, ByVal windowName As String, ByVal width As Integer, ByVal height As Integer)
        Dim vclientScript As String
        Dim windowAttribs As String
        windowAttribs = "width=" & width & "px," & _
                    "height=" & height & "px," & _
                    "left='+((screen.width -" & width & ") / 2)+'," & _
                    "top='+ (screen.height - " & height & ") / 2+'"
        vclientScript = "window.open('" & PagePath & "','" & windowName & "','" & windowAttribs & "');return false;"
        opener.Attributes.Add("onClick", vclientScript)

    End Sub

    Public Sub ShowLupa(ByVal opener As System.Web.UI.WebControls.WebControl, ByVal tboxclientecod As System.Web.UI.WebControls.TextBox, ByVal tboxcliente As System.Web.UI.WebControls.TextBox)
        OpenPopUp(opener, "lov_cliente.aspx?textbox=" & tboxclientecod.ClientID & "&textbox2=" & tboxcliente.ClientID & "&textboxtieneclasi=" & tboxclientecod.Text, "LOV", 410, 600)
    End Sub

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        div_lblerror.Visible = False

        Session("lineasPedido") = New List(Of BCb2b.CLineaPedidoOff)
        Session("lineasOferta") = New List(Of BCb2b.COferta_linOff)
        Session("cabeceraPed") = Nothing
        Session("cabecera") = Nothing

        'HABILITAMOS LOS MENSAJES MODALES
        Dim mensaje As New BCb2b.Utilities
        mensaje.HabilitarModalMessages(Me, GetLocalResourceObject("MsgModalBtnAceptar"))
        mensaje.CrearModalConfirm(Me, "BorrarPedido", GetLocalResourceObject("MsgModalBtnConfirm"), GetLocalResourceObject("ElimPedido.Text"), GetGlobalResourceObject("general", "MsgModalBtnYes"), GetGlobalResourceObject("general", "MsgModalBtnNo"))

        Dim perfiles As New BCb2b.USUARIOS_B2B()
        perfiles.Administrar_Permisos_Perfiles(Session("tipo_usuario"))
        If perfiles.prop_TIPO_PERFIL = 2 Then 'cli
            LBLTODOSTITU.CssClass = "oculto"
            checkboxTODOS.CssClass = "oculto"
            IBCliente.CssClass = "oculto"
            ImgBTCliente.CssClass = "oculto"
            tboxClienteCod.Enabled = False
            tboxCliente.Enabled = False
            GVPedidos.Columns(13).Visible = False 'SITUACION DE PEDIDO
        End If

        'btonVerPedidos.Attributes.Add("onMouseOver", "this.src = '" + GetLocalResourceObject("btonVerPedidos_r1") + "';")
        'btonVerPedidos.Attributes.Add("onMouseOut", "this.src = '" + GetLocalResourceObject("btonVerPedidos_r2") + "';")
        'btonVerPedidos.ImageUrl = GetLocalResourceObject("btonVerPedidos_r2")

        'tboxClienteCod.Attributes.Add("onkeyup", "javascript:comprobar_cliente('" & ConfigurationManager.AppSettings("grupo") & "','" & ConfigurationManager.AppSettings("venta") & "','" & tboxClienteCod.ClientID & "','" & tboxCliente.ClientID & "','" & Session("agente").prop_cod & "');")

        ShowLupa(IBCliente, tboxClienteCod, tboxCliente)

        If (Not Session("cliente") Is Nothing) Then
            'Datos de la cabecera.
            lblNombreCli.Text = Session("cliente").prop_nombre
            lblPortes.Text = Session("cliente").prop_portes_pd
            lblRSocial.Text = Session("cliente").prop_rsocial_cod
            lblAgencia.Text = Session("cliente").prop_GGMENVIO_DESC
        Else
            If perfiles.prop_TIPO_PERFIL = 0 Then 'ing svt
                checkboxTODOS.Checked = True
            Else
                Response.Redirect("BusquedaClientes.aspx", True)
            End If

        End If
        'XXX
        If Not Page.IsPostBack Then
            If (Not Session("cliente") Is Nothing) Then
                tboxClienteCod.Text = Session("cliente").prop_cod
                tboxCliente.Text = Session("cliente").prop_nombre
            End If

            ShowLupa(IBCliente, tboxClienteCod, tboxCliente)
            'TODO, CAMBIAR VARIABLE DE SESION USUARIO.
            Dim PARAMETRO As New BCb2b.empparam(ConfigurationManager.AppSettings("B2B_PED_VISUALIZAR"), GRUPO, EMPRESA, Session("USUARIOB2B").PROP_COD)

            Dim serie_request As String = ""
            Try
                Dim c As New CTI.Utilities.MD5.MD5Checker()
                If c.CompareUrl(Request.Url.Query) Then
                    serie_request = Request.QueryString("serie").ToUpper
                Else
                    serie_request = ""
                End If
            Catch ex As Exception
                serie_request = ""
            End Try

            Dim CODIGOS_SI As String = serie_request
            Dim CODIGOS_no As String = ""
            If serie_request = "" Then
                CODIGOS_SI = PARAMETRO.prop_VALOR
            End If

            Dim tipo_pedido As New BCb2b.CGGpedtip()
            'Dim listado As ArrayList = tipo_pedido.listado_SeriepEDIDO(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), CODIGOS_SI, CODIGOS_no, GetLocalResourceObject("todas").ToString(), "", Session("cadena_conexion"))
            Dim listado As ArrayList = tipo_pedido.listado_SeriePedido_traduc(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), CODIGOS_SI, CODIGOS_no, GetLocalResourceObject("todas").ToString(), "", Session("cadena_conexion"), ConfigurationManager.AppSettings("NOMTABLA_TRADUC_SERIES_PED"), ConfigurationManager.AppSettings("NOMCOLUMNA_TRADUC_SERIES_PED"), Session("idioma_spyro"))
            DDLSerie.DataSource = listado
            DDLSerie.DataBind()

            If serie_request = "" Then
                DDLSerie.SelectedIndex = 0
                DDLSerie.Enabled = True
            Else
                DDLSerie.SelectedValue = serie_request
                DDLSerie.Enabled = False
            End If

            Dim listado_historico As New ArrayList()
            Dim tipo_vigente As New BCb2b.CGGpedtip("N", GetLocalResourceObject("Vigente"))
            Dim tipo_historico As New BCb2b.CGGpedtip("S", GetLocalResourceObject("Historico"))
            Dim tipo_todas As New BCb2b.CGGpedtip("", GetLocalResourceObject("Todas"))
            listado_historico.Add(tipo_vigente)
            listado_historico.Add(tipo_historico)
            listado_historico.Add(tipo_todas)
            DDLHistorico.DataSource = listado_historico
            DDLHistorico.DataBind()
            DDLHistorico.SelectedValue = "N"

            Dim listado_busqueda_por As New ArrayList()
            Dim tipo_fecha_expedicion As New BCb2b.CGGpedtip("E", GetLocalResourceObject("Fecha_expedicion"))
            Dim tipo_fecha_confirmada As New BCb2b.CGGpedtip("C", GetLocalResourceObject("Fecha_confirmada"))
            Dim tipo_fecha_pedido As New BCb2b.CGGpedtip("P", GetLocalResourceObject("Fecha_pedido"))
            listado_busqueda_por.Add(tipo_fecha_pedido)
            listado_busqueda_por.Add(tipo_fecha_expedicion)
            listado_busqueda_por.Add(tipo_fecha_confirmada)
            DDLBusquedaPor.DataSource = listado_busqueda_por
            DDLBusquedaPor.DataBind()

            'Dim mi_agente As String = Session("AGENTE").prop_cod()
            'Dim clientes As New BCb2b.ggclipr()
            'Dim listado_clientes As ArrayList = clientes.listado_Clientes(ConfigurationManager.AppSettings("grupo"), "", "", "", ConfigurationManager.AppSettings("Filtro_cliente_agente"), ConfigurationManager.AppSettings("venta"), mi_agente, Session("empresa").prop_cod, "S")

            ''FECHAS PRECARGADAS.
            'Dim dia, mes, mesant, año, añoant As String
            'dia = Now.Day
            'mes = Now.Month
            'mesant = Now.Month - 1
            'año = Now.Year
            'añoant = Now.Year
            'If mes < 10 Then
            '    mes = "0" & mes
            'End If

            ''ESTO CONTROLA SI ES ENERO QUE BUSQUE EN DICIEMBRE DEL AÑO ANTERIOR.
            'If mesant < 10 And mesant > 0 Then
            '    mesant = "0" & mesant
            'ElseIf mesant = 0 Then
            '    mesant = "12"
            '    añoant = año - 1
            'End If

            'tboxFdesde.Text = dia & "/" & mesant & "/" & añoant
            'tboxFHasta.Text = dia & "/" & mes & "/" & año

            GVPedidos.VirtualItemCount = GetRowCount()
            BindPagingGrid()
        End If
    End Sub

    Protected Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click

        GVPedidos.VirtualItemCount = GetRowCount()
        BindPagingGrid()
    End Sub



    Protected Sub GVPedidos_PageIndexChanging(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewPageEventArgs) Handles GVPedidos.PageIndexChanging
        GVPedidos.PageIndex = e.NewPageIndex
        BindPagingGrid()
    End Sub

    Protected Sub GVPedidos_RowCommand(sender As Object, e As GridViewCommandEventArgs) Handles GVPedidos.RowCommand
        If e.CommandName <> "Page" Then
            Try
                Dim fila As GridViewRow
                fila = GVPedidos.SelectedRow
                Dim ind As Integer
                Integer.TryParse(e.CommandArgument, ind)
                fila = GVPedidos.Rows(ind)

                Dim Pkey As DataKeyArray = GVPedidos.DataKeys

                Dim DetalleGrupo As String = Pkey.Item(ind).Item(0)
                Dim DetalleEmpresa As String = Pkey.Item(ind).Item(1)
                Dim DetalleTIPVC As String = Pkey.Item(ind).Item(2)
                Dim tipo_ped As String = Pkey.Item(ind).Item(3)
                Dim n_pedido As String = Pkey.Item(ind).Item(4)

                Me.NPED = n_pedido
                Me.TIPOPED = tipo_ped
                Me.GRUPO = DetalleGrupo
                Me.EMPRESA = DetalleEmpresa
                Me.TIPVC = DetalleTIPVC

                If (e.CommandName = "ver") Then

                    Server.Transfer("PedidoDetalle.aspx")
                    'Response.Redirect("PedidoDetalle.aspx")

                ElseIf (e.CommandName = "revisar") Then

                    'METER LA COMPROBACIÓN DE SI ES REVISABLE O NO.
                    Dim vPedModificable As Boolean = False
                    If Me.GRUPO <> "" And Me.EMPRESA <> "" And Me.TIPVC <> "" And Me.TIPOPED <> "" And Me.NPED <> "" Then
                        'ESTANDAR.
                        vPedModificable = BCb2b.GGPEDCAB.PED_PERMITE_REV(Me.GRUPO, Me.EMPRESA, Me.TIPVC, Me.TIPOPED, Me.NPED, _
                                                                                         ConfigurationManager.AppSettings("usuario"), ConfigurationManager.AppSettings("pass"), _
                                                                                         ConfigurationManager.AppSettings("bbdd"))
                        'AMC A MEDIDA.
                        If vPedModificable Then
                            vPedModificable = Not BCb2b_AMC.GGPEDCAB.PEDIDO_B2B_REVISADO_AMC(Me.GRUPO, Me.EMPRESA, Me.TIPVC, Me.TIPOPED, Me.NPED, _
                                                                                         ConfigurationManager.AppSettings("usuario"), ConfigurationManager.AppSettings("pass"), _
                                                                                         ConfigurationManager.AppSettings("bbdd"))
                        End If

                        Dim pedidoBorradoOK_KO As String = GetGlobalResourceObject("general", "SinPermisoEnDoc")
                        If Not vPedModificable Then
                            ScriptManager.RegisterStartupScript(Me, Me.GetType(), "RevisarPedido", "ShowDialog('" & GetGlobalResourceObject("general", "MsgModalBtnCorrecto") & "','" & pedidoBorradoOK_KO & "','ok','PedidoConsulta.aspx',300);", True)
                            Exit Sub 'QUE NO SE SIGA EJECUTANDO EL CÓDIGO.
                        End If

                    End If
                    'FIN COMPROBACIÓN.


                    Session("lineasPedido") = New List(Of BCb2b.CLineaPedidoOff)
                    '    cogemos los datos del pedido que estamos modificando , en caso de que no estemos modificando no creamos esto.
                    Dim cabeceraPedido As New BCb2b.CCabeceraPedido(Me.GRUPO, Me.EMPRESA, Me.TIPVC, Me.TIPOPED, Me.NPED)
                    Session("cabeceraPed") = cabeceraPedido

                    'PRIMERO MIRO SE HAY OBCW Y SINO HAY MIRO SI HAY OBSA --> OBCW meten los clis, OBSA meten los agentes.
                    Dim obs As New BCb2b.CObs_pedido(Me.GRUPO, Me.EMPRESA, Me.TIPVC, Me.TIPOPED, Me.NPED, System.Configuration.ConfigurationManager.AppSettings("Obs_transporte_pedidos_cliente"))
                    If obs.prop_OBSER <> "" Then
                        Session("cabeceraPed").prop_observacion_Defecto = obs.prop_OBSER
                    Else
                        obs = New BCb2b.CObs_pedido(Me.GRUPO, Me.EMPRESA, Me.TIPVC, Me.TIPOPED, Me.NPED, System.Configuration.ConfigurationManager.AppSettings("Obs_transporte_pedidos"))
                        Session("cabeceraPed").prop_observacion_Defecto = obs.prop_OBSER
                    End If

                    'observacion int
                    Dim obs_int As New BCb2b.CObs_pedido(Me.GRUPO, Me.EMPRESA, Me.TIPVC, Me.TIPOPED, Me.NPED, System.Configuration.ConfigurationManager.AppSettings("Obs_interna_pedidos"))
                    Session("cabeceraPed").prop_OBSERVACION_interna = obs_int.prop_OBSER


                    Dim lineasPedidoModificar As List(Of BCb2b.CLineaPedidoOff)
                    Dim pedi As New BCb2b.CLineaPedidoOff()
                    Dim param As New BCb2b.CParametros()
                    lineasPedidoModificar = pedi.lista_lineas_modificar(Me.GRUPO, Me.EMPRESA, Me.TIPVC, Me.TIPOPED, Me.NPED, "", param.dame_param(ConfigurationManager.AppSettings("B2B_ART_COMI_AGENTES")))
                    Session("lineasPedido") = lineasPedidoModificar

                    'SI EL PEDIDO ES PEDWZ O PEDZ ES DE REAPROVISIONA
                    Session("es_reaprovision") = "N"
                    If Session("cabeceraPed").prop_GGPEDTIP_COD = ConfigurationManager.AppSettings("tipo_pedido_reaprovisiona") Or Session("cabeceraPed").prop_GGPEDTIP_COD = ConfigurationManager.AppSettings("tipo_pedido_reaprovisiona_amc") Then
                        Session("es_reaprovision") = "S"
                    End If

                    Response.Redirect("CrearPedido.aspx")
                ElseIf (e.CommandName = "eliminar") Then
                    Dim conexion As IDbConnection = BCb2b.cconexion_ole.conectar(ConfigurationManager.AppSettings("usuario"), ConfigurationManager.AppSettings("pass"), ConfigurationManager.AppSettings("bbdd"))
                    Dim transaccion As IDbTransaction
                    transaccion = conexion.BeginTransaction

                    'AQUI ELIMINAREMOS EL PEDIDO
                    Dim msginfo, msgerror As String
                    msgerror = ""
                    msginfo = ""

                    CS_B2B_PED_PKG.CS_B2B_PED_PKG.BORRAR_REVISION(transaccion, ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("empresa"), ConfigurationManager.AppSettings("venta"), Me.TIPOPED, Me.NPED, "S", msginfo, msgerror)
                    transaccion.Commit()
                    conexion.Close()
                    conexion.Dispose()

                    Dim pedidoBorradoOK_KO As String = GetLocalResourceObject("MsgModalBorrarPedidoOk")
                    If (msgerror <> "") Then
                        pedidoBorradoOK_KO = GetGlobalResourceObject("general", "MsgModalBtnInCorrecto")
                    End If

                    'MOSTRAR DIALOGO PEDIDO BORRADO
                    ScriptManager.RegisterStartupScript(Me, Me.GetType(), "BorrarPedido", "ShowDialog('" & GetGlobalResourceObject("general", "MsgModalBtnCorrecto") & "','" & pedidoBorradoOK_KO & "','ok','PedidoConsulta.aspx',300);", True)
                Else
                    If (e.CommandName <> "Page") Then

                        Response.Redirect("PedidoDetalle.aspx", False)

                    End If
                End If

            Catch ex As Exception
                lblerror.Text = ex.Message.ToString
                div_lblerror.Visible = True
            End Try
        End If
    End Sub

    Protected Sub GVPedidos_RowDataBound(sender As Object, e As GridViewRowEventArgs) Handles GVPedidos.RowDataBound
        If e.Row.RowType = DataControlRowType.DataRow Then
            Dim Pkey As DataKeyArray = GVPedidos.DataKeys
            Dim DetalleGrupo As String = Pkey.Item(e.Row.RowIndex).Item(0)
            Dim DetalleEmpresa As String = Pkey.Item(e.Row.RowIndex).Item(1)
            Dim DetalleTIPVC As String = Pkey.Item(e.Row.RowIndex).Item(2)
            Dim tipo_ped As String = Pkey.Item(e.Row.RowIndex).Item(3)
            Dim n_pedido As String = Pkey.Item(e.Row.RowIndex).Item(4)

            Dim vPedModificable As Boolean = False
            'ESTANDAR
            vPedModificable = BCb2b.GGPEDCAB.PED_PERMITE_REV(DetalleGrupo, DetalleEmpresa, DetalleTIPVC, tipo_ped, n_pedido, _
                                                                                 ConfigurationManager.AppSettings("usuario"), ConfigurationManager.AppSettings("pass"), _
                                                                                 ConfigurationManager.AppSettings("bbdd"))
            'AMC A MEDIDA.
            If vPedModificable Then
                vPedModificable = Not BCb2b_AMC.GGPEDCAB.PEDIDO_B2B_REVISADO_AMC(DetalleGrupo, DetalleEmpresa, DetalleTIPVC, tipo_ped, n_pedido, _
                                                                                ConfigurationManager.AppSettings("usuario"), ConfigurationManager.AppSettings("pass"), _
                                                                                ConfigurationManager.AppSettings("bbdd"))
            End If

            'SOLO SE PUEDEN EDITAR LAS QUE SON DE TIPO OFEW Y QUE SEAN MODIFICABLES
            Dim perfiles As New BCb2b.USUARIOS_B2B()
            perfiles.Administrar_Permisos_Perfiles(Session("tipo_usuario"))
            If vPedModificable Then
                e.Row.Cells(16).CssClass = e.Row.Cells(16).CssClass.Replace("oculto", "") 'CAMPO EDITAR
                e.Row.Cells(17).CssClass = e.Row.Cells(17).CssClass.Replace("oculto", "") 'CAMPO ELIMINAR
            End If
        End If
    End Sub

    Protected Sub GVPedidos_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles GVPedidos.SelectedIndexChanged

        Try
            Dim fila As GridViewRow
            fila = GVPedidos.SelectedRow

            Dim Pkey As DataKeyArray = GVPedidos.DataKeys


            Dim DetalleGrupo As String = Pkey.Item(GVPedidos.SelectedIndex).Item(0)
            Dim DetalleEmpresa As String = Pkey.Item(GVPedidos.SelectedIndex).Item(1)
            Dim DetalleTIPVC As String = Pkey.Item(GVPedidos.SelectedIndex).Item(2)
            Dim tipo_ped As String = Pkey.Item(GVPedidos.SelectedIndex).Item(3)
            Dim n_pedido As String = fila.Cells(1).Text
            Me.NPED = n_pedido
            Me.TIPOPED = tipo_ped
            Me.GRUPO = DetalleGrupo
            Me.EMPRESA = DetalleEmpresa
            Me.TIPVC = DetalleTIPVC

            'Vamos al detalle
            Server.Transfer("PedidoDetalle.aspx")
        Catch ex As Exception
            lblerror.Text = ex.Message.ToString
            div_lblerror.Visible = True
        End Try

    End Sub

    '::::::::. nuevo desarrollo

    Private Function GetRowCount() As Integer

        Dim vEMPGRUPO_COD As String = ConfigurationManager.AppSettings("grupo")
        Dim vemp_COD As String = ConfigurationManager.AppSettings("empresa")
        Dim vtip_vc As String = ConfigurationManager.AppSettings("venta")
        Dim vggPEDtip_cod As String = DDLSerie.SelectedValue
        Dim vhistorico As String = DDLHistorico.SelectedValue
        Dim vbusqueda_por As String = DDLBusquedaPor.SelectedValue


        'Dim vn_PED As OracleNumber = OracleNumber.Null
        Dim vn_PED As String = ""
        If (tboxNPedido.Text <> "") Then
            vn_PED = tboxNPedido.Text.Trim
        End If

        Dim vsuref As String = tboxSuRef.Text

        Dim vcodcli As String = ""
        If Not Session("cliente") Is Nothing Then
            vcodcli = Session("cliente").prop_COD
        Else
            vcodcli = tboxClienteCod.Text
        End If

        'Dim vhist_sn As String = "N"
        'If (checkboxHistorico.Checked) Then
        '    vhist_sn = "S"
        'End If
        Dim vtodos_sn As String = "N"
        If (checkboxTODOS.Checked) Then
            vtodos_sn = "S"
        End If

        ' Dim vfecha_inicio As OracleDateTime
        Dim vfecha_inicio As String
        Try
            'vfecha_inicio = OracleDateTime.Parse(tboxFdesde.Text)
            vfecha_inicio = tboxFdesde.Text
        Catch ex As Exception
            ' vfecha_inicio = OracleDateTime.Null
            vfecha_inicio = ""
        End Try

        'Dim vfecha_fin As OracleDateTime
        Dim vfecha_fin As String
        Try
            ' vfecha_fin = OracleDateTime.Parse(tboxFHasta.Text)
            vfecha_fin = tboxFHasta.Text
        Catch ex As Exception
            '  vfecha_fin = OracleDateTime.Null
            vfecha_fin = ""
        End Try
        Dim FILTRO_CLIENTES As String = ConfigurationManager.AppSettings("Filtro_Cliente")

        Dim vpublicos_sn As String = ConfigurationManager.AppSettings("publicos") 'TODO JVC, ESTO REALMENTE NO EXISTE NO SE QUE COÑO HACE AQUÍ.
        Dim elemento As New BCb2b.GGPEDCAB()


        Dim VAGENTE As String
        If Not Session("AGENTE") Is Nothing Then
            VAGENTE = Session("AGENTE").prop_cod()

            If Session("AGENTE").PROP_COD <> "" Then
                FILTRO_CLIENTES = Session("ver_clientes")
            End If

        Else
            VAGENTE = ""
            FILTRO_CLIENTES = Session("ver_clientes")
        End If

        Dim PARAMETRO As New BCb2b.empparam(ConfigurationManager.AppSettings("B2B_PED_VISUALIZAR"), vEMPGRUPO_COD, vemp_COD, Session("USUARIOB2B").PROP_COD)
        Dim VSERIES_SI As String = PARAMETRO.prop_VALOR

        Dim VSERIES_NO As String = ""
        Dim vfiltro_docum As String = ConfigurationManager.AppSettings("Filtro_documentos")
        Dim elcodcli As String = ""
        elcodcli = vcodcli
        If (Not tboxClienteCod.Text = "") Then
            elcodcli = tboxClienteCod.Text
        End If

        Dim total As Integer = elemento.lista_cabeceras_pedidos_cuantos(vEMPGRUPO_COD, vemp_COD, vtip_vc, vggPEDtip_cod, vn_PED, elcodcli, vhistorico, vtodos_sn, vbusqueda_por, vfecha_inicio, vfecha_fin, Session("cadena_conexion"), vpublicos_sn, FILTRO_CLIENTES, VAGENTE, VSERIES_SI, VSERIES_NO, vfiltro_docum, vsuref)
        Return total
    End Function
    Private Sub BindPagingGrid()
        GVPedidos.DataSource = GetDataPage(GVPedidos.PageIndex, GVPedidos.PageSize, GVPedidos.OrderBy)
        GVPedidos.DataBind()
    End Sub
    Private Function GetDataPage(ByVal pageIndex As Integer, ByVal pageSize As Integer, ByVal sortExpression As String) As ArrayList
        Dim lista As New ArrayList
        Try
            Dim vEMPGRUPO_COD As String = ConfigurationManager.AppSettings("grupo")
            Dim vemp_COD As String = ConfigurationManager.AppSettings("empresa")
            Dim vtip_vc As String = ConfigurationManager.AppSettings("venta")
            Dim vggPEDtip_cod As String = DDLSerie.SelectedValue
            Dim vhistorico As String = DDLHistorico.SelectedValue
            Dim vbusqueda_por As String = DDLBusquedaPor.SelectedValue
            ' Dim vn_PED As OracleNumber = OracleNumber.Null
            Dim vn_PED As String = ""
            If (tboxNPedido.Text <> "") Then
                vn_PED = tboxNPedido.Text
            End If
            ' Dim vcodcli As OracleNumber = OracleNumber.Parse(Session("cliente").prop_COD)
            Dim vcodcli As String = ""
            If Not Session("cliente") Is Nothing Then
                vcodcli = Session("cliente").prop_COD
            Else
                vcodcli = tboxClienteCod.Text
            End If
            'Dim vhist_sn As String = "N"
            'If (checkboxHistorico.Checked) Then
            '    vhist_sn = "S"
            'End If
            Dim vtodos_sn As String = "N"
            If (checkboxTODOS.Checked) Then
                vtodos_sn = "S"
            End If
            Dim vpublicos_sn As String = "" 'ConfigurationManager.AppSettings("publicos")
            Dim vpagina_inicio As String = ((GVPedidos.PageIndex) * GVPedidos.PageSize) + 1
            Dim vpagina_fin As String = ((GVPedidos.PageIndex + 1) * GVPedidos.PageSize)
            Dim vordenado_por As String = " F_PED DESC, N_PEDIDO DESC "
            Dim vidiomas_cod As String = "" ' Session("idiomas")
            Dim tipo_observacion_idioma As String = "" 'ConfigurationManager.AppSettings("cod_obs_idioma")

            Dim vsuref As String = tboxSuRef.Text

            ' Dim vfecha_inicio As OracleDateTime
            Dim vfecha_inicio As String

            Try
                'vfecha_inicio = OracleDateTime.Parse(tboxFdesde.Text)
                vfecha_inicio = tboxFdesde.Text
            Catch ex As Exception
                'vfecha_inicio = OracleDateTime.Null
                vfecha_inicio = ""
            End Try

            'Dim vfecha_fin As OracleDateTime
            Dim vfecha_fin As String
            Try
                'vfecha_fin = OracleDateTime.Parse(tboxFHasta.Text)
                vfecha_fin = tboxFHasta.Text
            Catch ex As Exception
                'vfecha_fin = OracleDateTime.Null
                vfecha_fin = ""
            End Try
            Dim filtro_clientes As String = ConfigurationManager.AppSettings("FiltroCliente")

            Dim elemento As New BCb2b.GGPEDCAB()
            Dim buscar_por_fecha As String = vbusqueda_por

            Dim VAGENTE As String
            If Not Session("AGENTE") Is Nothing Then
                VAGENTE = Session("AGENTE").prop_cod()
                If Session("AGENTE").PROP_COD <> "" Then
                    filtro_clientes = Session("ver_clientes")
                End If
            Else
                VAGENTE = ""
                filtro_clientes = Session("ver_clientes")
            End If

            Dim PARAMETRO As New BCb2b.empparam(ConfigurationManager.AppSettings("B2B_PED_VISUALIZAR"), vEMPGRUPO_COD, vemp_COD, Session("USUARIOB2B").PROP_COD)
            Dim VSERIES_SI As String = PARAMETRO.prop_VALOR
            Dim vfiltro_docum As String = ConfigurationManager.AppSettings("Filtro_documentos")

            Dim VSERIES_NO As String = ""
            Dim elcodcli As String = ""
            elcodcli = vcodcli
            If (Not tboxClienteCod.Text = "") Then
                elcodcli = tboxClienteCod.Text
            End If

            lista = elemento.lista_cabecera_pedidos_paginado(vEMPGRUPO_COD, vemp_COD, vtip_vc, vggPEDtip_cod, vn_PED, elcodcli, vhistorico, vtodos_sn, vpagina_inicio, vpagina_fin, vordenado_por, buscar_por_fecha, vfecha_inicio, vfecha_fin, Session("cadena_conexion"), vpublicos_sn, vidiomas_cod, tipo_observacion_idioma, filtro_clientes, VAGENTE, VSERIES_SI, VSERIES_NO, vfiltro_docum, vsuref)
            div_lblerror.Visible = False
        Catch ex As Exception
            lblerror.Text = ex.Message.ToString
            div_lblerror.Visible = True
        End Try

        Return lista

    End Function
    'Protected Sub ImgBCliente_Click(sender As Object, e As ImageClickEventArgs) Handles ImgBCliente.Click
    '    'tboxCliente.Text = GetLocalResourceObject("SinClienteSel")
    '    tboxCliente.Text = ""
    '    tboxClienteCod.Text = ""
    '    checkboxTODOS.Checked = True
    'End Sub
    'Protected Sub ImgBFDesde_Click(sender As Object, e As ImageClickEventArgs) Handles ImgBFDesde.Click
    '    tboxFdesde.Text = ""
    'End Sub
    'Protected Sub ImgBFhasta_Click(sender As Object, e As ImageClickEventArgs) Handles ImgBFHasta.Click
    '    tboxFHasta.Text = ""
    'End Sub

    Protected Sub tboxClienteCod_TextChanged(sender As Object, e As EventArgs) Handles tboxClienteCod.TextChanged
        If tboxClienteCod.Text = "" Then
            tboxCliente.Text = GetLocalResourceObject("NoExisteCli")
            checkboxTODOS.Checked = True
        Else
            Dim perfiles As New BCb2b.USUARIOS_B2B()
            perfiles.Administrar_Permisos_Perfiles(Session("tipo_usuario"))
            If perfiles.prop_TIPO_PERFIL = 0 Then 'ing y svt
                Dim cli As New BCb2b.ggclipr(tboxClienteCod.Text, ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"))
                tboxCliente.Text = cli.prop_NOMBRE
            Else
                Dim cli As New BCb2b.ggclipr()
                tboxCliente.Text = cli.DameCliDeAge(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), Session("agente").prop_cod, tboxClienteCod.Text)
            End If
            If tboxCliente.Text = "" Then
                tboxClienteCod.Text = ""
            End If
            checkboxTODOS.Checked = False
        End If
    End Sub

    Protected Sub checkboxTODOS_CheckedChanged(sender As Object, e As EventArgs) Handles checkboxTODOS.CheckedChanged
        If checkboxTODOS.Checked Then
            tboxClienteCod.Text = ""
            tboxCliente.Text = ""
        Else
            Dim cli As New BCb2b.ggclipr()
            cli = Session("cliente")
            tboxClienteCod.Text = cli.prop_COD
            tboxCliente.Text = cli.prop_NOMBRE
        End If
    End Sub
    Protected Sub ImgBTFDesde_Click(sender As Object, e As ImageClickEventArgs) Handles ImgBTFDesde.Click
        tboxFdesde.Text = ""
    End Sub

    Protected Sub ImgBTFHasta_Click(sender As Object, e As ImageClickEventArgs) Handles ImgBTFHasta.Click
        tboxFHasta.Text = ""
    End Sub

    Protected Sub ImgBTCliente_Click(sender As Object, e As ImageClickEventArgs) Handles ImgBTCliente.Click
        tboxCliente.Text = ""
        tboxClienteCod.Text = ""
        checkboxTODOS.Checked = True
    End Sub
End Class
