﻿Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.OracleClient
Imports BCb2b.Enterlan
Imports System.Configuration.ConfigurationSettings
Imports System.Collections
Imports System.Collections.Generic
Imports System.Configuration
Imports System.IO
Imports System.Runtime.InteropServices
Imports System.Security.Principal
Imports System.Net
Imports System.Diagnostics
Partial Class CambiarCodigo
    Inherits System.Web.UI.Page
    'Protected Sub Page_PreInit(sender As Object, e As EventArgs) Handles Me.PreInit
    '    Page.Theme = "amc"
    'End Sub
    Public Function ggestcampa_cambiar_codigo(p_ggestcampa_cod_ori As String, p_ggestcampa_cod_des As String, Optional ByVal p_recodificar_cfccosto As String = "N") As String

        Dim resultado As String = ""
        'p_recodificar_cfccosto nos dice si tenemos que mirar o no la codificación de centros de costo.
        'Por defecto en el pl/sql es S, pero en el caso de AMC por defecto sería N, si no le pasamos nada mira el parametro GGESTCAMPA_CFCCTIP_PROYECTO.

        Try

            Dim conn As New OracleConnection()
            Dim comm As New OracleCommand()
            Dim inputParam As OracleParameter
            Dim conexion As New BCb2b.Enterlan.b2b.Cconexion()

            conn.ConnectionString = conexion.cadena_conexion
            'Llamo al stored procedure.
            comm.CommandText = "ggestcampa_pkg.CAMBIO_CODIGO"
            comm.CommandType = CommandType.StoredProcedure

            inputParam = comm.Parameters.Add("p_ggestcampa_cod_ori", OracleClient.OracleType.VarChar, 10)
            inputParam.Direction = ParameterDirection.Input
            inputParam.Value = p_ggestcampa_cod_ori

            inputParam = comm.Parameters.Add("p_ggestcampa_cod_des", OracleClient.OracleType.VarChar, 10)
            inputParam.Direction = ParameterDirection.Input
            inputParam.Value = p_ggestcampa_cod_des

            inputParam = comm.Parameters.Add("p_recodificar_cfccosto", OracleClient.OracleType.VarChar, 1)
            inputParam.Direction = ParameterDirection.Input
            inputParam.Value = p_recodificar_cfccosto

            Try
                comm.Connection = conn
                conn.Open()
                comm.ExecuteNonQuery()

            Catch ex As Exception
                Throw New Exception("[ggestcampa_cambiar_codigo] Codigo origen:: " & p_ggestcampa_cod_ori & ",codigo Destino" & p_ggestcampa_cod_des & ex.Message.ToString)
            Finally
                conn.Close()
            End Try
        Catch ex As Exception
            Throw New Exception("[ggestcampa_cambiar_codigo] Codigo origen:: " & p_ggestcampa_cod_ori & ",codigo Destino" & p_ggestcampa_cod_des & ex.Message.ToString)
        End Try


        Return resultado
    End Function



    Public Function clasificacionesDefecto(codProy As String, vggclatipCod As String, Vggclasif_cod As String, valor As String) As String

        Dim vlog As String = ""
        Try

            Dim Cggclatip = New BCb2b.CGGCLATIP("V", vggclatipCod)

            AMC_Proyectos_pkg.CProyectos.actualiza_ggclasif(codProy, "PRY", vggclatipCod, "*", Vggclasif_cod, "*", valor, "V")
            vlog = "Actualizada clasificacion (" & vggclatipCod & "," & Vggclasif_cod & "," & valor & " ) <br>"
            Return vlog

        Catch ex As Exception
            Return "Error Actualizando clasificacion  (" & vggclatipCod & "," & Vggclasif_cod & "," & valor & " ) <br>" & ex.Message.ToString
        End Try


    End Function




    Public Function crearProy(vcliente_COD As OracleNumber, vtxtComentario As String) As String

        Dim grupo, empresa, tip_vc, descProyecto As String
        grupo = ConfigurationManager.AppSettings("Grupo")
        empresa = ConfigurationManager.AppSettings("Empresa")
        tip_vc = ConfigurationManager.AppSettings("Venta")



        descProyecto = vtxtComentario
        If descProyecto = "" Or Nothing Then
            descProyecto = "Proyecto Integrado "
        End If

        Dim cod_proy As String

        Dim proyect As New AMC_Proyectos_pkg.CProyectos()
        'EN AMC EL TIPO DE PROYECTO "TIPO_PROY" ES "PRY_FIJO"
        proyect = proyect.ggestcampa_crear_nuevo(grupo, empresa, tip_vc, ConfigurationManager.AppSettings("TipoProyCreacion"), "1", vcliente_COD, "", descProyecto, vtxtComentario, ConfigurationManager.AppSettings("USUARIO_WEB"))
        cod_proy = proyect.prop_cod

        Return cod_proy

    End Function


    Public Function actualizarCentros(ByVal idEstudioViejo As OracleNumber, ByVal idEstudioNuevo As OracleNumber) As String


        Dim vError As String = ""
        Dim conn2 As New OracleConnection()
        Dim conexion2 As New BCb2b.Enterlan.b2b.Cconexion()
        Dim command2 As New OracleDataAdapter()
        Dim sql2 As String

        sql2 = " UPDATE ACENTROS SET IDESTUDIO=:P1 "
        sql2 = sql2 & " WHERE IDESTUDIO = :P2 "


        conn2.ConnectionString = conexion2.cadena_conexion
        Dim cmd2 As New OracleCommand(sql2, conn2)
        'Dim rdr As OracleDataReader

        cmd2.Parameters.AddWithValue("P1", idEstudioNuevo)
        cmd2.Parameters.AddWithValue("P2", idEstudioViejo)

        Try
            conn2.Open()
            cmd2.ExecuteNonQuery()
        Catch ex As Exception
            vError = "Error actualizarCentros" & " " & ex.Message
        Finally
            conn2.Close()
        End Try

        Return verror
    End Function

    Public Function actualizarCentrosObserv(ByVal idEstudioViejo As OracleNumber, ByVal idEstudioNuevo As OracleNumber, ByVal idDistribucion As String) As String


        Dim vError As String = ""
        Dim conn2 As New OracleConnection()
        Dim conexion2 As New BCb2b.Enterlan.b2b.Cconexion()
        Dim command2 As New OracleDataAdapter()
        Dim sql2 As String

        sql2 = " UPDATE ACENTROS SET IDESTUDIO=:P1 "
        sql2 = sql2 & " WHERE IDESTUDIO = :P2 and iddistribucion = :p3 "


        conn2.ConnectionString = conexion2.cadena_conexion
        Dim cmd2 As New OracleCommand(sql2, conn2)
        'Dim rdr As OracleDataReader

        cmd2.Parameters.AddWithValue("P1", idEstudioNuevo)
        cmd2.Parameters.AddWithValue("P2", idEstudioViejo)
        cmd2.Parameters.AddWithValue("P3", idDistribucion)

        Try
            conn2.Open()
            cmd2.ExecuteNonQuery()
        Catch ex As Exception
            vError = "Error actualizarCentros Observ" & " " & ex.Message
        Finally
            conn2.Close()
        End Try

        Return vError
    End Function

    Public Function datosDistribucion(ByVal idEstudioViejo As OracleNumber) As String


        Dim vError As String = ""
        Dim conn2 As New OracleConnection()
        Dim conexion2 As New BCb2b.Enterlan.b2b.Cconexion()
        Dim command2 As New OracleDataAdapter()
        Dim sql2 As String

        sql2 = " select * from adistribucion  "
        sql2 = sql2 & " WHERE IDESTUDIO = :P1 "


        conn2.ConnectionString = conexion2.cadena_conexion
        Dim cmd2 As New OracleCommand(sql2, conn2)
        Dim rdr2 As OracleDataReader
        'Dim rdr As OracleDataReader

        cmd2.Parameters.AddWithValue("P1", idEstudioViejo)

        Dim observaciones As String = ""


        Try
            conn2.Open()
            rdr2 = cmd2.ExecuteReader()
            If rdr2.Read = True Then
                If (Not rdr2.GetOracleString(rdr2.GetOrdinal("observaciones")).IsNull) Then
                    observaciones = rdr2.GetOracleString(rdr2.GetOrdinal("observaciones"))
                End If
            End If
            Return observaciones
        Catch ex As Exception
            vError = "Error datosDistribucion" & " " & ex.Message
        Finally
            conn2.Close()
        End Try

        Return vError
    End Function

    Public Function actualizarDistribucion(ByVal idEstudioViejo As OracleNumber, ByVal idEstudioNuevo As OracleNumber) As String



        Dim observaciones As String = datosDistribucion(idEstudioViejo)
        Dim vError As String = ""
        Dim conn2 As New OracleConnection()
        Dim conexion2 As New BCb2b.Enterlan.b2b.Cconexion()
        Dim command2 As New OracleDataAdapter()
        Dim sql2 As String

        sql2 = " UPDATE adistribucion SET IDESTUDIO=:P1, observaciones = :p3 "
        sql2 = sql2 & " WHERE IDESTUDIO = :P2 "


        conn2.ConnectionString = conexion2.cadena_conexion
        Dim cmd2 As New OracleCommand(sql2, conn2)
        'Dim rdr As OracleDataReader

        cmd2.Parameters.AddWithValue("P1", idEstudioNuevo)
        cmd2.Parameters.AddWithValue("P2", idEstudioViejo)
        cmd2.Parameters.AddWithValue("P3", observaciones)

        Try
            conn2.Open()
            cmd2.ExecuteNonQuery()
        Catch ex As Exception
            vError = "Error actualizarDistribucion" & " " & ex.Message
        Finally
            conn2.Close()
        End Try

        Return vError
    End Function


    Public Function actualizarEstudios(ByVal idEstudioViejo As OracleNumber, ByVal idEstudioNuevo As OracleNumber) As String


        Dim vError As String = ""
        Dim conn2 As New OracleConnection()
        Dim conexion2 As New BCb2b.Enterlan.b2b.Cconexion()
        Dim command2 As New OracleDataAdapter()
        Dim sql2 As String

        sql2 = " UPDATE aestudios SET IDESTUDIO=:P1 "
        sql2 = sql2 & " WHERE IDESTUDIO = :P2 "


        conn2.ConnectionString = conexion2.cadena_conexion
        Dim cmd2 As New OracleCommand(sql2, conn2)
        'Dim rdr As OracleDataReader

        cmd2.Parameters.AddWithValue("P1", idEstudioNuevo)
        cmd2.Parameters.AddWithValue("P2", idEstudioViejo)

        Try
            conn2.Open()
            cmd2.ExecuteNonQuery()
        Catch ex As Exception
            vError = "Error actualizarEstudios" & " " & ex.Message
        Finally
            conn2.Close()
        End Try

        Return vError
    End Function



    Public Function insertar_MarcaExportado(ByVal cod_proyecto As String, ByVal texto As String, ByVal tipoObs As String) As String
        Dim conn As New OracleConnection()
        Dim sql As String = ""
        Dim conexion As New BCb2b.Enterlan.b2b.Cconexion()

        Dim Lista_apoyos As New ArrayList

        conn.ConnectionString = conexion.cadena_conexion
        sql = " INSERT INTO ggcampaobs(GGESTCAMPA_COD,TIP_VC,GGOBSTIP_COD,OBSER) "
        sql = sql & " VALUES (:P1,'V', :P2, :P3) "

        Dim cmd As New OracleCommand(sql, conn)
        cmd.Parameters.AddWithValue("P1", cod_proyecto)
        cmd.Parameters.AddWithValue("P2", tipoObs)
        cmd.Parameters.AddWithValue("P3", texto)
        Dim vlog As String = ""
        vlog = " [insertar_MarcaExportado] ( " & cod_proyecto & "," & tipoObs & "," & texto & " )"
        Try
            conn.Open()
            cmd.ExecuteNonQuery()
            Return vlog

        Catch ex As Exception
            'Throw New Exception("[insertar_MarcaExportado] " & ex.Message.ToString)
            Return "[insertar_MarcaExportado] " & ex.Message.ToString
        Finally
            If conn.State = ConnectionState.Open Then
                conn.Close()
            End If
            cmd.Dispose()
            conn.Dispose()

        End Try
    End Function

    ' Protected Sub Page_Load(sender As Object, e As System.EventArgs) Handles Me.Load
    Protected Sub Page_Load2(sender As Object, e As System.EventArgs)


        Dim conn As New OracleConnection()
        Dim conexion As New BCb2b.Enterlan.b2b.Cconexion()
        Dim command As New OracleDataAdapter()
        Dim sql As String
        Dim vlog As String = ""
        Dim vCodProy As String
        Dim anioAnt As String = "11"



        sql = "  SELECT ggestcampa_cod as cod FROM GGCAMPAOBS WHERE GGOBSTIP_COD='INTE' AND ggestcampa_cod like '12%' and GGESTCAMPA_COD IN "
        sql = sql & " (   SELECT COD FROM GGESTCAMPA  "
        sql = sql & " WHERE COD IN (SELECT GGESTCAMPA_COD FROM GGCAMPACLI  "
        sql = sql & "  WHERE EMPGRUPO_COD = 'AMC' "
        sql = sql & " AND EMP_COD = '0001' and ggclipr_cod = '55724'   "
        sql = sql & " ) "
        sql = sql & " ) "


        conn.ConnectionString = conexion.cadena_conexion
        Dim cmd As New OracleCommand(Sql, conn)
        Dim rdr2 As OracleDataReader

        vlog = " Empezamos el proceso1 "

        Try
            conn.Open()
            rdr2 = cmd.ExecuteReader()
            Do While rdr2.Read = True
                vCodProy = rdr2.GetOracleString(rdr2.GetOrdinal("cod"))
                Dim nuevoCodProy As String = "" '1205572405
                nuevoCodProy = Right(vCodProy, 8)
                nuevoCodProy = anioAnt & nuevoCodProy
                Me.ggestcampa_cambiar_codigo(vCodProy, nuevoCodProy)

                'Dim vlogAux = ""
                ''Modificamos tanto centros como distribución y estudios (así esa tabla nos queda de referencia).
                'vlogAux = actualizarCentros(vCodProy, nuevoCodProy)
                'vlog = vlog & "actualizarCentros::: (" & vCodProy.ToString & "," & nuevoCodProy & ") " & vlogAux & "   <br>"
                'vlogAux = actualizarDistribucion(vCodProy, nuevoCodProy)
                'vlog = vlog & " actualizarDistribucion::: (" & vCodProy.ToString & "," & nuevoCodProy & ") " & vlogAux & " <br>"
                'vlogAux = actualizarEstudios(vCodProy, vCodProy)
                'vlog = vlog & " actualizarEstudios::: (" & vCodProy.ToString & "," & nuevoCodProy & ") " & vlogAux & " <br>"

                'vlog = vlog & "cambiamos  Codigo " & vCodProy & " por::: " & nuevoCodProy

            Loop

            Label1.Text = vlog
        Catch ex As Exception
            Label1.Text = vlog & "<BR>" & ex.Message.ToString
        Finally
            If conn.State = ConnectionState.Open Then
                conn.Close()
            End If
            cmd.Dispose()
            conn.Dispose()
        End Try

    End Sub


    Public Function damePrimeroLIbre() As String


        Dim vError As String = ""
        Dim conn2 As New OracleConnection()
        Dim conexion2 As New BCb2b.Enterlan.b2b.Cconexion()
        Dim command2 As New OracleDataAdapter()
        Dim sql2 As String

        sql2 = " select * from ggestcampa,GGCAMPACLI where cod like '11055724%'"
        sql2 = sql2 & " and cod not in (select idestudio from adistribucion) "
        sql2 = sql2 & "and ggestcampa.usrnom_cre ='PRAXIS' "
        sql2 = sql2 & "AND  EMPGRUPO_COD = 'AMC'  "
        sql2 = sql2 & "AND EMP_COD = '0001' and ggclipr_cod in (55724) "
        sql2 = sql2 & " AND GGESTCAMPA.COD = GGCAMPACLI.GGESTCAMPA_COD  "




        conn2.ConnectionString = conexion2.cadena_conexion
        Dim cmd2 As New OracleCommand(sql2, conn2)
        Dim rdr2 As OracleDataReader
        'Dim rdr As OracleDataReader



        Dim observaciones As String = ""


        Try
            conn2.Open()
            rdr2 = cmd2.ExecuteReader()
            If rdr2.Read = True Then
                If (Not rdr2.GetOracleString(rdr2.GetOrdinal("ggestcampa_cod")).IsNull) Then
                    observaciones = rdr2.GetOracleString(rdr2.GetOrdinal("ggestcampa_cod"))
                End If
            End If
            Return observaciones
        Catch ex As Exception
            vError = "Error damePrimeroLIbre" & " " & ex.Message
        Finally
            conn2.Close()
        End Try

        Return vError
    End Function


    Public Function actualizarDistribucionObserv(ByVal idEstudioViejo As OracleNumber, ByVal idEstudioNuevo As OracleNumber, ByVal iddistribucion As String, ByVal observaciones As String) As String



        Dim observacionesNuevas As String = datosDistribucion(idEstudioViejo)
        Dim vError As String = ""
        Dim conn2 As New OracleConnection()
        Dim conexion2 As New BCb2b.Enterlan.b2b.Cconexion()
        Dim command2 As New OracleDataAdapter()
        Dim sql2 As String

        sql2 = " UPDATE adistribucion SET IDESTUDIO=:P1, observaciones = :p3 "
        sql2 = sql2 & " WHERE IDESTUDIO = :P2 and iddistribucion = :p4 "
        'and observaciones = :p5 

        conn2.ConnectionString = conexion2.cadena_conexion
        Dim cmd2 As New OracleCommand(sql2, conn2)
        'Dim rdr As OracleDataReader

        cmd2.Parameters.AddWithValue("P1", idEstudioNuevo)
        cmd2.Parameters.AddWithValue("P2", idEstudioViejo)
        cmd2.Parameters.AddWithValue("P3", observacionesNuevas)
        cmd2.Parameters.AddWithValue("P4", iddistribucion)
        'cmd2.Parameters.AddWithValue("P5", observaciones)

        Try
            conn2.Open()
            cmd2.ExecuteNonQuery()
        Catch ex As Exception
            vError = "Error actualizarDistribucion" & " " & ex.Message
        Finally
            conn2.Close()
        End Try

        Return vError
    End Function


    'Protected Sub Page_Load2(sender As Object, e As System.EventArgs)
    Protected Sub Page_Load(sender As Object, e As System.EventArgs) Handles Me.Load


        Dim conn As New OracleConnection()
        Dim conexion As New BCb2b.Enterlan.b2b.Cconexion()
        Dim command As New OracleDataAdapter()
        Dim sql As String
        Dim vlog As String = ""
        Dim vCodProy As String
        Dim anioAnt As String = "11"

        ' QUITAR LOS DEL ISESTUDIO ESE QUE HA ACAPARADO A MUCHOS.


        sql = "  select iddistribucion,idestudio,replace(SUBSTR(observaciones,instr ( observaciones,'[Imported]'  )),'[Imported]','')  as idestudioviejo,observaciones "
        sql = sql & " from adistribucion where "
        sql = sql & " idestudio like '90%'  "


        sql = " SELECT * FROM ADISTRIBUCION "
        sql = sql & " where to_char(idestudio) not in ( select cod from  ggestcampa) "
        sql = sql & " and idestudio not in (select idestudio from aestudios)"
        sql = sql & " and idestudio not like '9%'"
        sql = sql & " and observaciones  like '%[Imported]%'"

        conn.ConnectionString = conexion.cadena_conexion
        Dim cmd As New OracleCommand(Sql, conn)
        Dim rdr2 As OracleDataReader

        vlog = " Empezamos el procesoooooo "
        Dim vididstribucion As String
        Dim vobservaciones As String
        Try

            vlog = vlog & " - 0 -"
            conn.Open()
            rdr2 = cmd.ExecuteReader()
            Do While rdr2.Read = True

                vlog = vlog & " - 1 -"
                vCodProy = rdr2.GetOracleNumber(rdr2.GetOrdinal("idestudio"))
                vlog = vlog & " -codigoPory -" & vCodProy
                vididstribucion = rdr2.GetOracleNumber(rdr2.GetOrdinal("idDistribucion"))
                vlog = vlog & " -vididstribucion -" & vididstribucion
                vobservaciones = rdr2.GetOracleString(rdr2.GetOrdinal("observaciones"))
                vlog = vlog & " -vobservaciones -" & vobservaciones
                Dim nuevoCodProy As String = "" '1205572405
                ' nuevoCodProy = Right(vCodProy, 8)
                ' nuevoCodProy = anioAnt & nuevoCodProy
                ' Me.ggestcampa_cambiar_codigo(vCodProy, nuevoCodProy)

                nuevoCodProy = damePrimeroLIbre()
                vlog = vlog & " -nuevoCodProy -" & nuevoCodProy
                Dim vlogAux = ""
                'Modificamos tanto centros como distribución y estudios (así esa tabla nos queda de referencia).
                vlogAux = actualizarDistribucionObserv(vCodProy, nuevoCodProy, vididstribucion, vobservaciones)
                vlog = vlog & " actualizarDistribucion::: (" & vCodProy.ToString & "," & nuevoCodProy & ") " & vlogAux & " <br>"
                vlogAux = actualizarCentrosObserv(vCodProy, nuevoCodProy, vididstribucion)
                vlog = vlog & "actualizarCentros::: (" & vCodProy.ToString & "," & nuevoCodProy & ") " & vlogAux & "   <br>"
                'vlogAux = actualizarEstudios(vCodProy, vCodProy)
                'vlog = vlog & " actualizarEstudios::: (" & vCodProy.ToString & "," & nuevoCodProy & ") " & vlogAux & " <br>"
                'vlog = vlog & "cambiamos  Codigo " & vCodProy & " por::: " & nuevoCodProy

            Loop

            Label1.Text = vlog
        Catch ex As Exception
            Label1.Text = vlog & "<BR>" & ex.Message.ToString
        Finally
            If conn.State = ConnectionState.Open Then
                conn.Close()
            End If
            cmd.Dispose()
            conn.Dispose()
        End Try

    End Sub

End Class
