﻿Imports System.Drawing
Imports System.Drawing.Imaging
Imports BCb2b.Metodos
Imports BCb2b
Imports CTI.Utilities.Log
Partial Class GraficoApoyos
    'Inherits System.Web.UI.Page
    Inherits claseBase

    Public Function PuntosMinxMiny(centro As PointF, puntos() As PointF, centros() As PointF) As PointF

        'Buscar menor en eje x. y menor en eje y

        Dim minx As Double = centro.X
        Dim miny As Double = centro.Y

        For Each elemento As PointF In puntos
            If elemento.X < minx Then
                minx = elemento.X
            End If
            If elemento.Y < miny Then
                miny = elemento.Y
            End If
        Next

        For Each elemento As PointF In centros
            If elemento.X < minx Then
                minx = elemento.X
            End If
            If elemento.Y < miny Then
                miny = elemento.Y
            End If
        Next

        Return New Point(minx, miny)

    End Function

    Public Function TransformarCentro(centro As PointF, puntoMin As PointF) As PointF

        Dim minx As Double = puntoMin.X
        Dim miny As Double = puntoMin.Y

        If minx < 0 Then
            centro.X = centro.X - minx
        End If
        If miny < 0 Then
            centro.Y = centro.Y - miny
        End If
        Dim elementoAux As New PointF(centro.X, centro.Y)
        Return elementoAux

    End Function

    Public Function TransformarPuntos(puntos() As PointF, puntoMin As PointF) As PointF()

        'Buscar menor en eje x. y menor en eje y

        Dim minx As Double = puntoMin.X
        Dim miny As Double = puntoMin.Y


        'transformar los arrays.
        Dim resultado(puntos.Length - 1) As PointF

        If minx < 0 Or miny < 0 Then
            Dim ind As Int16 = 0
            For Each elemento As PointF In puntos
                If minx < 0 Then
                    elemento.X = elemento.X - minx
                End If
                If miny < 0 Then
                    elemento.Y = elemento.Y - miny
                End If
                Dim elementoAux As New PointF(elemento.X, elemento.Y)
                resultado.SetValue(elementoAux, ind)
                ind = ind + 1
            Next
        Else
            resultado = puntos
        End If

        Return resultado
    End Function
    'Protected Sub Page_PreInit(sender As Object, e As EventArgs) Handles Me.PreInit
    '    Page.Theme = "amc"
    'End Sub
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Dim elemento As New AMC_Proyectos_pkg.CCalculos.apoyo
        Dim calculo As New AMC_Proyectos_pkg.CCalculos
        Dim acentros As New AMC_Proyectos_pkg.CAcentros
        Try
            If Not Session("Apoyos") Is Nothing Then
                'If False Then


                Dim fuentePuntos = New Font("Arial", 11)
                Dim fuentePuntosCdg = New Font("Arial", 8)

                Dim misApoyos As ArrayList = Session("Apoyos")
                If misApoyos.Count > 0 Then
                    calculo = Session("calculos")

                    Dim puntos(0) As PointF
                    If calculo.prop_carga_sn = "N" Then
                        Dim i As Integer = 0
                        ReDim puntos(misApoyos.Count - 1)
                        For Each elemento In misApoyos
                            puntos(i) = New PointF(Metodos.StringToOracleNumber(elemento.prop_x), Metodos.StringToOracleNumber(elemento.prop_y))
                            i = i + 1
                        Next
                    Else
                        puntos(0) = New PointF(-1, -1)
                    End If

                    Dim limites = New RectangleF(0, 0, 363, 272)
                    Dim margen = New RectangleF(20, 20, 363 - 40, 272 - 40)

                    If (Not Session("Centros") Is Nothing) Then


                        Dim misCentros As ArrayList = Session("Centros")

                        Dim z As Integer = 0
                        Dim puntosCdg(misCentros.Count - 1) As PointF
                        Dim textoPuntosCdg(misCentros.Count - 1) As String
                        For Each acentros In misCentros
                            puntosCdg(z) = New PointF(Metodos.StringToOracleNumber(acentros.prop_x), Metodos.StringToOracleNumber(acentros.prop_y))
                            textoPuntosCdg(z) = acentros.prop_nombre
                            z = z + 1
                        Next

                        If Session("centroX") = "" Or Session("centroX") = "Null" Then
                            Session("centroX") = "0"
                        End If
                        If Session("centroY") = "" Or Session("centroY") = "Null" Then
                            Session("centroY") = "0"
                        End If

                        Dim centro = New PointF(Metodos.StringToOracleNumber(Session("centroX")), Metodos.StringToOracleNumber(Session("centroY")))

                        'JVC. Para escalar los puntos
                        Dim puntoMin As PointF = PuntosMinxMiny(centro, puntos, puntosCdg)
                        centro = TransformarCentro(centro, puntoMin)
                        puntos = TransformarPuntos(puntos, puntoMin)
                        puntosCdg = TransformarPuntos(puntosCdg, puntoMin)
                        'FIN PARA ESCALAR LOS PUNTOS.

                        Dim grafico = AMC_GraficoPuntosSoporte.Grafico.Crear(limites, margen, centro, puntos, fuentePuntos, puntosCdg, fuentePuntosCdg, textoPuntosCdg)

                        Response.ContentType = "image/gif"
                        grafico.Save(Response.OutputStream, ImageFormat.Gif)
                        Dim cliente As BCb2b.ggclipr
                        cliente = Session("cliente")
                        Dim nombreGraf As String = "grafico_apoyos_" & cliente.prop_COD & "_" & DateTime.Now.ToString("yyyyMMdd_HHmmss") & ".png"
                        grafico.Save(ConfigurationManager.AppSettings("rutaPDFmail") & "_" & nombreGraf, ImageFormat.Png)

                        calculo.PROP_ruta_grafico_apoyos = nombreGraf
                    End If
                End If
            End If
        Catch ex As Exception
            Log.Error(ex, "[GraficoApoyos.Load] calculo = {@calculo} apoyo = {@apoyo} centro = {@centro}", calculo, elemento, acentros)
        End Try

    End Sub
End Class
