﻿Imports System.IO
Imports System.Data.OracleClient
Imports System.Collections
Imports System.Linq

Partial Class Proyectos_excelCalculos
    Inherits System.Web.UI.Page

    Private Sub generarTabla(table As Table)
        Dim calculos = CType(Session("lista_calculos"), ArrayList)        
        'Cabecera del excel
        Dim contador As Integer = 1
        createHeader(table)
        For Each item In calculos
            'Obtenemos los datos del calculo
            Dim calculo = CType(item, AMC_Proyectos_pkg.CCalculos)
            Dim idEstudio As String = String.Format("{0:0000000000}", Integer.Parse(calculo.prop_idestudio))
            Dim proyecto As New AMC_Proyectos_pkg.CProyectos(ConfigurationManager.AppSettings("Grupo"), idEstudio)
            Dim datos As ArrayList = calculo.DameDatosRev(idEstudio, calculo.prop_revision)

            Dim vIddistribucion As String = IIf(CType(datos(0), OracleNumber).IsNull, "", datos(0).ToString())
            Dim vMx As String = IIf(CType(datos(7), OracleNumber).IsNull, "", datos(7).ToString())
            Dim vMy As String = IIf(CType(datos(8), OracleNumber).IsNull, "", datos(8).ToString())
            Dim vOrden As String = IIf(CType(datos(10), OracleNumber).IsNull, "", datos(10).ToString())
            Dim vRpm As String = IIf(CType(datos(9), OracleNumber).IsNull, "", datos(9).ToString())
            Dim peso As String = IIf(datos(4).ToString() = "Null", "", datos(4).ToString())

            If vOrden.StartsWith(",") Then 'Esto es para evitar un problema con el driver de oracle que interpreta "0,5" --> ",5"
                vOrden = "0" & vOrden
            End If
            calculo.cargar_datos(idEstudio, vIddistribucion, Integer.Parse(calculo.prop_revision), ConfigurationManager.AppSettings("Grupo"), vMx, vMy, _
                                 vOrden, vRpm, Session("idioma"), ConfigurationManager.AppSettings("obstip_articulo_idiomas"))


            'Dibujamos el calculo

            Dim fila As New TableRow()
            drawRow(calculo, peso, fila, contador)
            table.Rows.Add(fila)
            contador = contador + 1                     
        Next
    End Sub

    Private Sub createHeader(ByRef table As Table)
        Dim fila As New TableRow()        

        Dim celda1 As New TableHeaderCell()
        celda1.Text = GetLocalResourceObject("celdaComentarios")
        headerCellStyles(celda1)
        fila.Controls.Add(celda1)

        Dim celda2 As New TableHeaderCell()
        celda2.Text = GetLocalResourceObject("celdaPeso")
        headerCellStyles(celda2)
        fila.Controls.Add(celda2)

        Dim celda3 As New TableHeaderCell()
        celda3.Text = GetLocalResourceObject("celdaFreqExcitacion")
        headerCellStyles(celda3)
        fila.Controls.Add(celda3)

        Dim celda4 As New TableHeaderCell()
        celda4.Text = GetLocalResourceObject("celdaApoyos")
        headerCellStyles(celda4)
        fila.Controls.Add(celda4)

        Dim celda5 As New TableHeaderCell()
        celda5.Text = GetLocalResourceObject("celdaArticulo")
        headerCellStyles(celda5)
        fila.Controls.Add(celda5)

        Dim celda6 As New TableHeaderCell()
        celda6.Text = GetLocalResourceObject("celdaReferencia")
        headerCellStyles(celda6)
        fila.Controls.Add(celda6)

        Dim celda7 As New TableHeaderCell()
        celda7.Text = GetLocalResourceObject("celdaFreqPropia")
        headerCellStyles(celda7)
        fila.Controls.Add(celda7)

        Dim celda8 As New TableHeaderCell()
        celda8.Text = GetLocalResourceObject("celdaAislamiento")
        headerCellStyles(celda8)
        fila.Controls.Add(celda8)

        Dim celda9 As New TableHeaderCell()
        celda9.Text = GetLocalResourceObject("celdaDeflecMin")
        headerCellStyles(celda9)
        fila.Controls.Add(celda9)

        Dim celda10 As New TableHeaderCell()
        celda10.Text = GetLocalResourceObject("celdaDefelcMax")
        headerCellStyles(celda10)
        fila.Controls.Add(celda10)

        Dim celda11 As New TableHeaderCell()
        celda11.Text = GetLocalResourceObject("celdaDeflecExtre")
        headerCellStyles(celda11)
        fila.Controls.Add(celda11)

        table.Controls.Add(fila)
    End Sub

    Private Sub headerCellStyles(ByRef celda As TableHeaderCell)
        celda.Style.Add("border-bottom", "solid 2px #000")
        celda.Style.Add("border-right", "solid 1px #000")
    End Sub

    Private Sub drawRow(calculo As AMC_Proyectos_pkg.CCalculos, peso As String, ByRef fila As TableRow, contador As Integer)
        Dim apoyos = calculo.prop_apoyos.Cast(Of AMC_Proyectos_pkg.CCalculos.apoyo)().ToList()
        Dim valores = getRangeValues(apoyos)


        'Observacionese
        Dim celdaObs As New TableCell()
        celdaObs.Text = calculo.prop_observaciones
        cellStyles(celdaObs, contador)
        fila.Controls.Add(celdaObs)

        'Peso
        Dim celdaPeso As New TableCell()
        celdaPeso.Text = peso
        cellStyles(celdaPeso, contador)
        fila.Controls.Add(celdaPeso)

        'Frecuencia
        Dim celdaFrecuencia As New TableCell()
        celdaFrecuencia.Text = calculo.prop_rpm
        cellStyles(celdaFrecuencia, contador)
        fila.Controls.Add(celdaFrecuencia)

        'Apoyos
        Dim celdaApoyos As New TableCell()
        celdaApoyos.Text = calculo.prop_apoyos().Count
        cellStyles(celdaApoyos, contador)
        fila.Controls.Add(celdaApoyos)

        'Descripcion
        Dim celdDesc As New TableCell()
        celdDesc.Text = ""
        If calculo.prop_apoyos().Count > 0 Then
            celdDesc.Text = apoyos(0).prop_descripcion
        End If
        cellStyles(celdDesc, contador)
        fila.Controls.Add(celdDesc)

        'Articulo
        Dim celdArt As New TableCell()
        celdArt.Text = ""
        If calculo.prop_apoyos().Count > 0 Then
            celdArt.Text = apoyos(0).prop_idarticulo
            Dim a As New HtmlAnchor()
            a.HRef = "http://www.mecanocaucho.com/" & Session("idioma") & "/itemsearch/" & apoyos(0).prop_idarticulo & "/"
            a.InnerText = apoyos(0).prop_idarticulo
            a.Style.Add("color", "blue")
            a.Style.Add("font-weight", "bold")
            celdArt.Controls.Add(a)
        End If
        cellStyles(celdArt, contador)
        fila.Controls.Add(celdArt)

        'Frecuencia
        Dim celdFreq As New TableCell()
        celdFreq.Text = calculo.prop_frecProp
        cellStyles(celdFreq, contador)
        fila.Controls.Add(celdFreq)

        'Aislamiento
        Dim celdAisla As New TableCell()
        celdAisla.Text = calculo.prop_aislamiento
        cellStyles(celdAisla, contador)
        fila.Controls.Add(celdAisla)


        'Deflection Minima
        Dim celdDefMin As New TableCell()
        celdDefMin.Text = valores(0)
        cellStyles(celdDefMin, contador)
        fila.Controls.Add(celdDefMin)

        'Deflection Maxima
        Dim celdDefMax As New TableCell()
        celdDefMax.Text = valores(1)
        cellStyles(celdDefMax, contador)
        fila.Controls.Add(celdDefMax)

        'Deflection Maxima
        Dim celdaExtreme As New TableCell()
        celdaExtreme.Text = ""
        cellStyles(celdaExtreme, contador)
        fila.Controls.Add(celdaExtreme)
    End Sub

    Private Function getRangeValues(apoyos As List(Of AMC_Proyectos_pkg.CCalculos.apoyo)) As List(Of String)
        Dim valores As New List(Of String)
        Try
            Dim min As Double = apoyos.Min(Function(x As AMC_Proyectos_pkg.CCalculos.apoyo) Double.Parse(x.prop_flecha))
            Dim max As Double = apoyos.Max(Function(x As AMC_Proyectos_pkg.CCalculos.apoyo) Double.Parse(x.prop_flecha))           

            valores.Add(min.ToString())
            valores.Add(max.ToString())           
        Catch ex As Exception
            valores.Clear()
            valores.Add("")
            valores.Add("")            
        End Try

        Return valores
    End Function

    Private Sub cellStyles(ByRef celda As TableCell, contador As Integer)
        celda.Style.Add("border-bottom", "solid 1px #000")

        If (contador Mod 2 <> 0) Then
            celda.Style.Add("background-color", "#D2D2D2")
            celda.Style.Add("color", "#000")
            'celda.Style.Add("font-weight", "bold")
        End If

        celda.Style.Add("border-right", "solid 1px #000")       
    End Sub

    Private Sub generarExcel(table As Table)
        Response.ClearContent()
        Response.AddHeader("content-disposition", "attachment; filename=" + ConfigurationManager.AppSettings("ExcelFileName").Replace("[fecha]", FormatDateTime(Now.Date, DateFormat.ShortDate).Replace("/", "")))
        Response.ContentType = "application/excel"
        Response.ContentEncoding = System.Text.Encoding.Unicode
        Response.BinaryWrite(System.Text.Encoding.Unicode.GetPreamble())

        Using sw As New StringWriter()
            Using htw As New HtmlTextWriter(sw)
                table.RenderControl(htw)                
                Response.Write(sw.ToString())

                Response.End()
            End Using
        End Using

    End Sub


    Protected Sub Page_Load(sender As Object, e As EventArgs) Handles Me.Load
        If Session("cliente") Is Nothing Then
            Response.Redirect("lista_proyectos.aspx")
        End If
        If Session("proyecto") Is Nothing Then
            Response.Redirect("lista_proyectos.aspx")
        End If

        If (Not Page.IsPostBack) Then
            Dim tablaExcel As New Table()
            tablaExcel.Attributes("style") = "border: solid 2px #000;"
            generarTabla(tablaExcel)
            generarExcel(tablaExcel)
        End If
    End Sub

End Class
