
Partial Class SelCliente
    Inherits claseBase

    Private COD As String
    Private RSOCIAL_COD As String
    Private nombre As String

    Private EMPRESA As String
    Private GRUPO As String
    Private TIPVC As String

    Public ReadOnly Property PROP_COD() As String
        Get
            Return Me.COD
        End Get
    End Property
    Public ReadOnly Property PROP_RSOCIAL_COD() As String
        Get
            Return Me.RSOCIAL_COD
        End Get
    End Property
    Public ReadOnly Property PROP_nombre() As String
        Get
            Return Me.nombre
        End Get
    End Property
    Public ReadOnly Property PROP_EMPRESA() As String
        Get
            Return Me.EMPRESA
        End Get
    End Property
    Public ReadOnly Property PROP_GRUPO() As String
        Get
            Return Me.GRUPO
        End Get
    End Property
    Public ReadOnly Property PROP_TIPVC() As String
        Get
            Return Me.TIPVC
        End Get
    End Property

    Protected Overrides Sub InitializeCulture()
        Dim culture As String = ""

        If Not Page.IsPostBack Then
            Dim IDIOMA As String = ""
            If Not Session("idioma") Is Nothing Then
                If (Session("idioma").ToString <> "") Then
                    IDIOMA = Session("idioma")
                End If
            Else
                Session("idioma") = ConfigurationManager.AppSettings("IDIOMA_DEFECTO")
                IDIOMA = Session("IDIOMA")
            End If
            Select Case IDIOMA
                Case ConfigurationManager.AppSettings("CAS_SPYRO")
                    culture = "es-ES"
                Case ConfigurationManager.AppSettings("ING_SPYRO")
                    culture = "en-GB"
                Case ConfigurationManager.AppSettings("FRA_SPYRO")
                    culture = "fr-FR"
                Case Else
                    culture = ConfigurationManager.AppSettings("IDIOMA_DEFECTO")
            End Select
        End If

        Session("cultura") = culture
        culture = Session("cultura").ToString


        ' Aqui ponemos tambien lo botones adecuados y la imagen del logo.
        ' y el calendario.

        If (String.IsNullOrEmpty(culture)) Then
            culture = "Auto"
            'Use this
            UICulture = culture
            culture = culture
        End If
        'OR This
        If (culture <> "Auto") Then
            Dim ci As New System.Globalization.CultureInfo(culture)
            System.Threading.Thread.CurrentThread.CurrentCulture = ci
            System.Threading.Thread.CurrentThread.CurrentUICulture = ci
        End If
        MyBase.InitializeCulture()

    End Sub

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        If (Not Session("agente") Is Nothing) Or Session("tipo_usuario") = "ING" Then
            lblAvisos.Visible = True
            LblAvisos2.Visible = False


            If Not Page.IsPostBack Then
                If Session("perfil_usuario") <> "ING" And Session("perfil_usuario") <> "SVT" Then
                    If Session("perfil_usuario") = "DIS" Then
                        Dim age As New BCb2b.gvagente()
                        age = Session("agente")
                        Dim lista As New ArrayList
                        lista.Add(age)

                        ddlAgente.DataSource = lista
                    Else
                        Dim usuario As New BCb2b.CUsrnom()
                        usuario = New BCb2b.CUsrnom(Session("agente").prop_USRNOM_COD)
                        Session("Usuario") = usuario
                        Session("UsuarioB2B") = usuario
                        ddlAgente.DataSource = usuario.PROP_lista_agentes()
                    End If
                Else
                    Dim usuario As New BCb2b.CUsrnom()
                    If Not Session("agente") Is Nothing And Session("perfil_usuario") <> "SVT" Then
                        usuario = New BCb2b.CUsrnom(Session("agente").prop_USRNOM_COD)
                    End If

                    Session("Usuario") = usuario
                    Session("UsuarioB2B") = usuario
                    ddlAgente.DataSource = usuario.PROP_lista_agentes()
                End If

                ddlAgente.DataValueField = "prop_cod"
                ddlAgente.DataTextField = "prop_nombre"
                ddlAgente.DataBind()

                Dim cifAbuscar As String = Request("f")
                If cifAbuscar <> "" Then
                    tboxCodigoB.Text = cifAbuscar
                    buscar()
                End If
            End If
        Else
            'Response.Redirect("index.aspx")
            Response.Redirect("~/Expirado.aspx")
        End If

    End Sub

    Protected Sub GridView1_PageIndexChanging(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewPageEventArgs) Handles GridView1.PageIndexChanging
        'Es necesario cambiar el indice de pagina para realizar la paginacin.
        GridView1.PageIndex = e.NewPageIndex
        'GridView1.DataBind()
        buscar()
    End Sub

    Protected Sub GridView1_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles GridView1.SelectedIndexChanged
        Try
            Dim fila As GridViewRow
            fila = GridView1.SelectedRow

            Dim CODIGO As String = fila.Cells(1).Text
            Dim RSOCIAL_CLIENTE As String = fila.Cells(2).Text
            Dim NOMBRE_CLIENTE As String = fila.Cells(3).Text

            Me.COD = CODIGO
            Me.RSOCIAL_COD = RSOCIAL_CLIENTE
            Me.nombre = NOMBRE_CLIENTE




            Me.EMPRESA = Session("empresa").prop_cod
            Me.GRUPO = ConfigurationManager.AppSettings("grupo")
            Me.TIPVC = ConfigurationManager.AppSettings("venta")

            lblAvisos.Visible = False
            LblAvisos2.Visible = False
            alert.Visible = False

            'If rblTipo.SelectedItem.Value = "Cliente" Then
            Dim cliente As New BCb2b.ggclipr(CODIGO, ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"))
            Session("Cliente") = cliente

            If Session("agente") Is Nothing Then

                Dim ageC As New BCb2b.CAgente(ddlAgente.SelectedValue)
                Dim ageG As New BCb2b.gvagente(ageC.prop_USRNOM_COD, ConfigurationManager.AppSettings("grupo"))
                Session("agente") = ageG

            End If
            'Server.Transfer("DatosCliente.aspx")
            Server.Transfer("CrearCliente.aspx")
            'Else
            'Dim rsocial As New BCb2b.CRSOCIAL(CODIGO)
            'Session("rsocial") = rsocial.PROP_COD
            'Server.Transfer("OfertasConsulta.aspx")
            'End If

        Catch ex As Exception
            lblAvisos.Visible = True
            LblAvisos2.Visible = True
            alert.Visible = True
            lblAvisos.Text = ex.Message.ToString
        End Try
    End Sub

    'Protected Sub btnbuscar_Click(ByVal sender As Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles btnbuscar.Click
    '    If (Not Session("agente") Is Nothing) Then
    '        Dim agente_sel As String = ddlAgente.SelectedValue
    '        Dim agente_aux As New BCb2b.CAgente(ConfigurationManager.AppSettings("grupo"), CInt(agente_sel))
    '        Session("agente_aux") = agente_aux
    '    End If
    '    buscar()
    'End Sub

    Protected Sub ddlAgente_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ddlAgente.SelectedIndexChanged
        If (Not Session("agente") Is Nothing) Then
            Dim agente_sel As String = ddlAgente.SelectedValue
            Dim agente_aux As New BCb2b.CAgente(ConfigurationManager.AppSettings("grupo"), CInt(agente_sel))
            Session("agente_aux") = agente_aux
        End If
        buscar()
    End Sub

    Protected Sub buscar()
        lblAvisos.Visible = False
        LblAvisos2.Visible = True

        Dim nombre, codigo As String
        nombre = tboxNombreB.Text
        codigo = tboxCodigoB.Text
        If (Not Session("agente") Is Nothing) Or Session("tipo_usuario") = "ING" Then
            Dim filtro As String = ConfigurationManager.AppSettings("filtro_cliente_agente")
            Dim tip_vc As String = ConfigurationManager.AppSettings("Venta")
            Dim agente_sel As String = ddlAgente.SelectedValue

            If Session("ver_clientes") = "" Then
                Session("ver_clientes") = ConfigurationManager.AppSettings("Filtro_cliente_agente")
            End If


            'If rblTipo.SelectedItem.Value = "Cliente" Then
            'Dim cliente As New BCb2b.ggclipr()
            'GridView1.DataSource = cliente.listado_Clientes(ConfigurationManager.AppSettings("grupo"), tboxNombreB.Text, tboxCodigoB.Text, tboxCodigoB.Text, Session("ver_clientes"), ConfigurationManager.AppSettings("venta"), agente_sel, Session("empresa").prop_cod, "S")
            'Else
            'Dim rsocial As New BCb2b.CRSOCIAL()
            'GridView1.DataSource = rsocial.listado_rsocial(tboxCodigoB.Text, tboxNombreB.Text)
            'End If

            Dim cliente As New BCb2b.ggclipr()
            GridView1.DataSource = cliente.listado_Clientes_Por_RSocial(ConfigurationManager.AppSettings("grupo"), tboxNombreB.Text, tboxCodigoB.Text, tboxCodigoB.Text, Session("ver_clientes"), ConfigurationManager.AppSettings("venta"), agente_sel, Session("empresa").prop_cod, "S")

            Try
                GridView1.DataBind()

                lblAvisos.Visible = False
                LblAvisos2.Visible = False
                alert.Visible = False
            Catch ex As Exception
                lblAvisos.Visible = True
                LblAvisos2.Visible = True
                alert.Visible = True
                lblResultados.Text = ex.Message.ToString
            End Try

            If (GridView1.DataSource.count() > 0) Then
                lblResultados.Text = ""
            Else
                LblAvisos2.Visible = False
                tboxNombreB.Text = ""
                tboxCodigoB.Text = ""

            End If

        Else
            'Response.Redirect("index.aspx")
            Response.Redirect("~/Expirado.aspx")
        End If
    End Sub


    Protected Sub IBExportarExcel_Click(ByVal sender As Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles IBExportarExcel.Click

        Dim CODIGO As String = tboxCodigoB.Text
        Dim RSOCIAL_CLIENTE As String = ""
        Dim NOMBRE_CLIENTE As String = tboxNombreB.Text

        Me.COD = CODIGO
        Me.RSOCIAL_COD = RSOCIAL_CLIENTE
        Me.nombre = NOMBRE_CLIENTE

        Dim agente_seleccionado As String = ddlAgente.SelectedValue

        Dim mi_agente_seleccionado As New BCb2b.CAgente(agente_seleccionado)

        Session("AGENTE") = mi_agente_seleccionado


        Me.EMPRESA = Session("empresa").Prop_cod
        Me.GRUPO = ConfigurationManager.AppSettings("grupo")
        Me.TIPVC = ConfigurationManager.AppSettings("venta")


        Server.Transfer("SelCliente_Excel.aspx")
    End Sub

    Protected Sub botonBuscar_Click(sender As Object, e As EventArgs) Handles botonBuscar.Click
        If (Not Session("agente") Is Nothing) Then
            Dim agente_sel As String = ddlAgente.SelectedValue
            Dim agente_aux As New BCb2b.CAgente(ConfigurationManager.AppSettings("grupo"), CInt(agente_sel))
            Session("agente_aux") = agente_aux
        End If
        buscar()
    End Sub
End Class
